openssh (1:10.5p1-1) unstable; urgency=medium

  * New upstream release (closes: #1144192):
    - CVE-2026-73281: ssh-agent(1): fix an interaction between agent locking
      and the session-bind@openssh.com extension that is used to identify
      forwarded agents. These binding requests were refused when the agent
      was locked, with the result that operations that were intended to be
      limited to local use only could be performed remotely, including the
      ability to add PKCS#11 tokens and make use of keys that had
      destination restrictions applied.
    - CVE-2026-73282: ssh(1): avoid potential realloc use-after-free in the
      client if a remote forwarding is added via the local session
      multiplexing socket while a remote forwarding open request is pending
      with the server.
    - CVE-2026-73283: sshd(8): make the authorized_keys "restrict" keyword
      apply correctly to tunnel forwarding too (which is administratively
      disabled by default).
    - ssh-keygen(1): add ability to set or clear the touch-required and
      verify-required flags on FIDO private keys when resetting a private
      key's passphrase.
    - ssh(1): tweak ordering of certificates tried during pubkey
      authentication to prefer FIDO keys that do not require user presence
      (touch) first, and FIDO keys that require user verification via PIN or
      biometrics last. This effectively tries low-friction authenticators
      before higher friction ones.
    - ssh(1): add a "ssh -Z user@host" mode that prints the keys that will
      be tried for public key authentication in the order that they will be
      used.
    - sshd(8) use setproctitle(3) to identify sshd-session when it's acting
      as a post-authentication monitor.
    - ssh-keyscan(1): make reading the server banner a non-blocking
      operation to prevent a stuck server from blocking a many-host keyscan
      from proceeding.
    - sshd(8): use sshpkt_fatal() instead of plain fatal() for errors in the
      packet code as this provides context of the failing peer (address,
      port, user, etc).
    - sshd(8): when signing hostkey proofs for a client UpdateHostKeys
      request, allow each hostkey to perform at most one signature
      operation.
    - ssh-keygen(1): pass back errors from ed25519 key generation, which
      theoretically can fail.
    - sshd(8): move check of public key type against allowed algorithms to
      before parsing of the key sent by the peer. This removes at least some
      key parsing and verification paths from the pre-auth attack surface.
    - ssh-keygen(1): fix double frees (impossible to reach outside of a test
      harness), and also use freezero where possible.
    - sshd(8): fix ChannelTimeout and RekeyLimit not being applied in
      sshd_config Match blocks.
    - sshd(8): in sshd config dump mode, write all directives in mixed case
      for consistency.
    - sshd(8): re-allow PAMServiceName inside a Match block, which was
      incorrectly disabled during a refactoring in openssh-10.4.

 -- Colin Watson <cjwatson@debian.org>  Mon, 31 Aug 2026 20:53:27 +0100

openssh (1:10.4p1-5) unstable; urgency=medium

  * Drop GSS-API authentication and key exchange support, to reduce
    pre-authentication attack surface.  Users who need these features should
    install openssh-client-gssapi or openssh-server-gssapi instead.

 -- Colin Watson <cjwatson@debian.org>  Sun, 23 Aug 2026 17:39:55 +0100

openssh (1:10.4p1-4) unstable; urgency=medium

  * Add missing test dependencies.

 -- Colin Watson <cjwatson@debian.org>  Fri, 31 Jul 2026 17:11:39 +0100

openssh (1:10.4p1-3) unstable; urgency=medium

  * Remove most openssh-* dependencies from openssh-tests.
  * Add Slovak debconf translation (thanks, Damian Daniel; closes:
    #1142938).
  * Remove references to rsh/rcp/rlogin/rshd from package descriptions.

 -- Colin Watson <cjwatson@debian.org>  Tue, 28 Jul 2026 16:29:14 +0100

openssh (1:10.4p1-2) unstable; urgency=medium

  [ Alexander Fisher ]
  * Build-Depends: add libcrypt-dev so crypt() is detected at build time,
    fixing password authentication with UsePAM=no (closes: #1142354).
  * debian/tests: add password-auth-no-pam regression test.

 -- Colin Watson <cjwatson@debian.org>  Sun, 19 Jul 2026 12:46:25 +0100

openssh (1:10.4p1-1) unstable; urgency=medium

  [ Sven Joachim ]
  * Make doc symlinks relative on upgrade from 1:10.3p1-5 (closes:
    #1141420).

  [ Colin Watson ]
  * New upstream release:
    - CVE-2026-59995: sftp(1): when downloading files on the command-line
      using "sftp host:/path .", a malicious server could cause the file to
      be downloaded to an unexpected location. This issue was identified by
      the Swival Security Scanner.
    - CVE-2026-59996: scp(1): when copying files between two remote
      destinations, do not allow a malicious server to write files to the
      parent directory of the intended target directory. This issue was
      identified by the Swival Security Scanner.
    - CVE-2026-59997: sshd(8): when using the "internal-sftp" SFTP server
      implementation (this is not the default), long command lines were
      previously truncated silently after the 9th argument. If a
      security-relevant option was in the 10th or later position, it would
      be discarded. Reported by Steve Caffrey.
    - CVE-2026-59998: sshd(8): add a documentation note to mention that the
      GSSAPIStrictAcceptorCheck option is ineffective when the server is
      joined to a Windows Active Directory. Reported by Yarin Aharoni of
      Safebreach.
    - CVE-2026-59999: sshd(8): DisableForwarding=yes didn't override
      PermitTunnel=yes as it was documented to do. Note that PermitTunnel is
      not enabled by default. Reported independently by Huzaifa Sidhpurwala
      of Redhat and Marko Jevtic.
    - CVE-2026-60000: sshd(8): avoid a potential pre-authentication denial
      of service when GSSAPIAuthentication was enabled (this feature is off
      by default). This was not mitigated by MaxAuthTries, but would be
      penalised by PerSourcePenalties. This was reported by Manfred Kaiser
      of the milCERT AT (Austrian Ministry of Defence).
    - CVE-2026-60001: sshd(8): fix a number of cases where the minimum
      authentication delay was not being enforced. Reported by the Orange
      Cyberdefense Vulnerability Team.
    - CVE-2026-60002: ssh(1): fix a possible client-side use-after-free if
      the server changes its host key during a key reexchange. This was
      reported by Zhenpeng (Leo) Lin of Depthfirst.
    - All: add experimental support for a composite post-quantum signature
      scheme that combines ML-DSA 44 and Ed25519 as specified in
      draft-miller-sshm-mldsa44-ed25519-composite-sigs. This scheme is not
      enabled by default. To use it, you'll need to add it to
      HostKeyAlgorithms, PubkeyAcceptedAlgorithms, etc. Keys may be
      generated using "ssh-keygen -t mldsa44-ed25519".
    - ssh(1), sshd(8): replace the wildcard pattern matcher with an
      implementation based on an NFA. This avoids exponential worst-case
      behaviour for the old implementation.
    - ssh-agent(1): fix incorrect reply to "query" SSH_AGENTC_EXTENSION
      requests.
    - sshd(8): avoid sending observably different messages for valid vs
      invalid users in GSSAPIAuthentication (disabled by default).
    - ssh(1), sshd(8): fix several bugs that incorrectly classified bulk
      traffic as interactive.
    - ssh-keygen(1), ssh-add(1): skip unsupported key types when downloading
      resident keys from a FIDO token. Previously, downloads would abort
      when one was encountered.
    - ssh(1): fix a potential use-after-free on an error path if
      cipher_init() fails.
    - sshd(8): perform stricter encoding and validation of transport state
      passed between sshd privilege separation subprocesses. This somewhat
      further hardens the server against attacks on sshd-auth or
      sshd-session subprocesses.
    - ssh-agent(1): avoid possible runtime denial of service by enforcing
      some limits on the length of usernames in key use constraints.
    - sftp(1): fix two separate one-byte out-of-bounds reads, in
      SSH2_FXP_REALPATH and batch command processing.
    - sftp-server(8): disallow use of the copy-data extension to read and
      write to the same inode simultaneously.
    - ssh(1), sshd(8): avoid strlen(NULL) crash if an X11 channel was
      created before the x11-req SSH_MSG_CHANNEL_REQUEST was sent.
    - sftp(1), scp(1): avoid a situation where sftp_download() could get
      stuck in a loop if a broken server repeatedly returned zero length
      while reading a file.
    - ssh(1): avoid leaking DNS0x20 case-randomised names into names
      canonicalised using CanonicalizePermittedCNAMEs.
    - sftp-server(8): avoid truncation of pathnames passed to lstat() during
      SSH_FXP_REALPATH handling on systems where PATH_MAX is not the actual
      max.
    - ssh(1), sshd(8): correct arming of poll(2) event masks for some
      socket-type channels.
    - sshd(8): major refactor of sshd_config parsing and management code, to
      allow for more exact serialisation/deserialisation across privilege
      separation boundaries.
    - ssh-add(1): open connection to the agent only after getopt()
      processing has completed, to give options like "-v" a chance to
      display debug information about this operation.
    - sshd(8): differentiate between execution failures and a subsystem that
      was not found when logging why a subsystem failed to start.
    - All: use safer idioms for timegm(3) and mktime(3) error detection.
    - ssh(1), sshd(8): avoid accepting invalid cipher or MAC lists in config
      files or command-line arguments. This could cause runtime failures
      later.
    - ssh(1): fix NULL deref crash during pubkey auth when using a PEM style
      private key with no corresponding .pub key adjacent to it (closes:
      #1134814).
    - sshd(8): don't print an error message when trying to load a host
      private key when PKCS#11 keys are in use, as these don't need the
      private half on the filesystem.
    - All: don't use deprecated ERR_load_crypto_strings().
    - ssh(1): properly report errors during configuration default setting.
    - ssh(1): use correct directive name (Match instead of Host) in error
      message.
    - sftp(1): fix "ls -ln" which was not correctly showing numeric UID/GIDs
      but rather user and group names.
    - sshd(8): avoid possible NULL dereference if an allocation fails during
      config parsing.
    - All: fix ineffective guards against loading overly large public keys
      in several places.
    - sftp(1): ensure file descriptors used by sftp to communicate to its
      ssh(1) subprocess don't leak into executed subprocesses (e.g. via
      "!").
    - Sync fmt_scaled.c with OpenBSD upstream, picking up an exactness fix
      for large exponents.
    - sshd(8): remove duplicate sandbox entry for clock_gettime64.
    - Sync getrrsetbyname.c with OpenBSD upstream, picking up robustness
      fixes.
    - Fix a number of memory leaks on error paths in the portability code.
    - Revise the README.privsep documentation to reflect sshd's recent
      switch to a multi-binary model.

 -- Colin Watson <cjwatson@debian.org>  Mon, 06 Jul 2026 19:11:28 +0100

openssh (1:10.3p1-9) unstable; urgency=medium

  * openssh-client Conflicts: openssh-server (<< 1:10.3p1-6~) (closes:
    #1141550).

 -- Colin Watson <cjwatson@debian.org>  Mon, 06 Jul 2026 09:51:32 +0100

openssh (1:10.3p1-8) unstable; urgency=medium

  * d/copyright: Add some missing authors.
  * Standards-Version: 4.7.4.
  * openssh-tests: Make a couple more scripts executable.

 -- Colin Watson <cjwatson@debian.org>  Fri, 03 Jul 2026 16:54:01 +0100

openssh (1:10.3p1-7) unstable; urgency=medium

  * Reupload with binaries, since openssh-common is new.

 -- Colin Watson <cjwatson@debian.org>  Fri, 03 Jul 2026 00:32:52 +0100

openssh (1:10.3p1-6) unstable; urgency=medium

  * Move documentation to a new openssh-common package (closes: #1070098).
  * Remove dependency on openssh-client{,-gssapi} from
    openssh-server{,-gssapi} (closes: #699473).
  * Use --link-doc on all packages.
  * Move ssh-keygen and openssh-{pkcs11,sk}-helper to openssh-common.

 -- Colin Watson <cjwatson@debian.org>  Thu, 02 Jul 2026 20:24:29 +0100

openssh (1:10.3p1-5) unstable; urgency=medium

  [ Johannes Schauer Marin Rodrigues ]
  * Support DPKG_ROOT.

  [ Colin Watson ]
  * d/copyright: Significantly rework to be lrc-clean.

  [ Roland C. Dowdeswell ]
  * Fix GSS C25519 server blob bounds check.

 -- Colin Watson <cjwatson@debian.org>  Fri, 26 Jun 2026 16:16:18 +0100

openssh (1:10.3p1-4) unstable; urgency=medium

  * OpenSSL 4 removed support for engines, so only configure with
    --with-ssl-engine when building for older versions (closes: #1138423).

 -- Colin Watson <cjwatson@debian.org>  Mon, 01 Jun 2026 11:37:05 +0100

openssh (1:10.3p1-3) unstable; urgency=medium

  * Enable regression tests of keyboard-interactive and password
    authentication.
  * Add test dependency on procps for pidof (closes: #1136545).

 -- Colin Watson <cjwatson@debian.org>  Fri, 29 May 2026 10:00:29 +0100

openssh (1:10.3p1-2) unstable; urgency=medium

  * Correctly set extended type for client-side channels.  Fixes interactive
    vs bulk IPQoS for client->server traffic.
  * Build-depend on libselinux-dev rather than libselinux1-dev.

 -- Colin Watson <cjwatson@debian.org>  Sun, 03 May 2026 17:28:29 +0100

openssh (1:10.3p1-1) unstable; urgency=medium

  * New upstream release:
    - CVE-2026-35386: ssh(1): validation of shell metacharacters in user
      names supplied on the command-line was performed too late to prevent
      some situations where they could be expanded from %-tokens in
      ssh_config. For certain configurations, such as those that use a "%u"
      token in a "Match exec" block, an attacker who can control the user
      name passed to ssh(1) could potentially execute arbitrary shell
      commands. Reported by Florian Kohnhäuser (closes: #1132573).
      We continue to recommend against directly exposing ssh(1) and other
      tools' command-lines to untrusted input. Mitigations such as this can
      not be absolute given the variety of shells and user configurations in
      use.
    - CVE-2026-35414: sshd(8): when matching an authorized_keys
      principals="" option against a list of principals in a certificate, an
      incorrect algorithm was used that could allow inappropriate matching
      in cases where a principal name in the certificate contains a comma
      character. Exploitation of the condition requires an authorized_keys
      principals="" option that lists more than one principal *and* a CA
      that will issue a certificate that encodes more than one of these
      principal names separated by a comma (typical CAs strongly constrain
      which principal names they will place in a certificate). This
      condition only applies to user- trusted CA keys in authorized_keys,
      the main certificate authentication path
      (TrustedUserCAKeys/AuthorizedPrincipalsFile) is not affected. Reported
      by Vladimir Tokarev (closes: #1132576).
    - CVE-2026-35385: scp(1): when downloading files as root in legacy (-O)
      mode and without the -p (preserve modes) flag set, scp did not clear
      setuid/setgid bits from downloaded files as one might typically
      expect. This bug dates back to the original Berkeley rcp program.
      Reported by Christos Papakonstantinou of Cantina and Spearbit (closes:
      #1132572).
    - CVE-2026-35387: sshd(8): fix incomplete application of
      PubkeyAcceptedAlgorithms and HostbasedAcceptedAlgorithms with regard
      to ECDSA keys. Previously if one of these directives contains any
      ECDSA algorithm name (say "ecdsa-sha2-nistp384"), then any other ECDSA
      algorithm would be accepted in its place regardless of whether it was
      listed or not.  Reported by Christos Papakonstantinou of Cantina and
      Spearbit (closes: #1132574).
    - CVE-2026-35388: ssh(1): connection multiplexing confirmation
      (requested using "ControlMaster ask/autoask") was not being tested for
      proxy mode multiplexing sessions (i.e. "ssh -O proxy ..."). Reported
      by Michalis Vasileiadis (closes: #1132575).
    - ssh(1), sshd(8): support IANA-assigned codepoints for SSH agent
      forwarding, as per draft-ietf-sshm-ssh-agent. Support for the new
      names is advertised via the EXT_INFO message. If a server offers
      support for the new names, then they are used preferentially. Support
      for the pre-standardisation "@openssh.com" extensions for agent
      forwarding remains supported.
    - ssh-agent(1): implement support for draft-ietf-sshm-ssh-agent "query"
      extension.
    - ssh-add(1): support querying the protocol extensions via the agent
      "query" extension with a new -Q flag.
    - ssh(1): support multiple files in a ssh_config RevokedHostKeys
      directive.
    - sshd(8): support multiple files in a sshd_config RevokedKeys
      directive.
    - ssh(1): add a ~I escape option that shows information about the
      current SSH connection (closes: #321525).
    - ssh(1): add an "ssh -Oconninfo user@host" multiplexing command that
      shows connection information, similar to the ~I escapechar.
    - ssh(1): add an "ssh -O channels user@host" multiplexing command to get
      a running mux process to show information about what channels are
      currently open.
    - sshd(8): add 'invaliduser' penalty to PerSourcePenalties, which is
      applied to login attempts for usernames that do not match real
      accounts. Defaults to 5s to match 'authfail' but allows administrators
      to block such attempts for longer if desired.
    - sshd(8): add a GSSAPIDelegateCredentials option for the server,
      controlling whether it accepts delegated credentials offered by the
      client.  This option mirrors the same option in ssh_config.
    - ssh(1), sshd(8): support the VA DSCP codepoint in the IPQoS directive.
    - sshd(8): convert PerSourcePenalties to using floating point time,
      allowing penalties to be less than a second. This is useful if you
      need to penalise things you expect to occur at >=1 QPS.
    - ssh-keygen(1): support writing ED25519 keys in PKCS8 format.
    - Support the ed25519 signature scheme via libcrypto.
    - sshd(8): make IPQoS first-match-wins in sshd_config, like other
      configuration directives.
    - sshd(8): fix potential crash when MaxStartups is using a single
      argument (i.e. not using the MaxStartups x:y:z form) to a value below
      10.
    - sshd(8): fix a potential hang during key exchange if needed DH group
      values were missing from /etc/moduli.
    - ssh-agent(1): fix return values from extensions to be correct wrt
      draft-ietf-sshm-ssh-agent: extension requests should indicate failure
      using SSH_AGENT_EXTENSION_FAILURE rather than the generic
      SSH_AGENT_FAILURE error code. This allows the client to discern
      between "the request failed" and "the agent doesn't support this
      extension".
    - ssh(1): use fmprintf for showing challenge-response name and info to
      preserve UTF-8 characters where appropriate.
    - scp(1): when uploading a directory using sftp/sftp (e.g. during a
      recursive transfer), don't clobber the remote directory permissions
      unless either we created the directory during the transfer or the -p
      flag was set.
    - All: implement missing pieces of FIDO/webauthn signature support,
      mostly related to certificate handling and enable acceptance of this
      signature format by default.
    - sshd_config(5): make it clear that DenyUsers/DenyGroups overrides
      AllowUsers/AllowGroups. Previously we specified the order in which the
      directives are processed but it was ambiguous as to what happened if
      both matched.
    - ssh(1): don't try to match certificates held in an agent to private
      keys. This matching is done to support certificates that were loaded
      without their private key material, but is unnecessary for
      agent-hosted certificate which always have private key material
      available in the agent. Worse, this matching would mess up the request
      sent to the agent in such a way as to break usage of these keys when
      the key usage was restricted in the agent.
    - sftp(1): if editline has been switched to vi mode (i.e. via "bind -v"
      in .editrc), setup a keybinding so that command mode can be entered.
    - ssh(1), sshd(8): improve performance of keying the sntrup761 key
      agreement algorithm.
    - ssh(1), sshd(8): enforce maximum packet/block limit during
      pre-authentication phase.
    - sftp(1): don't misuse the sftp limits extension's open-handles field.
      This value is supposed to be the number of handles a server will allow
      to be opened and not a number of outstanding read/write requests that
      can be sent during an upload/download.
    - sshd(8): don't crash at connection time if the main sshd_config lacks
      any subsystem directive but one is defined in a Match block.
    - sshd_config(5): add a warning next to the ForceCommand directive that
      forcing a command doesn't automatically disable forwarding.
    - sshd_config(5): add a warning that TOKENS are replaced without
      filtering or escaping and that it's the administrator's responsibility
      to ensure they are used safely in context.
    - sshd(8): don't mess up the PerSourceNetBlockSize IPv6 mask if sscanf
      didn't decode it.
    - ssh-add(1): when loading FIDO2 resident keys, set the comment to the
      FIDO application string. This matches the behaviour of ssh-keygen -K.
    - sshd(8): don't strnvis() log messages that are going to be logged by
      sshd-auth via its parent sshd-session process, as the parent will also
      run them though strnvis(). Prevents double-escaping of non-printing
      characters in some log messages.
    - ssh-agent(1): escape SSH_AUTH_SOCK paths that are sent to the shell as
      setenv commands. Unbreaks ssh-agent for home directory paths that
      contain whitespace (closes: #1118288).
    - All: Remove unnecessary checks for ECDSA public key validity.
    - sshd(8): activate UnusedConnectionTimeout only after the last channel
      has closed. Previously UnusedConnectionTimeout could fire early after
      a ChannelTimeout. This was not a problem for the OpenSSH client
      because it terminates once all channels have closed but could cause
      problems for other clients (e.g. API clients) that do things
      differently.
    - scp(1): when using the SFTP protocol for transfers, fix implicit
      destination path selection when source path ends with "..".
    - sftp(1): when tab-completing a filename, ensure that the completed
      string does not end up mid-way through a multibyte character, as this
      will cause a fatal() later on.
    - ssh-keygen(1): fix crash at exit (visible via ssh-keygen -D) when
      multiple keys loaded.
    - scp(1)/sftp(1): correctly display bandwidths >2GBps in the progress
      meter.
    - sshd(8): fix condition introduced in openssh 10.2p1 stable branch
      where a PAM module that changed the requested username between
      SSH_MSG_USERAUTH_REQUEST messages during authentication could confuse
      the PAM stack and let it proceed with a different understanding of the
      active username than the rest of sshd. Reported by Mike Damm.
    - sshd(8): immediately report interactive instructions to clients when
      using keyboard-interactive authentication with PAM.
    - sshd(8): fix duplicate PAM messages under some situations.
    - sshd(8): don't leak PAM handle on repeat invocations.
    - sshd(8): fix ut_type for btmp records, correctly using LOGIN_PROCESS
      and USER_PROCESS.
    - sshd(8): allow uname(3) in the seccomp sandbox. This is needed by
      zlib-ng on RISC-V platforms.
    - All: remove remaining OpenSSL_add_all_algorithms() calls. We already
      have OPENSSL_init_crypto() in the compat layer.

 -- Colin Watson <cjwatson@debian.org>  Sun, 12 Apr 2026 12:49:45 +0100

openssh (1:10.2p1-6) unstable; urgency=medium

  * CVE-2026-3497: Fix incorrect GSS-API error handling; Replace incorrect
    use of sshpkt_disconnect() with ssh_packet_disconnect(), and properly
    initialize some variables (closes: #1130595; thanks, Marc Deslauriers).
  * Do not default to weak GSS-API exchange algorithms (closes: #989906,
    #1131206; LP: #2144812; thanks, Athos Ribeiro).

 -- Colin Watson <cjwatson@debian.org>  Fri, 27 Mar 2026 18:26:06 +0000

openssh (1:10.2p1-5) unstable; urgency=medium

  [ Samuel Thibault ]
  * Do not link against libcrypt on GNU/Hurd (closes: #1128399).

  [ Colin Watson ]
  * Install systemd files directly to /usr and drop dh-sequence-movetousr
    (closes: #1122765).

 -- Colin Watson <cjwatson@debian.org>  Thu, 19 Feb 2026 10:46:15 +0000

openssh (1:10.2p1-4) unstable; urgency=medium

  [ Colin Watson ]
  * Debconf translations:
    - Simplified and Traditional Chinese (thanks, Yangfl; closes: #1124970).

  [ Luca Boccassi ]
  * openssh-client: use sysusers.d instead of manual scripting.
  * openssh-client: drop compat postinst not needed since bookworm/noble.
  * openssh-client: drop versioned dependency on i-s-h, satisfied since
    trixie/noble.
  * openssh-client: drop dependency on passwd, add recommends on
    openssh-server.
  * Use dh-sequence-installsysusers and drop d/rules override.

  [ Christian Göttsche ]
  * Reorder pam_selinux(7) usage (closes: #747303).

 -- Colin Watson <cjwatson@debian.org>  Wed, 18 Feb 2026 14:09:13 +0000

openssh (1:10.2p1-3) unstable; urgency=medium

  * Drop "Rules-Requires-Root: no", default as of dpkg-dev 1.22.13.
  * Drop openssh-server's dependency on lsb-base.
  * Remove support for direct upgrades from before Debian 12 (bookworm).
  * Rewrite scp-quoting.patch using argv_assemble, and forward it upstream.

 -- Colin Watson <cjwatson@debian.org>  Tue, 02 Dec 2025 14:36:37 +0000

openssh (1:10.2p1-2) unstable; urgency=medium

  * ssh-session-cleanup: Update pattern for sshd-session split in 9.8
    (closes: #1117965).
  * Link ssh against ssh-pkcs11.o directly (closes: #1117638, #1117720).

 -- Colin Watson <cjwatson@debian.org>  Fri, 17 Oct 2025 10:14:14 +0100

openssh (1:10.2p1-1) unstable; urgency=medium

  * New upstream release:
    - ssh-keygen(1): fix download of keys from PKCS#11 tokens.

 -- Colin Watson <cjwatson@debian.org>  Fri, 10 Oct 2025 14:50:27 +0100

openssh (1:10.1p1-2) unstable; urgency=medium

  * Don't reuse c->isatty for signalling that the remote channel has a tty
    attached (closes: #1117574, #1117594).
  * Link ssh-keygen directly against ssh-pkcs11.c.

 -- Colin Watson <cjwatson@debian.org>  Thu, 09 Oct 2025 00:54:25 +0100

openssh (1:10.1p1-1) unstable; urgency=medium

  [ Allison Karlitskaya ]
  * sshd@.service: Support ephemeral keys from VM/container hosts.

  [ Colin Watson ]
  * New upstream release:
    - ssh(1): add a warning when the connection negotiates a non-post
      quantum key agreement algorithm.
    - ssh(1), sshd(8): major changes to handling of DSCP marking/IPQoS: by
      default, interactive traffic is assigned to the EF (Expedited
      Forwarding) class, while non-interactive traffic uses the operating
      system default DSCP marking.
    - ssh(1), sshd(8): deprecate support for IPv4 type-of-service (ToS)
      keywords in the IPQoS configuration directive.
    - ssh-add(1): when adding certificates to an agent, set the expiry to
      the certificate expiry time plus a short (5 min) grace period.
    - All: remove experimental support for XMSS keys.
    - ssh-agent(1), sshd(8): move agent listener sockets from /tmp to under
      ~/.ssh/agent for both ssh-agent(1) and forwarded sockets in sshd(8).
    - CVE-2025-61984: ssh(1): disallow control characters in usernames
      passed via the commandline or expanded using %-sequences from the
      configuration file (closes: #1117529).
    - CVE-2025-61985: ssh(1): disallow \0 characters in ssh:// URIs (closes:
      #1117530).
    - ssh(1), sshd(8): add SIGINFO handlers to log active channel and
      session information.
    - sshd(8): when refusing a certificate for user authentication, log
      enough information to identify the certificate in addition to the
      reason why it was being denied. Makes debugging certificate
      authorisation problems a bit easier.
    - ssh(1), ssh-agent(1): support ed25519 keys hosted on PKCS#11 tokens.
    - ssh(1): add an ssh_config(5) RefuseConnection option that, when
      encountered while processing an active section in a configuration,
      terminates ssh(1) with an error message that contains the argument to
      the option.
    - sshd(8): make the X11 display number check relative to
      X11DisplayOffset. This will allow people to use X11DisplayOffset to
      configure much higher port ranges if they really want, while not
      changing the default behaviour.
    - ssh(1): fix delay on X client startup when ObscureKeystrokeTiming is
      enabled.
    - sshd(8): increase the maximum size of the supported configuration from
      256KB to 4MB, which ought to be enough for anybody. Fail early and
      visibly when this limit is breached.
    - sftp(1): during sftp uploads, avoid a condition where a failed write
      could be ignored if a subsequent write succeeded. This is unlikely but
      technically possible because sftp servers are allowed to reorder
      requests.
    - sshd(8): avoid a race condition when the sshd-auth process exits that
      could cause a spurious error message to be logged.
    - sshd(8): log at level INFO when PerSourcePenalties actually blocks
      access to a source address range. Previously this was logged at level
      VERBOSE, which hid enforcement actions under default config settings.
    - sshd(8): Make the MaxStartups and PerSourceNetBlockSize options
      first-match-wins as advertised.
    - ssh(1): fix an incorrect return value check in the local forward
      cancellation path that would cause failed cancellations not to be
      logged.
    - sshd(8): make "Match !final" not trigger a second parsing pass of
      ssh_config (unless hostname canonicalisation or a separate "Match
      final" does).
    - ssh(1): better debug diagnostics when loading keys. Will now list key
      fingerprint and algorithm (not just algorithm number) as well as
      making it explicit which keys didn't load.
    - All: fix a number of memory leaks found by LeakSanitizer, Coverity and
      manual inspection.
    - sshd(8): Output the current name for PermitRootLogin's
      "prohibit-password" in sshd -T instead of its deprecated alias
      "without-password" (closes: #1095922).
    - ssh(1): make writing known_hosts lines more atomic by writing the
      entire line in one operation and using unbuffered stdio.
    - sshd(8): check the username didn't change during the PAM transactions.
    - sshd(8): don't log audit messages with UNKNOWN hostname to avoid slow
      DNS lookups in the audit subsystem.
    - All: when making a copy of struct passwd, ensure struct fields are
      non-NULL.
    - sshd(8): handle futex_time64 properly in seccomp sandbox.
    - Add contrib/gnome-ssh-askpass4 for GNOME 40+ using the GCR API.
    - ssh-agent(1): exit 0 from SIGTERM under systemd socket-activation,
      preventing a graceful shutdown of an agent via systemd from
      incorrectly marking the service as "failed".
  * Drop patches:
    - no-openssl-version-status.patch: Mostly applied upstream; the rest
      only applied to OpenSSL < 3, which isn't relevant to current Debian
      releases.
    - revert-ipqos-defaults.patch: This new upstream release reworks IPQoS,
      so let's see how that works in Debian (closes: #1111446).
  * debian/run-tests: Fix path to dropbear.

 -- Colin Watson <cjwatson@debian.org>  Tue, 07 Oct 2025 22:07:19 +0100

openssh (1:10.0p1-8) unstable; urgency=medium

  * Remove some long-obsolete Conflicts (closes: #54243).
  * Fix mistracking of MaxStartups process exits in some situations (closes:
    #1080350).

 -- Colin Watson <cjwatson@debian.org>  Sun, 10 Aug 2025 00:07:55 +0100

openssh (1:10.0p1-7) unstable; urgency=medium

  * Make postinst logic for cleaning up the sshd diversion more robust.

 -- Colin Watson <cjwatson@debian.org>  Fri, 01 Aug 2025 16:02:27 +0100

openssh (1:10.0p1-6) unstable; urgency=medium

  * Temporarily divert /usr/sbin/sshd during upgrades from before
    1:9.8p1-1~, to avoid new connections failing between unpack and
    configure (closes: #1109742).

 -- Colin Watson <cjwatson@debian.org>  Mon, 28 Jul 2025 12:17:42 +0100

openssh (1:10.0p1-5) unstable; urgency=medium

  * Ensure that configure knows the path to passwd; fixes reproducibility of
    openssh-tests.

 -- Colin Watson <cjwatson@debian.org>  Fri, 09 May 2025 13:40:49 +0100

openssh (1:10.0p1-4) unstable; urgency=medium

  [ Daniel Kahn Gillmor ]
  * Add Requires=ssh-agent.socket to ssh-agent.service (closes: #1103522).

 -- Colin Watson <cjwatson@debian.org>  Fri, 09 May 2025 10:16:45 +0100

openssh (1:10.0p1-3) unstable; urgency=medium

  * Disable --with-linux-memlock-onfault again, since it causes
    RLIMIT_MEMLOCK to be exceeded with some combinations of PAM modules
    (closes: #1103418).

 -- Colin Watson <cjwatson@debian.org>  Wed, 07 May 2025 16:18:43 +0100

openssh (1:10.0p1-2) unstable; urgency=medium

  [ Colin Watson ]
  * Disable --with-linux-memlock-onfault on riscv64.
  * Build with wtmpdb (see #1102643).
  * Stop writing /var/log/btmp, since nothing reads it any more (closes:
    #1072184).
  * Restore some rdomain references in sshd_config(5) where they're
    supported on Linux, referring to ip-vrf(8) (closes: #1095686).

  [ Daniel Kahn Gillmor ]
  * Improve systemd user service socket activation (closes: #961311,
    #1039919, #1103037).

  [ Luca Boccassi ]
  * Switch from adduser to sysusers.d.
  * Add sshd-keygen service.

 -- Colin Watson <cjwatson@debian.org>  Tue, 15 Apr 2025 14:19:35 +0100

openssh (1:10.0p1-1) unstable; urgency=medium

  [ Luca Boccassi ]
  * Add COLORTERM NO_COLOR to SendEnv and AcceptEnv.

  [ Colin Watson ]
  * New upstream release:
    - This release removes support for the weak DSA signature algorithm.
    - scp(1), sftp(1): pass "ControlMaster no" to ssh when invoked by scp &
      sftp.
    - This release has the version number 10.0 and announces itself as
      "SSH-2.0-OpenSSH_10.0". Software that naively matches versions using
      patterns like "OpenSSH_1*" may be confused by this.
    - sshd(8): this release removes the code responsible for the user
      authentication phase of the protocol from the per-connection
      sshd-session binary to a new sshd-auth binary. Splitting this code
      into a separate binary ensures that the crucial pre-authentication
      attack surface has an entirely disjoint address space from the code
      used for the rest of the connection. It also yields a small runtime
      memory saving as the authentication code will be unloaded after the
      authentication phase completes. This change should be largely
      invisible to users, though some log messages may now come from
      "sshd-auth" instead of "sshd-session".
    - sshd(8): this release disables finite field (a.k.a modp)
      Diffie-Hellman key exchange in sshd by default. Specifically, this
      removes the "diffie-hellman-group*" and
      "diffie-hellman-group-exchange-*" methods from the default
      KEXAlgorithms list. The client is unchanged and continues to support
      these methods by default.
    - sshd(8): this release removes the implicit fallback to compiled-in
      groups for Diffie-Hellman Group Exchange KEX when the moduli file
      exists but does not contain moduli within the client-requested range.
      The fallback behaviour remains for the case where the moduli file does
      not exist at all. This allows administrators more explicit control
      over which DH groups will be selected, but can lead to connection
      failures if the moduli file is edited incorrectly.
    - CVE-2025-32728: sshd(8): fix the DisableForwarding directive, which
      was failing to disable X11 forwarding and agent forwarding as
      documented (closes: #1102603). X11 forwarding is disabled by default
      in the server and agent forwarding is off by default in the client.
    - ssh(1): the hybrid post-quantum algorithm mlkem768x25519-sha256 is now
      used by default for key agreement. This algorithm is considered to be
      safe against attack by quantum computers, is guaranteed to be no less
      strong than the popular curve25519-sha256 algorithm, has been
      standardised by NIST and is considerably faster than the previous
      default.
    - ssh(1): prefer AES-GCM to AES-CTR mode when selecting a cipher for the
      connection. The default cipher preference list is now
      Chacha20/Poly1305, AES-GCM (128/256) followed by AES-CTR
      (128/192/256).
    - ssh(1): add %-token and environment variable expansion to the
      ssh_config SetEnv directive.
    - ssh(1): allow %-token and environment variable expansion in the
      ssh_config User directive, with the exception of %r and %C which would
      be self-referential.
    - ssh(1), sshd(8): add "Match version" support to ssh_config and
      sshd_config. Allows matching on the local version of OpenSSH, e.g.
      "Match version OpenSSH_10.*".
    - ssh(1): add support for "Match sessiontype" to ssh_config. Allows
      matching on the type of session initially requested, either "shell"
      for interactive sessions, "exec" for command execution sessions,
      "subsystem" for subsystem requests, such as sftp, or "none" for
      transport/forwarding-only sessions.
    - ssh(1): add support for "Match command ..." support to ssh_config,
      allowing matching on the remote command as specified on the
      command-line.
    - ssh(1): allow 'Match tagged ""' and 'Match command ""' to match empty
      tag and command values respectively.
    - sshd(8): allow glob(3) patterns to be used in sshd_config
      AuthorizedKeysFile and AuthorizedPrincipalsFile directives.
    - sshd(1): support the VersionAddendum in the client, mirroring the
      option of the same name in the server.
    - ssh-agent(1): the agent will now delete all loaded keys when signaled
      with SIGUSR1. This allows deletion of keys without having access to
      $SSH_AUTH_SOCK.
    - Portable OpenSSH, ssh-agent(1): support systemd-style socket
      activation in ssh-agent using the LISTEN_PID/LISTEN_FDS mechanism.
      Activated when these environment variables are set, the agent is
      started with the -d or -D option and no socket path is set.
    - ssh-keygen(1): support FIDO tokens that return no attestation data,
      e.g. recent WinHello.
    - ssh-agent(1): add a "-Owebsafe-allow=..." option to allow the default
      FIDO application ID allow-list to be overridden.
    - ssh-keygen(1): allow "-" as output file for moduli screening.
    - sshd(8): remove assumption that the sshd_config and any configs it
      includes can fit in a (possibly enlarged) socket buffer. Previously it
      was possible to create a sufficiently large configuration that could
      cause sshd to fail to accept any connection. sshd(8) will now actively
      manage sending its config to the sshd-session sub-process.
    - ssh(1): don't start the ObscureKeystrokeTiming mitigations if there
      has been traffic on a X11 forwarding channel recently. Should fix X11
      forwarding performance problems when this setting is enabled.
    - ssh(1): prohibit the comma character in hostnames accepted, but allow
      an underscore as the first character in a hostname.
    - sftp(1): set high-water when resuming a "put". Prevents bogus "server
      reordered acks" debug message.
    - ssh(1), sshd(8): fix regression in openssh-9.8, which would fail to
      accept "Match criteria=argument" as well as the documented "Match
      criteria argument" syntax in ssh_config and sshd_config.
    - sftp(1), ssh(1): fix a number of possible NULL dereference bugs,
      including Coverity CIDs 405019 and 477813.
    - sshd(8): fix PerSourcePenalty incorrectly using "crash" penalty when
      LoginGraceTime was exceeded.
    - sshd(8): fix "Match invalid-user" from incorrectly being activated in
      initial configuration pass when no other predicates were present on
      the match line.
    - sshd(8): fix debug logging of user specific delay.
    - sshd(8): improve debug logging across sub-process boundaries.
      Previously some log messages were lost early in the sshd-auth and
      sshd-session processes' life.
    - ssh(1): require control-escape character sequences passed via the '-e
      ^x' command-line to be exactly two characters long. Avoids one byte
      out-of-bounds read if ssh is invoked as "ssh -e^ ...".
    - ssh(1), sshd(8): prevent integer overflow in x11 port handling. These
      are theoretically possible if the admin misconfigured X11DisplayOffset
      or the user misconfigures their own $DISPLAY, but don't happen in
      normal operation.
    - ssh-keygen(1): don't mess up ssh-keygen -l output when the file
      contains CR characters.
    - sshd(8): add rate limits to logging of connections dropped by
      PerSourcePenalties. Previously these could be noisy in logs.
    - ssh(1): fix argument of "Compression" directive in ssh -G config dump,
      which regressed in openssh-9.8.
    - sshd(8): fix a corner-case triggered by UpdateHostKeys when sshd
      refuses to accept the signature returned by an agent holding host keys
      during the hostkey rotation sub-protocol. This situation could occur
      in situations where a PKCS#11 smartcard that lacked support for
      particular signature algorithms was used to store host keys.
    - ssh-keygen(1): when using RSA keys to sign messages with "ssh-keygen
      -Y", select the signature algorithm based on the requested hash
      algorithm ("-Ohashalg=xxx"). This allows using something other than
      the default of rsa-sha2-512, which may not be supported on all signing
      backends, e.g. some smartcards only support SHA256.
    - sshd(8): add wtmpdb support as a Y2038 safe wtmp replacement.
    - sshd(8): add support for locking sshd into memory, enabled with the
      --with-linux-memlock-onfault configure flag.
  * Configure --with-linux-memlock-onfault on Linux.

 -- Colin Watson <cjwatson@debian.org>  Fri, 11 Apr 2025 16:00:55 +0100

openssh (1:9.9p2-2) unstable; urgency=medium

  * Simplify most autopkgtests using needs-sudo restriction.
  * Remove obsolete slogin symlink (closes: #1098760).
  * Check if dbclient supports SHA1 before trying SHA1-based KEX (closes:
    #1100948).

 -- Colin Watson <cjwatson@debian.org>  Thu, 20 Mar 2025 23:12:58 +0000

openssh (1:9.9p2-1) unstable; urgency=medium

  * New upstream release:
    - CVE-2025-26465: ssh(1) in OpenSSH versions 6.8p1 to 9.9p1 (inclusive)
      contained a logic error that allowed an on-path attacker (a.k.a MITM)
      to impersonate any server when the VerifyHostKeyDNS option is enabled.
      This option is off by default.
    - CVE-2025-26466: sshd(8) in OpenSSH versions 9.5p1 to 9.9p1 (inclusive)
      is vulnerable to a memory/CPU denial-of-service related to the
      handling of SSH2_MSG_PING packets. This condition may be mitigated
      using the existing PerSourcePenalties feature.
    - ssh(1), sshd(8): fix regression in Match directive that caused
      failures when predicates and their arguments were separated by '='
      characters instead of whitespace (bz3739).
    - sshd(8): fix the "Match invalid-user" predicate, which was matching
      incorrectly in the initial pass of config evaluation.

 -- Colin Watson <cjwatson@debian.org>  Tue, 18 Feb 2025 10:13:10 +0000

openssh (1:9.9p1-3) unstable; urgency=medium

  * Fix mlkem768x25519-sha256 key exchange algorithm on big-endian
    architectures.
  * Drop patch to define MAXHOSTNAMELEN on GNU/Hurd (no longer needed).

 -- Colin Watson <cjwatson@debian.org>  Sun, 27 Oct 2024 13:58:04 +0000

openssh (1:9.9p1-2) unstable; urgency=medium

  * Don't prefer host-bound public key signatures if there was no initial
    host key, as is the case when using GSS-API key exchange (closes:
    #1041521).
  * Use runuser rather than sudo in autopkgtests where possible, avoiding a
    dependency.

 -- Colin Watson <cjwatson@debian.org>  Mon, 21 Oct 2024 18:24:07 +0100

openssh (1:9.9p1-1) unstable; urgency=medium

  * Alias the old Debian-specific SetupTimeOut client option to
    ConnectTimeout rather than to ServerAliveInterval.
  * New upstream release (https://www.openssh.com/releasenotes.html#9.9p1):
    - ssh(1): remove support for pre-authentication compression.
    - ssh(1), sshd(8): processing of the arguments to the "Match"
      configuration directive now follows more shell-like rules for quoted
      strings, including allowing nested quotes and \-escaped characters.
    - ssh(1), sshd(8): add support for a new hybrid post-quantum key
      exchange based on the FIPS 203 Module-Lattice Key Enapsulation
      mechanism (ML-KEM) combined with X25519 ECDH as described by
      https://datatracker.ietf.org/doc/html/draft-kampanakis-curdle-ssh-pq-ke-03
      This algorithm "mlkem768x25519-sha256" is available by default.
    - ssh(1): the ssh_config "Include" directive can now expand environment
      as well as the same set of %-tokens "Match Exec" supports.
    - sshd(8): add a sshd_config "RefuseConnection" option that, if set will
      terminate the connection at the first authentication request.
    - sshd(8): add a "refuseconnection" penalty class to sshd_config
      PerSourcePenalties that is applied when a connection is dropped by the
      new RefuseConnection keyword.
    - sshd(8): add a "Match invalid-user" predicate to sshd_config Match
      options that matches when the target username is not valid on the
      server.
    - ssh(1), sshd(8): update the Streamlined NTRUPrime code to a
      substantially faster implementation.
    - ssh(1), sshd(8): the hybrid Streamlined NTRUPrime/X25519 key exchange
      algorithm now has an IANA-assigned name in addition to the
      "@openssh.com" vendor extension name. This algorithm is now also
      available under this name "sntrup761x25519-sha512"
    - ssh(1), sshd(8), ssh-agent(1): prevent private keys from being
      included in core dump files for most of their lifespans. This is in
      addition to pre-existing controls in ssh-agent(1) and sshd(8) that
      prevented coredumps.
    - All: convert key handling to use the libcrypto EVP_PKEY API, with the
      exception of DSA.
    - sshd(8): add a random amount of jitter (up to 4 seconds) to the grace
      login time to make its expiry unpredictable.
    - sshd(8): fix regression introduced in openssh-9.8 that swapped the
      order of source and destination addresses in some sshd log messages.
    - sshd(8): do not apply authorized_keys options when signature
      verification fails. Prevents more restrictive key options being
      incorrectly applied to subsequent keys in authorized_keys.
    - ssh-keygen(1): include pathname in some of ssh-keygen's passphrase
      prompts. Helps the user know what's going on when ssh-keygen is
      invoked via other tools.
    - ssh(1), ssh-add(1): make parsing user@host consistently look for the
      last '@' in the string rather than the first. This makes it possible
      to more consistently use usernames that contain '@' characters.
    - ssh(1), sshd(8): be more strict in parsing key type names. Only allow
      short names (e.g "rsa") in user-interface code and require full SSH
      protocol names (e.g. "ssh-rsa") everywhere else.
    - regress: many performance and correctness improvements to the
      re-keying regression test.
    - ssh-keygen(1): clarify that ed25519 is the default key type generated
      and clarify that rsa-sha2-512 is the default signature scheme when RSA
      is in use.
    - sshd(8): fix minor memory leak in Subsystem option parsing.
    - All: additional hardening and consistency checks for the sshbuf code.
    - sshd(8): reduce default logingrace penalty to ensure that a single
      forgotten login that times out will be below the penalty threshold.
    - ssh(1): fix proxy multiplexing (-O proxy) bug. If a mux started with
      ControlPersist then later has a forwarding added using mux proxy
      connection and the forwarding was used, then when the mux proxy
      session terminated, the mux master process would issue a bad message
      that terminated the connection.
    - Sync contrib/ssh-copy-id to the latest upstream version.
    - sshd(8): restore audit call before exit that regressed in openssh-9.8.
      Fixes an issue where the SSH_CONNECTION_ABANDON event was not
      recorded.
    - Fix detection of setres*id on GNU/Hurd.

 -- Colin Watson <cjwatson@debian.org>  Mon, 23 Sep 2024 21:09:59 -0700

openssh (1:9.8p1-8) unstable; urgency=medium

  * Source-only reupload.

 -- Colin Watson <cjwatson@debian.org>  Fri, 30 Aug 2024 00:38:26 +0100

openssh (1:9.8p1-7) unstable; urgency=medium

  * Adjust description line-wrapping so that lintian recognizes that
    openssh-client-gssapi is an intentionally empty package.

 -- Colin Watson <cjwatson@debian.org>  Thu, 29 Aug 2024 14:17:13 +0100

openssh (1:9.8p1-6) unstable; urgency=medium

  * Upload with binaries to satisfy Debian archive NEW checks.

 -- Colin Watson <cjwatson@debian.org>  Thu, 29 Aug 2024 13:46:57 +0100

openssh (1:9.8p1-5) unstable; urgency=medium

  * Add openssh-client-gssapi and openssh-server-gssapi packages; these
    currently just depend on their non-gssapi counterparts, but will become
    different in future.  See
    https://lists.debian.org/debian-devel/2024/04/msg00044.html.

 -- Colin Watson <cjwatson@debian.org>  Thu, 29 Aug 2024 12:53:42 +0100

openssh (1:9.8p1-4) unstable; urgency=medium

  [ Grzegorz Szymaszek ]
  * Disable listening on 22 in the port change example in README.Debian.

  [ Colin Watson ]
  * sshd: Allow exec without absolute path in inetd mode (closes: #1078429).
  * Add an autopkgtest for running sshd from xinetd.

 -- Colin Watson <cjwatson@debian.org>  Mon, 26 Aug 2024 15:02:45 +0100

openssh (1:9.8p1-3) unstable; urgency=medium

  [ Dirk Van Haerenborgh ]
  * Add sshd-session to openssh-server-udeb.

 -- Colin Watson <cjwatson@debian.org>  Tue, 06 Aug 2024 12:58:46 +0100

openssh (1:9.8p1-2) unstable; urgency=medium

  * Don't close sockets passed by systemd socket activation (closes:
    #1077765).
  * Add an autopkgtest for socket activation.
  * Consult /etc/hosts.{allow,deny} as "sshd", not "sshd-session" (closes:
    #1077799).

 -- Colin Watson <cjwatson@debian.org>  Fri, 02 Aug 2024 17:08:58 +0100

openssh (1:9.8p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/releasenotes.html#9.8p1):
    - CVE-2024-39894: Fix Logic error in ssh(1) ObscureKeystrokeTiming that
      made the feature ineffective.
    - The DSA signature algorithm is now disabled at compile-time.
    - sshd(8): the server has been split into a listener binary, sshd(8),
      and a per-session binary "sshd-session".  This allows for a much
      smaller listener binary, as it no longer needs to support the SSH
      protocol.  As part of this work, support for disabling privilege
      separation (which previously required code changes to disable) and
      disabling re-execution of sshd(8) has been removed.  Further
      separation of sshd-session into additional, minimal binaries is
      planned for the future.
    - sshd(8): several log messages have changed.  In particular, some log
      messages will be tagged with as originating from a process named
      "sshd-session" rather than "sshd".
    - ssh-keyscan(1): this tool previously emitted comment lines containing
      the hostname and SSH protocol banner to standard error.  This release
      now emits them to standard output, but adds a new "-q" flag to silence
      them altogether.
    - sshd(8): sshd will no longer use argv[0] as the PAM service name.  A
      new "PAMServiceName" sshd_config(5) directive allows selecting the
      service name at runtime.  This defaults to "sshd".
    - sshd(8): penalise client addresses that, for various reasons, do not
      successfully complete authentication.  This feature is controlled by a
      new sshd_config(5) PerSourcePenalties option and is on by default.
    - ssh(8): allow the HostkeyAlgorithms directive to disable the implicit
      fallback from certificate host key to plain host keys.
    - misc: fix a number of inaccuracies in the PROTOCOL.* documentation
      files.
    - all: switch to strtonum(3) for more robust integer parsing in most
      places.
    - ssh(1), sshd(8): correctly restore sigprocmask around ppoll().
    - ssh-keysign(8): stricter validation of messaging socket fd.
    - sftp(1): flush stdout after writing "sftp>" prompt when not using
      editline.
    - sftp-server(8): fix home-directory extension implementation, it
      previously always returned the current user's home directory contrary
      to the spec.
    - ssh-keyscan(1): do not close stdin to prevent error messages when
      stdin is read multiple times.
    - regression tests: fix rekey test that was testing the same KEX
      algorithm repeatedly instead of testing all of them.
    - ssh_config(5), sshd_config(5): clarify the KEXAlgorithms directive
      documentation, especially around what is supported vs available
      (closes: #1073065).
    - sshd(8): expose SSH_AUTH_INFO_0 always to PAM auth modules
      unconditionally. The previous behaviour was to expose it only when
      particular authentication methods were in use.
    - build: fix OpenSSL ED25519 support detection. An incorrect function
      signature in configure.ac previously prevented enabling the recently
      added support for ED25519 private keys in PEM PKCS8 format.
    - ssh(1), ssh-agent(8): allow the presence of the WAYLAND_DISPLAY
      environment variable to enable SSH_ASKPASS, similarly to the X11
      DISPLAY environment variable (closes: #1037515, #1068044).
  * Stop generating DSA host key.
  * Apply X-Style: black.

 -- Colin Watson <cjwatson@debian.org>  Wed, 31 Jul 2024 17:16:04 +0100

openssh (1:9.7p1-7) unstable; urgency=critical

  [ Salvatore Bonaccorso ]
  * Disable async-signal-unsafe code from the sshsigdie() function.  This is
    a minimal workaround for a regression from CVE-2006-5051.

 -- Colin Watson <cjwatson@debian.org>  Mon, 01 Jul 2024 10:11:27 +0100

openssh (1:9.7p1-6) unstable; urgency=medium

  * Stop reading ~/.pam_environment, which has a history of security
    problems and is deprecated by PAM upstream (closes: #1018260).

 -- Colin Watson <cjwatson@debian.org>  Tue, 25 Jun 2024 14:20:44 +0100

openssh (1:9.7p1-5) unstable; urgency=medium

  [ Colin Watson ]
  * Add "After=nss-user-lookup.target" to ssh.service and sshd@.service
    (closes: #1069706).
  * Avoid cleanup of /tmp/sshauth.*, created by sshd if ExposeAuthInfo is
    set.

  [ Andreas Hasenack ]
  * Add autopkgtests for GSSAPI logins, including gssapi-keyex.

  [ Luca Boccassi ]
  * Install tmpfiles.d to avoid cleanup of ssh-agent socket in /tmp/
    (closes: #1070725).
  * Only set PAM_RHOST if the remote host is not "UNKNOWN" (thanks, Daan De
    Meyer).

 -- Colin Watson <cjwatson@debian.org>  Thu, 16 May 2024 11:16:30 +0100

openssh (1:9.7p1-4) unstable; urgency=medium

  * Rework systemd readiness notification and socket activation patches to
    not link against libsystemd (the former via an upstream patch).
  * Force -fzero-call-used-regs=used not to be used on ppc64el (it's
    unsupported, but configure fails to detect this).

 -- Colin Watson <cjwatson@debian.org>  Wed, 03 Apr 2024 12:06:08 +0100

openssh (1:9.7p1-3) unstable; urgency=medium

  * Fix gssapi-keyex declaration further (thanks, Andreas Hasenack;
    LP: #2053146).
  * Extend -fzero-call-used-regs check to catch m68k gcc bug (closes:
    #1067243).
  * debian/tests/regress: Set a different IP address for UNKNOWN.
  * Re-enable ssh-askpass-gnome on all architectures.
  * regress: Redirect conch stdin from /dev/zero (re-enables conch interop
    tests).
  * Drop "Work around RSA SHA-2 signature issues in conch" patch (no longer
    needed now that Twisted is fixed).

 -- Colin Watson <cjwatson@debian.org>  Sun, 31 Mar 2024 11:55:38 +0100

openssh (1:9.7p1-2) unstable; urgency=medium

  [ Simon McVittie ]
  * d/control, d/rules: Disable ssh-askpass-gnome on 32-bit, except i386
    (closes: #1066847).

 -- Colin Watson <cjwatson@debian.org>  Thu, 14 Mar 2024 11:45:12 +0000

openssh (1:9.7p1-1) unstable; urgency=medium

  * Add the isolation-container restriction to the "regress" autopkgtest.
    Our setup code wants to ensure that the haveged service is running, and
    furthermore at least the agent-subprocess test assumes that there's an
    init to reap zombie processes and doesn't work in (e.g.)
    autopkgtest-virt-unshare.
  * New upstream release (https://www.openssh.com/releasenotes.html#9.7p1):
    - ssh(1), sshd(8): add a "global" ChannelTimeout type that watches all
      open channels and will close all open channels if there is no traffic
      on any of them for the specified interval. This is in addition to the
      existing per-channel timeouts added recently.
      This supports situations like having both session and x11 forwarding
      channels open where one may be idle for an extended period but the
      other is actively used. The global timeout could close both channels
      when both have been idle for too long (closes: #165185).
    - All: make DSA key support compile-time optional, defaulting to on.
    - sshd(8): don't append an unnecessary space to the end of subsystem
      arguments (bz3667)
    - ssh(1): fix the multiplexing "channel proxy" mode, broken when
      keystroke timing obfuscation was added. (GHPR#463)
    - ssh(1), sshd(8): fix spurious configuration parsing errors when
      options that accept array arguments are overridden (bz3657).
    - ssh-agent(1): fix potential spin in signal handler (bz3670)
    - Many fixes to manual pages and other documentation.
    - Greatly improve interop testing against PuTTY.
  * Skip utimensat test on ZFS, since it seems to leave the atime set to 0.
  * Allow passing extra options to debian/tests/regress, for debugging.
  * Fix gssapi-keyex declaration, broken when rebasing onto 8.9p1
    (LP: #2053146).

 -- Colin Watson <cjwatson@debian.org>  Thu, 14 Mar 2024 10:47:58 +0000

openssh (1:9.6p1-5) unstable; urgency=medium

  * Restore systemd template unit for per-connection sshd instances,
    although without any corresponding .socket unit for now; this is mainly
    for use with the forthcoming systemd-ssh-generator (closes: #1061516).
    It's now called sshd@.service, since unlike the main service there's no
    need to be concerned about compatibility with the slightly confusing
    "ssh" service name that Debian has traditionally used.

 -- Colin Watson <cjwatson@debian.org>  Wed, 06 Mar 2024 09:45:56 +0000

openssh (1:9.6p1-4) unstable; urgency=medium

  * Add sshd_config checksums for 1:9.2p1-1 to ucf reference file, and add a
    test to ensure it doesn't get out of date again.
  * Drop manual adjustment of OpenSSL dependencies; OpenSSH relaxed its
    checks for OpenSSL >= 3 in 9.4p1.
  * Build-depend on pkgconf rather than pkg-config.
  * Adjust debian/copyright to handle the "placed in the public domain"
    status of rijndael.* more explicitly.

 -- Colin Watson <cjwatson@debian.org>  Mon, 26 Feb 2024 12:26:57 +0000

openssh (1:9.6p1-3) unstable; urgency=medium

  * Allow passing extra ssh-agent arguments via
    "/usr/lib/openssh/agent-launch start", making it possible to override
    things like identity lifetime using a systemd drop-in unit (closes:
    #1059639).
  * Don't try to start rescue-ssh.target in postinst (LP: #2047082).

 -- Colin Watson <cjwatson@debian.org>  Wed, 17 Jan 2024 22:50:07 +0000

openssh (1:9.6p1-2) unstable; urgency=medium

  * Improve detection of broken -fzero-call-used-regs=used (see
    https://bugzilla.mindrot.org/show_bug.cgi?id=3645; fixes build on
    ppc64/ppc64el).

 -- Colin Watson <cjwatson@debian.org>  Thu, 21 Dec 2023 16:07:34 +0000

openssh (1:9.6p1-1) unstable; urgency=medium

  * Use single quotes in suggested ssh-keygen commands (closes: #1057835).
  * Debconf translations:
    - Catalan (thanks, Pablo Huguet; closes: #1049995).
  * New upstream release (https://www.openssh.com/releasenotes.html#9.6p1):
    - [CVE-2023-48795] ssh(1), sshd(8): implement protocol extensions to
      thwart the so-called "Terrapin attack" discovered by Fabian Bäumer,
      Marcus Brinkmann and Jörg Schwenk. This attack allows a MITM to effect
      a limited break of the integrity of the early encrypted SSH transport
      protocol by sending extra messages prior to the commencement of
      encryption, and deleting an equal number of consecutive messages
      immediately after encryption starts. A peer SSH client/server would
      not be able to detect that messages were deleted.
    - [CVE-2023-51384] ssh-agent(1): when adding PKCS#11-hosted private keys
      while specifying destination constraints, if the PKCS#11 token
      returned multiple keys then only the first key had the constraints
      applied. Use of regular private keys, FIDO tokens and unconstrained
      keys are unaffected.
    - [CVE-2023-51385] ssh(1): if an invalid user or hostname that contained
      shell metacharacters was passed to ssh(1), and a ProxyCommand,
      LocalCommand directive or "match exec" predicate referenced the user
      or hostname via %u, %h or similar expansion token, then an attacker
      who could supply arbitrary user/hostnames to ssh(1) could potentially
      perform command injection depending on what quoting was present in the
      user-supplied ssh_config(5) directive. OpenSSH 9.6 now bans most shell
      metacharacters from user and hostnames supplied via the command-line.
    - ssh(1), sshd(8): the RFC4254 connection/channels protocol provides a
      TCP-like window mechanism that limits the amount of data that can be
      sent without acceptance from the peer. In cases where this limit was
      exceeded by a non-conforming peer SSH implementation, ssh(1)/sshd(8)
      previously discarded the extra data. From OpenSSH 9.6, ssh(1)/sshd(8)
      will now terminate the connection if a peer exceeds the window limit
      by more than a small grace factor. This change should have no effect
      of SSH implementations that follow the specification.
    - ssh(1): add a %j token that expands to the configured ProxyJump
      hostname (or the empty string if this option is not being used) that
      can be used in a number of ssh_config(5) keywords.
    - ssh(1): add ChannelTimeout support to the client, mirroring the same
      option in the server and allowing ssh(1) to terminate quiescent
      channels.
    - ssh(1), sshd(8), ssh-add(1), ssh-keygen(1): add support for reading
      ED25519 private keys in PEM PKCS8 format. Previously only the OpenSSH
      private key format was supported.
    - ssh(1), sshd(8): introduce a protocol extension to allow renegotiation
      of acceptable signature algorithms for public key authentication after
      the server has learned the username being used for authentication.
      This allows varying sshd_config(5) PubkeyAcceptedAlgorithms in a
      "Match user" block.
    - ssh-add(1), ssh-agent(1): add an agent protocol extension to allow
      specifying certificates when loading PKCS#11 keys. This allows the use
      of certificates backed by PKCS#11 private keys in all OpenSSH tools
      that support ssh-agent(1). Previously only ssh(1) supported this
      use-case.
    - ssh(1): when deciding whether to enable the keystroke timing
      obfuscation, enable it only if a channel with a TTY is active.
    - ssh(1): switch mainloop from poll(3) to ppoll(3) and mask signals
      before checking flags set in signal handler. Avoids potential race
      condition between signaling ssh to exit and polling.
    - ssh(1): when connecting to a destination with both the AddressFamily
      and CanonicalizeHostname directives in use, the AddressFamily
      directive could be ignored.
    - sftp(1): correct handling of the limits@openssh.com option when the
      server returned an unexpected message.
    - ssh(1): release GSS OIDs only at end of authentication, avoiding
      unnecessary init/cleanup cycles.
    - ssh_config(5): mention "none" is a valid argument to IdentityFile in
      the manual.
    - scp(1): improved debugging for paths from the server rejected for not
      matching the client's glob(3) pattern in old SCP/RCP protocol mode.
    - ssh-agent(1): refuse signing operations on destination-constrained
      keys if a previous session-bind operation has failed. This may prevent
      a fail-open situation in future if a user uses a mismatched ssh(1)
      client and ssh-agent(1) where the client supports a key type that the
      agent does not support.
  * debian/run-tests: Supply absolute paths to tools.
  * debian/run-tests: Enable interop tests for Dropbear.

 -- Colin Watson <cjwatson@debian.org>  Mon, 18 Dec 2023 22:35:25 +0000

openssh (1:9.5p1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Colin Watson <cjwatson@debian.org>  Sat, 25 Nov 2023 16:16:04 +0000

openssh (1:9.5p1-1) experimental; urgency=medium

  * New upstream release (https://www.openssh.com/releasenotes.html#9.5p1):
    - ssh-keygen(1): generate Ed25519 keys by default. Ed25519 public keys
      are very convenient due to their small size. Ed25519 keys are
      specified in RFC 8709 and OpenSSH has supported them since version 6.5
      (January 2014).
    - sshd(8): the Subsystem directive now accurately preserves quoting of
      subsystem commands and arguments. This may change behaviour for exotic
      configurations, but the most common subsystem configuration
      (sftp-server) is unlikely to be affected.
    - ssh(1): add keystroke timing obfuscation to the client. This attempts
      to hide inter-keystroke timings by sending interactive traffic at
      fixed intervals (default: every 20ms) when there is only a small
      amount of data being sent. It also sends fake "chaff" keystrokes for a
      random interval after the last real keystroke. These are controlled by
      a new ssh_config ObscureKeystrokeTiming keyword.
    - ssh(1), sshd(8): Introduce a transport-level ping facility. This adds
      a pair of SSH transport protocol messages SSH2_MSG_PING/PONG to
      implement a ping capability. These messages use numbers in the "local
      extensions" number space and are advertised using a "ping@openssh.com"
      ext-info message with a string version number of "0".
    - sshd(8): allow override of Subsystem directives in sshd Match blocks.
    - scp(1): fix scp in SFTP mode recursive upload and download of
      directories that contain symlinks to other directories. In scp mode,
      the links would be followed, but in SFTP mode they were not.
    - ssh-keygen(1): handle cr+lf (instead of just cr) line endings in
      sshsig signature files.
    - ssh(1): interactive mode for ControlPersist sessions if they
      originally requested a tty.
    - sshd(8): make PerSourceMaxStartups first-match-wins.
    - sshd(8): limit artificial login delay to a reasonable maximum (5s) and
      don't delay at all for the "none" authentication mechanism.
    - sshd(8): Log errors in kex_exchange_identification() with level
      verbose instead of error to reduce preauth log spam. All of those get
      logged with a more generic error message by sshpkt_fatal().
    - sshd(8): correct math for ClientAliveInterval that caused the probes
      to be sent less frequently than configured.
    - ssh(1): fix regression in OpenSSH 9.4 (mux.c r1.99) that caused
      multiplexed sessions to ignore SIGINT under some circumstances.
  * Build-depend on dh-sequence-movetousr.
  * Report DebianBanner setting in "sshd -G/-T" output (thanks, Rasmus
    Villemoes; closes: #1053555).

 -- Colin Watson <cjwatson@debian.org>  Thu, 23 Nov 2023 17:38:07 +0000

openssh (1:9.4p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/releasenotes.html#9.4p1):
    - ssh-agent(1): PKCS#11 modules must now be specified by their full
      paths. Previously dlopen(3) could search for them in system library
      directories.
    - ssh(1): allow forwarding Unix Domain sockets via ssh -W.
    - ssh(1): add support for configuration tags to ssh(1). This adds a
      ssh_config(5) "Tag" directive and corresponding "Match tag" predicate
      that may be used to select blocks of configuration similar to the
      pf.conf(5) keywords of the same name.
    - ssh(1): add a "match localnetwork" predicate. This allows matching on
      the addresses of available network interfaces and may be used to vary
      the effective client configuration based on network location.
    - ssh(1), sshd(8), ssh-keygen(1): infrastructure support for KRL
      extensions. This defines wire formats for optional KRL extensions and
      implements parsing of the new submessages. No actual extensions are
      supported at this point.
    - sshd(8): AuthorizedPrincipalsCommand and AuthorizedKeysCommand now
      accept two additional %-expansion sequences: %D which expands to the
      routing domain of the connected session and %C which expands to the
      addresses and port numbers for the source and destination of the
      connection.
    - ssh-keygen(1): increase the default work factor (rounds) for the
      bcrypt KDF used to derive symmetric encryption keys for passphrase
      protected key files by 50%.
    - ssh-agent(1): improve isolation between loaded PKCS#11 modules by
      running separate ssh-pkcs11-helpers for each loaded provider.
    - ssh(1): make -f (fork after authentication) work correctly with
      multiplexed connections, including ControlPersist (closes: #348741).
    - ssh(1): make ConnectTimeout apply to multiplexing sockets and not just
      to network connections.
    - ssh-agent(1), ssh(1): improve defences against invalid PKCS#11 modules
      being loaded by checking that the requested module contains the
      required symbol before loading it.
    - sshd(8): fix AuthorizedPrincipalsCommand when AuthorizedKeysCommand
      appears before it in sshd_config. Since OpenSSH 8.7 the
      AuthorizedPrincipalsCommand directive was incorrectly ignored in this
      situation.
    - sshd(8), ssh(1), ssh-keygen(1): remove vestigial support for KRL
      signatures. When the KRL format was originally defined, it included
      support for signing of KRL objects. However, the code to sign KRLs and
      verify KRL signatues was never completed in OpenSSH. This release
      removes the partially-implemented code to verify KRLs. All OpenSSH
      tools now ignore KRL_SECTION_SIGNATURE sections in KRL files.
    - All: fix a number of memory leaks and unreachable/harmless integer
      overflows.
    - ssh-agent(1), ssh(1): don't truncate strings logged from PKCS#11
      modules.
    - sshd(8), ssh(1): better validate CASignatureAlgorithms in ssh_config
      and sshd_config. Previously this directive would accept certificate
      algorithm names, but these were unusable in practice as OpenSSH does
      not support CA chains.
    - ssh(1): make `ssh -Q CASignatureAlgorithms` only list signature
      algorithms that are valid for CA signing. Previous behaviour was to
      list all signing algorithms, including certificate algorithms.
    - ssh-keyscan(1): gracefully handle systems where rlimits or the maximum
      number of open files is larger than INT_MAX.
    - ssh-keygen(1): fix "no comment" not showing on when running
      `ssh-keygen -l` on multiple keys where one has a comment and other
      following keys do not. bz3580
    - scp(1), sftp(1): adjust ftruncate() logic to handle servers that
      reorder requests. Previously, if the server reordered requests then
      the resultant file would be erroneously truncated.
    - ssh(1): don't incorrectly disable hostname canonicalization when
      CanonicalizeHostname=yes and ProxyJump was explicitly set to "none".
    - scp(1): when copying local->remote, check that the source file exists
      before opening an SFTP connection to the server (closes: #59255).
    - sshd(8): provide a replacement for the SELinux matchpathcon()
      function, which is deprecated.
    - All: relax libcrypto version checks for OpenSSL >=3 (closes:
      #1035623). Beyond OpenSSL 3.0, the ABI compatibility guarantees are
      wider (only the library major must match instead of major and minor in
      earlier versions).
    - ssh-copy-id(1): Special case OpenWrt instead of Dropbear
      (LP: #1966886).

 -- Colin Watson <cjwatson@debian.org>  Sat, 02 Sep 2023 21:02:53 +0100

openssh (1:9.3p2-1) unstable; urgency=high

  * New upstream release (https://www.openssh.com/releasenotes.html#9.3p2):
    - [CVE-2023-38408] Fix a condition where specific libraries loaded via
      ssh-agent(1)'s PKCS#11 support could be abused to achieve remote code
      execution via a forwarded agent socket.

 -- Colin Watson <cjwatson@debian.org>  Wed, 19 Jul 2023 22:49:14 +0100

openssh (1:9.3p1-1) unstable; urgency=medium

  * Debconf translations:
    - Romanian (thanks, Remus-Gabriel Chelu; closes: #1033178).
  * Properly fix date of 1:3.0.2p1-2 changelog entry (closes: #1034425).
  * New upstream release (https://www.openssh.com/releasenotes.html#9.3p1):
    - [CVE-2023-28531] ssh-add(1): when adding smartcard keys to
      ssh-agent(1) with the per-hop destination constraints (ssh-add -h ...)
      added in OpenSSH 8.9, a logic error prevented the constraints from
      being communicated to the agent. This resulted in the keys being added
      without constraints. The common cases of non-smartcard keys and keys
      without destination constraints are unaffected. This problem was
      reported by Luci Stanescu (closes: #1033166).
    - [SECURITY] ssh(1): Portable OpenSSH provides an implementation of the
      getrrsetbyname(3) function if the standard library does not provide
      it, for use by the VerifyHostKeyDNS feature. A specifically crafted
      DNS response could cause this function to perform an out-of-bounds
      read of adjacent stack data, but this condition does not appear to be
      exploitable beyond denial-of-service to the ssh(1) client.
    - ssh-keygen(1), ssh-keyscan(1): accept -Ohashalg=sha1|sha256 when
      outputting SSHFP fingerprints to allow algorithm selection.
    - sshd(8): add a `sshd -G` option that parses and prints the effective
      configuration without attempting to load private keys and perform
      other checks. This allows usage of the option before keys have been
      generated and for configuration evaluation and verification by
      unprivileged users.
    - scp(1), sftp(1): fix progressmeter corruption on wide displays.
    - ssh-add(1), ssh-keygen(1): use RSA/SHA256 when testing usability of
      private keys as some systems are starting to disable RSA/SHA1 in
      libcrypto.
    - sftp-server(8): fix a memory leak.
    - ssh(1), sshd(8), ssh-keyscan(1): remove vestigial protocol
      compatibility code and simplify what's left.
    - Fix a number of low-impact Coverity static analysis findings.
    - ssh_config(5), sshd_config(5): mention that some options are not
      first-match-wins.
    - Rework logging for the regression tests. Regression tests will now
      capture separate logs for each ssh and sshd invocation in a test.
    - ssh(1): make `ssh -Q CASignatureAlgorithms` work as the manpage says
      it should.
    - ssh(1): ensure that there is a terminating newline when adding a new
      entry to known_hosts.
    - sshd(8): harden Linux seccomp sandbox. Move to an allowlist of
      mmap(2), madvise(2) and futex(2) flags, removing some concerning
      kernel attack surface.
  * debian/README.Debian: Clarify that you need to restart ssh.socket after
    overriding its ListenStream= option (LP: #2020560).
  * debian/openssh-server.postinst: Use "sshd -G" to parse the server
    configuration file (closes: #959726).
  * Fix incorrect RRSET_FORCE_EDNS0 flags validation in SSHFP DNSSEC patch
    (thanks, Ben Hutchings; closes: #909022).
  * Always use the internal mkdtemp implementation, since it substitutes
    more randomness into the template string than glibc's version (closes:
    #1001186).

 -- Colin Watson <cjwatson@debian.org>  Tue, 20 Jun 2023 01:01:48 +0100

openssh (1:9.2p1-2) unstable; urgency=medium

  * Fix mistakenly-unreleased entry for 1:9.2p1-1 in debian/NEWS.

 -- Colin Watson <cjwatson@debian.org>  Wed, 08 Feb 2023 10:43:07 +0000

openssh (1:9.2p1-1) unstable; urgency=medium

  * Set "UsePAM yes" when running regression tests, to match our default
    sshd configuration.
  * Ignore Lintian error about depending on lsb-base for now, to avoid
    problems with partial upgrades on non-default init systems.
  * New upstream release (https://www.openssh.com/releasenotes.html#9.2p1):
    - [SECURITY] sshd(8): fix a pre-authentication double-free memory fault
      introduced in OpenSSH 9.1. This is not believed to be exploitable, and
      it occurs in the unprivileged pre-auth process that is subject to
      chroot(2) and is further sandboxed on most major platforms.
    - [SECURITY] ssh(8): in OpenSSH releases after 8.7, the PermitRemoteOpen
      option would ignore its first argument unless it was one of the
      special keywords "any" or "none", causing the permission list to fail
      open if only one permission was specified.
    - [SECURITY] ssh(1): if the CanonicalizeHostname and
      CanonicalizePermittedCNAMEs options were enabled, and the system/libc
      resolver did not check that names in DNS responses were valid, then
      use of these options could allow an attacker with control of DNS to
      include invalid characters (possibly including wildcards) in names
      added to known_hosts files when they were updated. These names would
      still have to match the CanonicalizePermittedCNAMEs allow-list, so
      practical exploitation appears unlikely.
    - ssh(1): add a new EnableEscapeCommandline ssh_config(5) option that
      controls whether the client-side ~C escape sequence that provides a
      command-line is available. Among other things, the ~C command-line
      could be used to add additional port-forwards at runtime. This option
      defaults to "no", disabling the ~C command-line that was previously
      enabled by default.
    - sshd(8): add support for channel inactivity timeouts via a new
      sshd_config(5) ChannelTimeout directive. This allows channels that
      have not seen traffic in a configurable interval to be automatically
      closed. Different timeouts may be applied to session, X11, agent and
      TCP forwarding channels.
    - sshd(8): add a sshd_config UnusedConnectionTimeout option to terminate
      client connections that have no open channels for a length of time.
      This complements the ChannelTimeout option above.
    - sshd(8): add a -V (version) option to sshd like the ssh client has.
    - ssh(1): add a "Host" line to the output of ssh -G showing the original
      hostname argument. bz3343
    - scp(1), sftp(1): add a -X option to both scp(1) and sftp(1) to allow
      control over some SFTP protocol parameters: the copy buffer length and
      the number of in-flight requests, both of which are used during
      upload/download. Previously these could be controlled in sftp(1) only.
      This makes them available in both SFTP protocol clients using the same
      option character sequence.
    - ssh-keyscan(1): allow scanning of complete CIDR address ranges, e.g.
      "ssh-keyscan 192.168.0.0/24". If a CIDR range is passed, then it will
      be expanded to all possible addresses in the range including the
      all-0s and all-1s addresses.
    - ssh(1): support dynamic remote port forwarding in escape
      command-line's -R processing.
    - ssh(1): when restoring non-blocking mode to stdio fds, restore exactly
      the flags that ssh started with and don't just clobber them with zero,
      as this could also remove the append flag from the set.
    - ssh(1): avoid printf("%s", NULL) if using UserKnownHostsFile=none and
      a hostkey in one of the system known hosts file changes.
    - scp(1): switch scp from using pipes to a socket-pair for communication
      with its ssh sub-processes, matching how sftp(1) operates.
    - sshd(8): clear signal mask early in main(); sshd may have been started
      with one or more signals masked (sigprocmask(2) is not cleared on
      fork/exec) and this could interfere with various things, e.g. the
      login grace timer. Execution environments that fail to clear the
      signal mask before running sshd are clearly broken, but apparently
      they do exist.
    - ssh(1): warn if no host keys for hostbased auth can be loaded.
    - sshd(8): Add server debugging for hostbased auth that is queued and
      sent to the client after successful authentication, but also logged to
      assist in diagnosis of HostbasedAuthentication problems.
    - ssh(1): document use of the IdentityFile option as being usable to
      list public keys as well as private keys.
    - sshd(8): check for and disallow MaxStartups values less than or equal
      to zero during config parsing, rather than failing later at runtime.
    - ssh-keygen(1): fix parsing of hex cert expiry times specified on the
      command-line when acting as a CA.
    - scp(1): when scp(1) is using the SFTP protocol for transport (the
      default), better match scp/rcp's handling of globs that don't match
      the globbed characters but do match literally (e.g. trying to transfer
      a file named "foo.[1]"). Previously scp(1) in SFTP mode would not
      match these pathnames but legacy scp/rcp mode would.
    - ssh-agent(1): document the "-O no-restrict-websafe" command-line
      option.
    - ssh(1): honour user's umask(2) if it is more restrictive then the ssh
      default (022).
    - sshd(8): allow writev(2) in the Linux seccomp sandbox. This seems to
      be used by recent glibcs at least in some configurations during error
      conditions.
    - sshd(8): simplify handling of SSH_CONNECTION PAM env var, removing
      global variable and checking the return value from pam_putenv.
    - sshd(8): disable SANDBOX_SECCOMP_FILTER_DEBUG that was mistakenly
      enabled during the OpenSSH 9.1 release cycle.
    - sshd(8): defer PRNG seeding until after the initial closefrom(2) call.
      PRNG seeding will initialize OpenSSL, and some engine providers (e.g.
      Intel's QAT) will open descriptors for their own use that closefrom(2)
      could clobber.
  * debian/run-tests: Add a little more flexibility for debugging.

 -- Colin Watson <cjwatson@debian.org>  Wed, 08 Feb 2023 10:36:06 +0000

openssh (1:9.1p1-2) unstable; urgency=medium

  [ Christian Göttsche ]
  * Do not copy SELinux security context in postinst.

  [ Colin Watson ]
  * Add missing ${misc:Depends} to Depends for openssh-client-udeb,
    openssh-server-udeb.
  * Use secure URI in Homepage field.
  * Remove 2 obsolete maintscript entries in 2 files.
  * Fix day-of-week for changelog entries 1:3.0.2p1-9, 1:3.0.2p1-2,
    1:3.0.1p1-1.
  * Remove deprecated Encoding key from desktop file
    debian/ssh-askpass-gnome.desktop.
  * Update standards version to 4.6.2, no changes needed.
  * debian/tests/regress: Adjust to cope with changes in adduser 3.130 (see
    #625758).

 -- Colin Watson <cjwatson@debian.org>  Tue, 03 Jan 2023 11:57:19 +0000

openssh (1:9.1p1-1) unstable; urgency=medium

  [ Markus Teich ]
  * Delete obsolete upstart configuration override.

  [ Colin Watson ]
  * Work around apparent dh-exec regressions (closes: #1016340).
  * Don't install unnecessary *.lo files in openssh-tests.
  * Update Lintian overrides to current syntax.
  * Pass on compiler/linker flags when building debian/keygen-test.
  * Remove obsolete and misleading rcp/rlogin/rsh alternatives, and stop
    providing rsh-client (closes: #197037).
  * Add sshd_config checksums for 1:8.2p1-1 and 1:8.7p1-1 to ucf reference
    file.
  * New upstream release (https://www.openssh.com/releasenotes.html#9.1p1,
    closes: #1021585):
    - ssh-keyscan(1): fix a one-byte overflow in SSH- banner processing.
    - ssh-keygen(1): double free() in error path of file hashing step in
      signing/verify code.
    - ssh-keysign(8): double-free in error path introduced in openssh-8.9.
    - ssh(1), sshd(8): SetEnv directives in ssh_config and sshd_config are
      now first-match-wins to match other directives. Previously if an
      environment variable was multiply specified the last set value would
      have been used.
    - ssh-keygen(8): ssh-keygen -A (generate all default host key types)
      will no longer generate DSA keys, as these are insecure and have not
      been used by default for some years.
    - ssh(1), sshd(8): add a RequiredRSASize directive to set a minimum RSA
      key length. Keys below this length will be ignored for user
      authentication and for host authentication in sshd(8). ssh(1) will
      terminate a connection if the server offers an RSA key that falls
      below this limit, as the SSH protocol does not include the ability to
      retry a failed key exchange.
    - sftp-server(8): add a "users-groups-by-id@openssh.com" extension
      request that allows the client to obtain user/group names that
      correspond to a set of uids/gids.
    - sftp(1): use "users-groups-by-id@openssh.com" sftp-server extension
      (when available) to fill in user/group names for directory listings.
    - sftp-server(8): support the "home-directory" extension request defined
      in draft-ietf-secsh-filexfer-extensions-00. This overlaps a bit with
      the existing "expand-path@openssh.com", but some other clients support
      it.
    - ssh-keygen(1), sshd(8): allow certificate validity intervals, sshsig
      verification times and authorized_keys expiry-time options to accept
      dates in the UTC time zone in addition to the default of interpreting
      them in the system time zone. YYYYMMDD and YYMMDDHHMM[SS] dates/times
      will be interpreted as UTC if suffixed with a 'Z' character. Also
      allow certificate validity intervals to be specified in raw
      seconds-since-epoch as hex value, e.g. -V 0x1234:0x4567890. This is
      intended for use by regress tests and other tools that call ssh-keygen
      as part of a CA workflow.
    - sftp(1): allow arguments to the sftp -D option, e.g. sftp -D
      "/usr/libexec/sftp-server -el debug3".
    - ssh-keygen(1): allow the existing -U (use agent) flag to work with "-Y
      sign" operations, where it will be interpreted to require that the
      private keys is hosted in an agent.
    - ssh-keygen(1): implement the "verify-required" certificate option.
      This was already documented when support for user-verified FIDO keys
      was added, but the ssh-keygen(1) code was missing.
    - ssh-agent(1): hook up the restrict_websafe command-line flag;
      previously the flag was accepted but never actually used.
    - sftp(1): improve filename tab completions: never try to complete names
      to non-existent commands, and better match the completion type (local
      or remote filename) against the argument position being completed.
    - ssh-keygen(1), ssh(1), ssh-agent(1): several fixes to FIDO key
      handling, especially relating to keys that request user-verification.
      These should reduce the number of unnecessary PIN prompts for keys
      that support intrinsic user verification.
    - ssh-keygen(1): when enrolling a FIDO resident key, check if a
      credential with matching application and user ID strings already
      exists and, if so, prompt the user for confirmation before overwriting
      the credential.
    - sshd(8): improve logging of errors when opening authorized_keys files.
    - ssh(1): avoid multiplexing operations that could cause SIGPIPE from
      causing the client to exit early.
    - ssh_config(5), sshd_config(5): clarify that the RekeyLimit directive
      applies to both transmitted and received data.
    - ssh-keygen(1): avoid double fclose() in error path.
    - sshd(8): log an error if pipe() fails while accepting a connection.
    - ssh-keyscan(1): add missing *-sk types to ssh-keyscan manpage.
    - sshd(8): ensure that authentication passwords are cleared from memory
      in error paths.
    - ssh(1), ssh-agent(1): avoid possibility of notifier code executing
      kill(-1).
    - ssh_config(5): note that the ProxyJump directive also accepts the same
      tokens as ProxyCommand.
    - scp(1): do not ftruncate(3) files early when in sftp mode. The
      previous behaviour of unconditionally truncating the destination file
      would cause "scp ~/foo localhost:foo" and the reverse "scp
      localhost:foo ~/foo" to delete all the contents of their destination.
    - ssh-keygen(1): improve error message when 'ssh-keygen -Y sign' is
      unable to load a private key.
    - sftp(1), scp(1): when performing operations that glob(3) a remote
      path, ensure that the implicit working directory used to construct
      that path escapes glob(3) characters. This prevents glob characters
      from being processed in places they shouldn't, e.g. "cd /tmp/a*/",
      "get *.txt" should have the get operation treat the path "/tmp/a*"
      literally and not attempt to expand it (LP: #1483751).
    - ssh(1), sshd(8): be stricter in which characters will be accepted in
      specifying a mask length; allow only 0-9.
    - ssh-keygen(1): avoid printing hash algorithm twice when dumping a KRL.
    - ssh(1), sshd(8): continue running local I/O for open channels during
      SSH transport rekeying. This should make ~-escapes work in the client
      (e.g. to exit) if the connection happened to have stalled during a
      rekey event.
    - ssh(1), sshd(8): avoid potential poll() spin during rekeying.
    - Further hardening for sshbuf internals: disallow "reparenting" a
      hierarchical sshbuf and zero the entire buffer if reallocation fails.
    - sshd(8): add AUDIT_ARCH_PPC to supported seccomp sandbox
      architectures.
  * Drop patch to work around https://twistedmatrix.com/trac/ticket/9765,
    since the fix for that is in Debian testing.
  * Rewrite gnome-ssh-askpass(1) manual page using mdoc macros, and flesh it
    out a bit more.

  [ Steve Langasek ]
  * Support systemd socket activation.  Migrate any existing inetd-style
    socket activation to systemd socket activation.

  [ Gioele Barabucci ]
  * Remove ancient version constraints.
  * d/openssh-server.{postinst,config}: get_config_option: Replace perl with
    sed.

 -- Colin Watson <cjwatson@debian.org>  Mon, 14 Nov 2022 16:25:45 +0000

openssh (1:9.0p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/releasenotes.html#9.0p1):
    - scp(1): Use the SFTP protocol by default (closes: #144579, #204546,
      #327019). This changes scp's quoting semantics by no longer performing
      wildcard expansion using the remote shell, and (with some server
      versions) no longer expanding ~user paths. The -O option is available
      to use the old protocol. See NEWS.Debian for more details.
    - ssh(1), sshd(8): use the hybrid Streamlined NTRU Prime + x25519 key
      exchange method by default ("sntrup761x25519-sha512@openssh.com").
      The NTRU algorithm is believed to resist attacks enabled by future
      quantum computers and is paired with the X25519 ECDH key exchange (the
      previous default) as a backstop against any weaknesses in NTRU Prime
      that may be discovered in the future. The combination ensures that the
      hybrid exchange offers at least as good security as the status quo.
    - sftp-server(8): support the "copy-data" extension to allow server-
      side copying of files/data, following the design in
      draft-ietf-secsh-filexfer-extensions-00.
    - sftp(1): add a "cp" command to allow the sftp client to perform
      server-side file copies.
    - ssh(1), sshd(8): upstream: fix poll(2) spin when a channel's output fd
      closes without data in the channel buffer (closes: #1007822).
    - sshd(8): pack pollfd array in server listen/accept loop. Could cause
      the server to hang/spin when MaxStartups > RLIMIT_NOFILE.
    - ssh-keygen(1): avoid NULL deref via the find-principals and
      check-novalidate operations. bz3409 and GHPR307 respectively.
    - scp(1): fix a memory leak in argument processing.
    - sshd(8): don't try to resolve ListenAddress directives in the sshd
      re-exec path. They are unused after re-exec and parsing errors
      (possible for example if the host's network configuration changed)
      could prevent connections from being accepted.
    - sshd(8): when refusing a public key authentication request from a
      client for using an unapproved or unsupported signature algorithm
      include the algorithm name in the log message to make debugging
      easier.
    - ssh(1), sshd(8): Fix possible integer underflow in scan_scaled(3)
      parsing of K/M/G/etc quantities.
    - sshd(8): default to not using sandbox when cross compiling. On most
      systems poll(2) does not work when the number of FDs is reduced with
      setrlimit, so assume it doesn't when cross compiling and we can't run
      the test.
  * Remove obsolete FAQ, removed from openssh.com in 2016.

 -- Colin Watson <cjwatson@debian.org>  Sat, 09 Apr 2022 14:14:10 +0100

openssh (1:8.9p1-3) unstable; urgency=medium

  * Allow ppoll_time64 in seccomp filter (closes: #1006445).

 -- Colin Watson <cjwatson@debian.org>  Fri, 25 Feb 2022 23:30:49 +0000

openssh (1:8.9p1-2) unstable; urgency=medium

  * Improve detection of -fzero-call-used-regs=all support.

 -- Colin Watson <cjwatson@debian.org>  Thu, 24 Feb 2022 16:09:56 +0000

openssh (1:8.9p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/releasenotes.html#8.9p1):
    - sshd(8): fix an integer overflow in the user authentication path that,
      in conjunction with other logic errors, could have yielded
      unauthenticated access under difficult to exploit conditions.
    - sshd(8), portable OpenSSH only: this release removes in-built support
      for MD5-hashed passwords.
    - ssh(1), sshd(8), ssh-add(1), ssh-agent(1): add a system for
      restricting forwarding and use of keys added to ssh-agent(1).
    - ssh(1), sshd(8): add the sntrup761x25519-sha512@openssh.com hybrid
      ECDH/x25519 + Streamlined NTRU Prime post-quantum KEX to the default
      KEXAlgorithms list (after the ECDH methods but before the prime-group
      DH ones). The next release of OpenSSH is likely to make this key
      exchange the default method.
    - ssh-keygen(1): when downloading resident keys from a FIDO token, pass
      back the user ID that was used when the key was created and append it
      to the filename the key is written to (if it is not the default).
      Avoids keys being clobbered if the user created multiple resident keys
      with the same application string but different user IDs.
    - ssh-keygen(1), ssh(1), ssh-agent(1): better handling for FIDO keys on
      tokens that provide user verification (UV) on the device itself,
      including biometric keys, avoiding unnecessary PIN prompts.
    - ssh-keygen(1): add "ssh-keygen -Y match-principals" operation to
      perform matching of principals names against an allowed signers file.
      To be used towards a TOFU model for SSH signatures in git.
    - ssh-add(1), ssh-agent(1): allow pin-required FIDO keys to be added to
      ssh-agent(1). $SSH_ASKPASS will be used to request the PIN at
      authentication time.
    - ssh-keygen(1): allow selection of hash at sshsig signing time (either
      sha512 (default) or sha256).
    - ssh(1), sshd(8): read network data directly to the packet input buffer
      instead indirectly via a small stack buffer. Provides a modest
      performance improvement.
    - ssh(1), sshd(8): read data directly to the channel input buffer,
      providing a similar modest performance improvement.
    - ssh(1): extend the PubkeyAuthentication configuration directive to
      accept yes|no|unbound|host-bound to allow control over one of the
      protocol extensions used to implement agent-restricted keys.
    - sshd(8): document that CASignatureAlgorithms, ExposeAuthInfo and
      PubkeyAuthOptions can be used in a Match block.
    - sshd(8): fix possible string truncation when constructing paths to
      .rhosts/.shosts files with very long user home directory names.
    - ssh-keysign(1): unbreak for KEX algorithms that use SHA384/512
      exchange hashes.
    - ssh(1): don't put the TTY into raw mode when SessionType=none, avoids
      ^C being unable to kill such a session.
    - scp(1): fix some corner-case bugs in SFTP-mode handling of ~-prefixed
      paths.
    - ssh(1): unbreak hostbased auth using RSA keys. Allow ssh(1) to select
      RSA keys when only RSA/SHA2 signature algorithms are configured (this
      is the default case). Previously RSA keys were not being considered in
      the default case.
    - ssh-keysign(1): make ssh-keysign use the requested signature algorithm
      and not the default for the key type. Part of unbreaking hostbased
      auth for RSA/SHA2 keys.
    - ssh(1): stricter UpdateHostkey signature verification logic on the
      client-side. Require RSA/SHA2 signatures for RSA hostkeys except when
      RSA/SHA1 was explicitly negotiated during initial KEX.
    - ssh(1), sshd(8): fix signature algorithm selection logic for
      UpdateHostkeys on the server side. The previous code tried to prefer
      RSA/SHA2 for hostkey proofs of RSA keys, but missed some cases. This
      will use RSA/SHA2 signatures for RSA keys if the client proposed these
      algorithms in initial KEX.
    - All: convert all uses of select(2)/pselect(2) to poll(2)/ppoll(2).
      This includes the mainloops in ssh(1), ssh-agent(1), ssh-agent(1) and
      sftp-server(8), as well as the sshd(8) listen loop and all other FD
      read/writability checks. On platforms with missing or broken
      poll(2)/ppoll(2) syscalls a select(2)-based compat shim is available.
    - ssh-keygen(1): the "-Y find-principals" command was verifying key
      validity when using ca certs but not with simple key lifetimes within
      the allowed signers file.
    - ssh-keygen(1): make sshsig verify-time argument parsing optional.
    - sshd(8): fix truncation in rhosts/shosts path construction.
    - ssh(1), ssh-agent(1): avoid xmalloc(0) for PKCS#11 keyid for ECDSA
      keys (we already did this for RSA keys). Avoids fatal errors for
      PKCS#11 libraries that return empty keyid, e.g. Microchip ATECC608B
      "cryptoauthlib".
    - ssh(1), ssh-agent(1): improve the testing of credentials against
      inserted FIDO: ask the token whether a particular key belongs to it in
      cases where the token supports on-token user-verification (e.g.
      biometrics) rather than just assuming that it will accept it. Will
      reduce spurious "Confirm user presence" notifications for key handles
      that relate to FIDO keys that are not currently inserted in at least
      some cases.
    - ssh(1), sshd(8): correct value for IPTOS_DSCP_LE. It needs to allow
      for the preceding two ECN bits.
    - ssh-keygen(1): add missing -O option to usage() for the "-Y sign"
      option.
    - ssh-keygen(1): fix a NULL deref when using the find-principals
      function, when matching an allowed_signers line that contains a
      namespace restriction, but no restriction specified on the
      command-line
    - ssh-agent(1): fix memleak in process_extension().
    - ssh(1): suppress "Connection to xxx closed" messages when LogLevel is
      set to "error" or above.
    - ssh(1), sshd(8): use correct zlib flags when inflate(3)-ing compressed
      packet data.
    - scp(1): when recursively transferring files in SFTP mode, create the
      destination directory if it doesn't already exist to match scp(1) in
      legacy RCP mode behaviour.
    - scp(1): many improvements in error message consistency between scp(1)
      in SFTP mode vs legacy RCP mode.
    - sshd(8): fix potential race in SIGTERM handling.
    - ssh(1), ssh(8): since DSA keys are deprecated, move them to the end of
      the default list of public keys so that they will be tried last.
    - ssh-keygen(1): allow 'ssh-keygen -Y find-principals' to match wildcard
      principals in allowed_signers files.
    - ssh(1), sshd(8): don't trust closefrom(2) on Linux. glibc's
      implementation does not work in a chroot when the kernel does not have
      close_range(2). It tries to read from /proc/self/fd and when that
      fails dies with an assertion of sorts. Instead, call close_range(2)
      directly from our compat code and fall back if that fails.
    - Correct handling of exceptfds/POLLPRI in our select(2)-based
      poll(2)/ppoll(2) compat implementation.
  * Drop patch to work around https://twistedmatrix.com/trac/ticket/9515,
    since the fix for that is in Debian stable.

 -- Colin Watson <cjwatson@debian.org>  Thu, 24 Feb 2022 11:06:15 +0000

openssh (1:8.8p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/releasenotes.html#8.8p1,
    closes: #996391):
    - This release disables RSA signatures using the SHA-1 hash algorithm by
      default.  (Existing RSA keys may still be used and do not need to be
      replaced; see NEWS.Debian if you have problems connecting to old SSH
      servers.)
    - ssh(1): allow the ssh_config(5) CanonicalizePermittedCNAMEs directive
      to accept a "none" argument to specify the default behaviour.
    - scp(1): when using the SFTP protocol, continue transferring files
      after a transfer error occurs, better matching original scp/rcp
      behaviour.
    - ssh(1): fixed a number of memory leaks in multiplexing,
    - ssh-keygen(1): avoid crash when using the -Y find-principals command.
    - A number of documentation and manual improvements.
    - ssh(1)/sshd(8): some fixes to the pselect(2) replacement compatibility
      code.
  * Work around missing RSA SHA-2 signature support in conch until the
    upstream fix lands in Debian.

 -- Colin Watson <cjwatson@debian.org>  Tue, 15 Feb 2022 19:20:21 +0000

openssh (1:8.7p1-4) unstable; urgency=medium

  [ Daniel Baumann ]
  * Fix typo in openssh-client.alternatives (closes: #1002803).

  [ Colin Watson ]
  * Further clarify socket activation instructions.

 -- Colin Watson <cjwatson@debian.org>  Wed, 29 Dec 2021 12:08:38 +0000

openssh (1:8.7p1-3) unstable; urgency=medium

  * Include unit test binaries in openssh-tests even if building with
    DEB_BUILD_OPTIONS=nocheck.
  * Install built version of sshd_config, with corrected PATH and PidFile.
  * Upgrade to debhelper v13.
  * debian/copyright: Use HTTPS in Source field.
  * Update renamed Lintian tag name in Lintian override.
  * debian/watch: Upgrade to version 4.
  * Clarify instructions for using socket activation to avoid accidental
    attempts to start the non-socket-activated service that can result in
    systems without a running sshd (closes: #1001320).
  * Remove maintainer script code for upgrades from before Debian 9.
  * Make the sysvinit script provide "ssh" as well as "sshd".
  * Set Rules-Requires-Root: no.
  * Use dh_installalternatives.
  * Simplify some debhelper overrides slightly.

 -- Colin Watson <cjwatson@debian.org>  Wed, 29 Dec 2021 01:12:00 +0000

openssh (1:8.7p1-2) unstable; urgency=medium

  * Backport from upstream:
    - Avoid NULL deref in -Y find-principals (closes: #999593).

 -- Colin Watson <cjwatson@debian.org>  Sat, 13 Nov 2021 13:40:50 +0000

openssh (1:8.7p1-1) unstable; urgency=medium

  * debian/upstream/signing-key.asc: Update from upstream.
  * New upstream release (https://www.openssh.com/releasenotes.html#8.7p1):
    - scp(1): this release changes the behaviour of remote to remote copies
      (e.g. "scp host-a:/path host-b:") to transfer through the local host
      by default (closes: #734386, LP: #1462758). This was previously
      available via the -3 flag. A -R flag has been added to select the old
      behaviour.
    - ssh(1)/sshd(8): both the client and server are now using a stricter
      configuration file parser.
    - ssh(1): when using SSHFP DNS records for host key verification, ssh(1)
      will verify all matching records instead of just those with the
      specific signature type requested.
    - ssh-keygen(1): when generating a FIDO key and specifying an explicit
      attestation challenge (using -Ochallenge), the challenge will now be
      hashed by the builtin security key middleware.
    - sshd(8): environment="..." directives in authorized_keys files are now
      first-match-wins and limited to 1024 discrete environment variable
      names.
    - scp(1): experimental support for transfers using the SFTP protocol as
      a replacement for the venerable SCP/RCP protocol that it has
      traditionally used. SFTP offers more predictable filename handling and
      does not require expansion of glob(3) patterns via the shell on the
      remote side.
      SFTP support may be enabled via a temporary scp -s flag. It is
      intended for SFTP to become the default transfer mode in the near
      future, at which time the -s flag will be removed. The -O flag exists
      to force use of the original SCP/RCP protocol for cases where SFTP may
      be unavailable or incompatible.
    - sftp-server(8): add a protocol extension to support expansion of ~/
      and ~user/ prefixed paths. This was added to support these paths when
      used by scp(1) while in SFTP mode.
    - ssh(1): add a ForkAfterAuthentication ssh_config(5) counterpart to the
      ssh(1) -f flag. GHPR231
    - ssh(1): add a StdinNull directive to ssh_config(5) that allows the
      config file to do the same thing as -n does on the ssh(1) command-
      line. GHPR231
    - ssh(1): add a SessionType directive to ssh_config, allowing the
      configuration file to offer equivalent control to the -N (no session)
      and -s (subsystem) command-line flags (closes: #609122).
    - ssh-keygen(1): allowed signers files used by ssh-keygen(1) signatures
      now support listing key validity intervals alongside they key, and
      ssh-keygen(1) can optionally check during signature verification
      whether a specified time falls inside this interval. This feature is
      intended for use by git to support signing and verifying objects using
      ssh keys.
    - ssh-keygen(8): support printing of the full public key in a sshsig
      signature via a -Oprint-pubkey flag.
    - ssh(1)/sshd(8): start time-based re-keying exactly on schedule in the
      client and server mainloops. Previously the re-key timeout could
      expire but re-keying would not start until a packet was sent or
      received, causing a spin in select() if the connection was quiescent.
    - ssh-keygen(1): avoid Y2038 problem in printing certificate validity
      lifetimes. Dates past 2^31-1 seconds since epoch were displayed
      incorrectly on some platforms.
    - scp(1): allow spaces to appear in usernames for local to remote and
      scp -3 remote to remote copies.
    - ssh(1)/sshd(8): remove references to ChallengeResponseAuthentication
      in favour of KbdInteractiveAuthentication. The former is what was in
      SSHv1, the latter is what is in SSHv2 (RFC4256) and they were treated
      as somewhat but not entirely equivalent. We retain the old name as a
      deprecated alias so configuration files continue to work as well as a
      reference in the man page for people looking for it.
    - ssh(1)/ssh-add(1)/ssh-keygen(1): fix decoding of X.509 subject name
      when extracting a key from a PKCS#11 certificate.
    - ssh(1): restore blocking status on stdio fds before close. ssh(1)
      needs file descriptors in non-blocking mode to operate but it was not
      restoring the original state on exit. This could cause problems with
      fds shared with other programs via the shell.
    - ssh(1)/sshd(8): switch both client and server mainloops from select(3)
      to pselect(3). Avoids race conditions where a signal may arrive
      immediately before select(3) and not be processed until an event
      fires.
    - ssh(1): sessions started with ControlPersist were incorrectly
      executing a shell when the -N (no shell) option was specified (closes:
      #762633).
    - ssh(1): check if IPQoS or TunnelDevice are already set before
      overriding. Prevents values in config files from overriding values
      supplied on the command line.
    - ssh(1): fix debug message when finding a private key to match a
      certificate being attempted for user authentication. Previously it
      would print the certificate's path, whereas it was supposed to be
      showing the private key's path.
    - sshd(8): match host certificates against host public keys, not private
      keys. Allows use of certificates with private keys held in a
      ssh-agent.
    - ssh(1): add a workaround for a bug in OpenSSH 7.4 sshd(8), which
      allows RSA/SHA2 signatures for public key authentication but fails to
      advertise this correctly via SSH2_MSG_EXT_INFO. This causes clients of
      these server to incorrectly match PubkeyAcceptedAlgorithms and
      potentially refuse to offer valid keys.
    - sftp(1)/scp(1): degrade gracefully if a sftp-server offers the
      limits@openssh.com extension but fails when the client tries to invoke
      it.
    - ssh(1): allow ssh_config SetEnv to override $TERM, which is otherwise
      handled specially by the protocol. Useful in ~/.ssh/config to set TERM
      to something generic (e.g. "xterm" instead of "xterm-256color") for
      destinations that lack terminfo entries.
    - sftp-server(8): the limits@openssh.com extension was incorrectly
      marked as an operation that writes to the filesystem, which made it
      unavailable in sftp-server read-only mode.
    - ssh(1): fix SEGV in UpdateHostkeys debug() message, triggered when the
      update removed more host keys than remain present.
    - Many manual page fixes.
    - sshd(8): handle GIDs > 2^31 in getgrouplist. When compiled in 32bit
      mode, the getgrouplist implementation may fail for GIDs greater than
      LONG_MAX.
    - ssh(1): xstrdup environment variable used by ForwardAgent.
    - sshd(8): don't sigdie() in signal handler in privsep child process;
      this can end up causing sandbox violations.
  * New upstream release (https://www.openssh.com/releasenotes.html#8.6p1):
    - sftp-server(8): add a new limits@openssh.com protocol extension that
      allows a client to discover various server limits, including maximum
      packet size and maximum read/write length.
    - sftp(1): use the new limits@openssh.com extension (when available) to
      select better transfer lengths in the client.
    - sshd(8): Add ModuliFile keyword to sshd_config to specify the location
      of the "moduli" file containing the groups for DH-GEX.
    - ssh_config(5), sshd_config(5): sync CASignatureAlgorithms lists in
      manual pages with the current default.
    - ssh(1): ensure that pkcs11_del_provider() is called before exit.
    - ssh(1), sshd(8): fix problems in string->argv conversion. Multiple
      backslashes were not being dequoted correctly and quoted space in the
      middle of a string was being incorrectly split.
    - ssh(1): return non-zero exit status when killed by signal.
    - sftp-server(8): increase maximum SSH2_FXP_READ to match the maximum
      packet size. Also handle zero-length reads that are not explicitly
      banned by the spec.
    - sshd(8): don't mistakenly exit on transient read errors on the network
      socket (e.g. EINTR, EAGAIN).
    - Create a dedicated contrib/gnome-ssk-askpass3.c source instead of
      building it from the same file as used for GNOME2. Use the GNOME3
      gdk_seat_grab() to manage keyboard/mouse/server grabs for better
      compatibility with Wayland.
    - sshd(8): soft-disallow the fstatat64 syscall in the Linux seccomp-bpf
      sandbox.
  * New upstream release (https://www.openssh.com/releasenotes.html#8.5p1):
    - ssh(1), sshd(8): change the first-preference signature algorithm from
      ECDSA to ED25519.
    - ssh(1), sshd(8): set the TOS/DSCP specified in the configuration for
      interactive use prior to TCP connect.
    - ssh(1), sshd(8): remove the pre-standardization cipher
      rijndael-cbc@lysator.liu.se.
    - ssh(1), sshd(8): update/replace the experimental post-quantum hybrid
      key exchange method based on Streamlined NTRU Prime coupled with
      X25519.
    - ssh(1): disable CheckHostIP by default. It provides insignificant
      benefits while making key rotation significantly more difficult,
      especially for hosts behind IP-based load-balancers (closes: #764027).
    - ssh(1): enable UpdateHostkeys by default subject to some conservative
      preconditions (closes: #875532):
      + The key was matched in the UserKnownHostsFile (and not in the
        GlobalKnownHostsFile).
      + The same key does not exist under another name.
      + A certificate host key is not in use.
      + known_hosts contains no matching wildcard hostname pattern.
      + VerifyHostKeyDNS is not enabled.
      + The default UserKnownHostsFile is in use.
      We expect some of these conditions will be modified or relaxed in
      future.
    - ssh(1), sshd(8): add a new LogVerbose configuration directive that
      allows forcing maximum debug logging by file/function/line
      pattern-lists.
    - ssh(1): when prompting the user to accept a new hostkey, display any
      other host names/addresses already associated with the key.
    - ssh(1): allow UserKnownHostsFile=none to indicate that no known_hosts
      file should be used to identify host keys.
    - ssh(1): add a ssh_config KnownHostsCommand option that allows the
      client to obtain known_hosts data from a command in addition to the
      usual files.
    - ssh(1): add a ssh_config PermitRemoteOpen option that allows the
      client to restrict the destination when RemoteForward is used with
      SOCKS.
    - ssh(1): for FIDO keys, if a signature operation fails with a
      "incorrect PIN" reason and no PIN was initially requested from the
      user, then request a PIN and retry the operation. This supports some
      biometric devices that fall back to requiring PIN when reading of the
      biometric failed, and devices that require PINs for all hosted
      credentials.
    - sshd(8): implement client address-based rate-limiting via new
      sshd_config(5) PerSourceMaxStartups and PerSourceNetBlockSize
      directives that provide more fine-grained control on a per-origin
      address basis than the global MaxStartups limit.
    - ssh(1): Prefix keyboard interactive prompts with "(user@host)" to make
      it easier to determine which connection they are associated with in
      cases like scp -3, ProxyJump, etc. (closes: #343267).
    - sshd(8): fix sshd_config SetEnv directives located inside Match
      blocks.
    - ssh(1): when requesting a FIDO token touch on stderr, inform the user
      once the touch has been recorded.
    - ssh(1): prevent integer overflow when ridiculously large
      ConnectTimeout values are specified, capping the effective value (for
      most platforms) at 24 days.
    - ssh(1): consider the ECDSA key subtype when ordering host key
      algorithms in the client.
    - ssh(1), sshd(8): rename the PubkeyAcceptedKeyTypes keyword to
      PubkeyAcceptedAlgorithms. The previous name incorrectly suggested that
      it control allowed key algorithms, when this option actually specifies
      the signature algorithms that are accepted. The previous name remains
      available as an alias (closes: #933665).
    - ssh(1), sshd(8): similarly, rename HostbasedKeyTypes (ssh) and
      HostbasedAcceptedKeyTypes (sshd) to HostbasedAcceptedAlgorithms.
    - sftp-server(8): add missing lsetstat@openssh.com documentation and
      advertisement in the server's SSH2_FXP_VERSION hello packet.
    - ssh(1), sshd(8): more strictly enforce KEX state-machine by banning
      packet types once they are received. Fixes memleak caused by duplicate
      SSH2_MSG_KEX_DH_GEX_REQUEST.
    - sftp(1): allow the full range of UIDs/GIDs for chown/chgrp on 32bit
      platforms instead of being limited by LONG_MAX.
    - Minor man page fixes (capitalization, commas, etc.)
    - sftp(1): when doing an sftp recursive upload or download of a
      read-only directory, ensure that the directory is created with write
      and execute permissions in the interim so that the transfer can
      actually complete, then set the directory permission as the final
      step.
    - ssh-keygen(1): document the -Z, check the validity of its argument
      earlier and provide a better error message if it's not correct.
    - ssh(1): ignore comments at the end of config lines in ssh_config,
      similar to what we already do for sshd_config.
    - sshd_config(5): mention that DisableForwarding is valid in a
      sshd_config Match block.
    - sftp(1): fix incorrect sorting of "ls -ltr" under some circumstances.
    - ssh(1), sshd(8): fix potential integer truncation of (unlikely)
      timeout values.
    - ssh(1): make hostbased authentication send the signature algorithm in
      its SSH2_MSG_USERAUTH_REQUEST packets instead of the key type. This
      make HostbasedAcceptedAlgorithms do what it is supposed to - filter on
      signature algorithm and not key type.
    - sshd(8): add a number of platform-specific syscalls to the Linux
      seccomp-bpf sandbox.
    - sshd(8): remove debug message from sigchld handler that could cause
      deadlock on some platforms.
    - Sync contrib/ssh-copy-id with upstream.
  * Remove OpenBSD-specific rdomain references from sshd_config(5) (closes:
    #998069).
  * Define MAXHOSTNAMELEN on GNU/Hurd (thanks, Svante Signell; closes:
    #997030).
  * Build-depend on libelogind-dev as an alternative to libsystemd-dev on
    Linux (thanks, Svante Signell; closes: #997035).
  * Backport from upstream:
    - CVE-2021-41617 (closes: #995130): sshd(8) from OpenSSH 6.2 through 8.7
      failed to correctly initialise supplemental groups when executing an
      AuthorizedKeysCommand or AuthorizedPrincipalsCommand, where a
      AuthorizedKeysCommandUser or AuthorizedPrincipalsCommandUser directive
      has been set to run the command as a different user. Instead these
      commands would inherit the groups that sshd(8) was started with.
  * Configure with ac_cv_func_closefrom=no to avoid an incompatibility with
    glibc 2.34's fallback_closefrom function (thanks, William 'jawn-smith'
    Wilson; LP: #1944621).

 -- Colin Watson <cjwatson@debian.org>  Sat, 06 Nov 2021 12:23:47 +0000

openssh (1:8.4p1-6) unstable; urgency=medium

  [ Colin Watson ]
  * Rename ssh group to _ssh (closes: #990456).  It's only used by
    ssh-agent.
  * debian/tests/regress: Don't fail cleanup if haveged isn't running.
  * Backport from upstream:
    - Add includes.h to compat tests (closes: #992134, LP: #1939751).
  * Use "command -v" in maintainer scripts rather than "which".

  [ Athos Ribeiro ]
  * d/systemd/ssh@.service: preserve the systemd managed runtime directory to
    ensure parallel processes will not disrupt one another when halting
    (LP: #1905285) (closes: #934663)

 -- Colin Watson <cjwatson@debian.org>  Thu, 19 Aug 2021 11:04:01 +0100

openssh (1:8.4p1-5) unstable; urgency=high

  * CVE-2021-28041: Fix double free in ssh-agent(1) (closes: #984940).

 -- Colin Watson <cjwatson@debian.org>  Sat, 13 Mar 2021 09:59:40 +0000

openssh (1:8.4p1-4) unstable; urgency=medium

  * Avoid using libmd's <sha2.h> even if it's installed (closes: #982705).

 -- Colin Watson <cjwatson@debian.org>  Mon, 15 Feb 2021 10:25:17 +0000

openssh (1:8.4p1-3) unstable; urgency=medium

  * Backport from upstream:
    - Fix `EOF: command not found` error in ssh-copy-id (closes: #975540).

 -- Colin Watson <cjwatson@debian.org>  Wed, 02 Dec 2020 10:32:23 +0000

openssh (1:8.4p1-2) unstable; urgency=medium

  * Revert incorrect upstream patch that claimed to fix the seccomp sandbox
    on x32 but in fact broke it instead.

 -- Colin Watson <cjwatson@debian.org>  Mon, 26 Oct 2020 17:41:13 +0000

openssh (1:8.4p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-8.4):
    - [SECURITY] ssh-agent(1): restrict ssh-agent from signing web
      challenges for FIDO/U2F keys.
    - [SECURITY] ssh-keygen(1): Enable FIDO 2.1 credProtect extension when
      generating a FIDO resident key.
    - ssh-keygen(1): the format of the attestation information optionally
      recorded when a FIDO key is generated has changed. It now includes the
      authenticator data needed to validate attestation signatures.
    - The API between OpenSSH and the FIDO token middleware has changed and
      the SSH_SK_VERSION_MAJOR version has been incremented as a result.
      Third-party middleware libraries must support the current API version
      (7) to work with OpenSSH 8.4.
    - ssh(1), ssh-keygen(1): support for FIDO keys that require a PIN for
      each use. These keys may be generated using ssh-keygen using a new
      "verify-required" option. When a PIN-required key is used, the user
      will be prompted for a PIN to complete the signature operation.
    - sshd(8): authorized_keys now supports a new "verify-required" option
      to require FIDO signatures assert that the token verified that the
      user was present before making the signature. The FIDO protocol
      supports multiple methods for user-verification, but currently OpenSSH
      only supports PIN verification.
    - sshd(8), ssh-keygen(1): add support for verifying FIDO webauthn
      signatures. Webauthn is a standard for using FIDO keys in web
      browsers. These signatures are a slightly different format to plain
      FIDO signatures and thus require explicit support.
    - ssh(1): allow some keywords to expand shell-style ${ENV} environment
      variables. The supported keywords are CertificateFile, ControlPath,
      IdentityAgent and IdentityFile, plus LocalForward and RemoteForward
      when used for Unix domain socket paths.
    - ssh(1), ssh-agent(1): allow some additional control over the use of
      ssh-askpass via a new $SSH_ASKPASS_REQUIRE environment variable,
      including forcibly enabling and disabling its use (closes: #368657).
    - ssh(1): allow ssh_config(5)'s AddKeysToAgent keyword accept a time
      limit for keys in addition to its current flag options. Time-limited
      keys will automatically be removed from ssh-agent after their expiry
      time has passed.
    - scp(1), sftp(1): allow the -A flag to explicitly enable agent
      forwarding in scp and sftp. The default remains to not forward an
      agent, even when ssh_config enables it.
    - ssh(1): add a '%k' TOKEN that expands to the effective HostKey of the
      destination. This allows, e.g., keeping host keys in individual files
      using "UserKnownHostsFile ~/.ssh/known_hosts.d/%k" (closes: #481250).
    - ssh(1): add %-TOKEN, environment variable and tilde expansion to the
      UserKnownHostsFile directive, allowing the path to be completed by the
      configuration.
    - ssh-keygen(1): allow "ssh-add -d -" to read keys to be deleted from
      stdin.
    - sshd(8): improve logging for MaxStartups connection throttling.  sshd
      will now log when it starts and stops throttling and periodically
      while in this state.
    - ssh(1), ssh-keygen(1): better support for multiple attached FIDO
      tokens. In cases where OpenSSH cannot unambiguously determine which
      token to direct a request to, the user is now required to select a
      token by touching it. In cases of operations that require a PIN to be
      verified, this avoids sending the wrong PIN to the wrong token and
      incrementing the token's PIN failure counter (tokens effectively erase
      their keys after too many PIN failures).
    - sshd(8): fix Include before Match in sshd_config (LP: #1885990).
    - ssh(1): close stdin/out/error when forking after authentication
      completes ("ssh -f ...").
    - ssh(1), sshd(8): limit the amount of channel input data buffered,
      avoiding peers that advertise large windows but are slow to read from
      causing high memory consumption.
    - ssh-agent(1): handle multiple requests sent in a single write() to the
      agent.
    - sshd(8): allow sshd_config longer than 256k.
    - sshd(8): avoid spurious "Unable to load host key" message when sshd
      load a private key but no public counterpart.
    - ssh(1): prefer the default hostkey algorithm list whenever we have a
      hostkey that matches its best-preference algorithm.
    - sshd(1): when ordering the hostkey algorithms to request from a
      server, prefer certificate types if the known_hosts files contain a
      key marked as a @cert-authority.
    - ssh(1): perform host key fingerprint comparisons for the "Are you sure
      you want to continue connecting (yes/no/[fingerprint])?" prompt with
      case sensitivity.
    - sshd(8): ensure that address/masklen mismatches in sshd_config yield
      fatal errors at daemon start time rather than later when they are
      evaluated.
    - ssh-keygen(1): ensure that certificate extensions are lexically
      sorted. Previously if the user specified a custom extension then the
      everything would be in order except the custom ones.
    - ssh(1): also compare username when checking for JumpHost loops.
    - ssh-keygen(1): preserve group/world read permission on known_hosts
      files across runs of "ssh-keygen -Rf /path". The old behaviour was to
      remove all rights for group/other.
    - ssh-keygen(1): Mention the [-a rounds] flag in the ssh-keygen manual
      page and usage().
    - sshd(8): explicitly construct path to ~/.ssh/rc rather than relying on
      it being relative to the current directory, so that it can still be
      found if the shell startup changes its directory.
    - sshd(8): when redirecting sshd's log output to a file, undo this
      redirection after the session child process is forked(). Fixes missing
      log messages when using this feature under some circumstances.
    - sshd(8): start ClientAliveInterval bookkeeping before first pass
      through select() loop; fixed theoretical case where busy sshd may
      ignore timeouts from client.
    - ssh(1): only reset the ServerAliveInterval check when we receive
      traffic from the server and ignore traffic from a port forwarding
      client, preventing a client from keeping a connection alive when it
      should be terminated.
    - ssh-keygen(1): avoid spurious error message when ssh-keygen creates
      files outside ~/.ssh.
    - sftp-client(1): fix off-by-one error that caused sftp downloads to
      make one more concurrent request that desired. This prevented using
      sftp(1) in unpipelined request/response mode, which is useful when
      debugging.
    - ssh(1), sshd(8): handle EINTR in waitfd() and timeout_connect()
      helpers.
    - ssh(1), ssh-keygen(1): defer creation of ~/.ssh until we attempt to
      write to it so we don't leave an empty .ssh directory when it's not
      needed.
    - ssh(1), sshd(8): fix multiplier when parsing time specifications when
      handling seconds after other units.
    - sshd(8): always send any PAM account messages. If the PAM account
      stack returns any messages, always send them to the user and not just
      if the check succeeds.
    - gnome-ssh-askpass3: ensure the "close" button is not focused by
      default for SSH_ASKPASS_PROMPT=none prompts. Avoids space/enter
      accidentally dismissing FIDO touch notifications.
    - gnome-ssh-askpass3: allow some control over textarea colour via
      $GNOME_SSH_ASKPASS_FG_COLOR and $GNOME_SSH_ASKPASS_BG_COLOR
      environment variables.
    - Detect the Frankenstein monster of Linux/X32 and allow the sandbox to
      function there.

 -- Colin Watson <cjwatson@debian.org>  Tue, 20 Oct 2020 14:15:17 +0100

openssh (1:8.3p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-8.3):
    - [SECURITY] scp(1): when receiving files, scp(1) could become
      desynchronised if a utimes(2) system call failed.  This could allow
      file contents to be interpreted as file metadata and thereby permit an
      adversary to craft a file system that, when copied with scp(1) in a
      configuration that caused utimes(2) to fail (e.g. under a SELinux
      policy or syscall sandbox), transferred different file names and
      contents to the actual file system layout.
    - sftp(1): reject an argument of "-1" in the same way as ssh(1) and
      scp(1) do instead of accepting and silently ignoring it.
    - sshd(8): make IgnoreRhosts a tri-state option: "yes" to ignore
      rhosts/shosts, "no" to allow rhosts/shosts or (new) "shosts-only" to
      allow .shosts files but not .rhosts.
    - sshd(8): allow the IgnoreRhosts directive to appear anywhere in a
      sshd_config, not just before any Match blocks.
    - ssh(1): add %TOKEN percent expansion for the LocalForward and
      RemoteForward keywords when used for Unix domain socket forwarding.
    - all: allow loading public keys from the unencrypted envelope of a
      private key file if no corresponding public key file is present.
    - ssh(1), sshd(8): prefer to use chacha20 from libcrypto where possible
      instead of the (slower) portable C implementation included in OpenSSH.
    - ssh-keygen(1): add ability to dump the contents of a binary key
      revocation list via "ssh-keygen -lQf /path".
    - ssh(1): fix IdentitiesOnly=yes to also apply to keys loaded from a
      PKCS11Provider.
    - ssh-keygen(1): avoid NULL dereference when trying to convert an
      invalid RFC4716 private key.
    - scp(1): when performing remote-to-remote copies using "scp -3", start
      the second ssh(1) channel with BatchMode=yes enabled to avoid
      confusing and non-deterministic ordering of prompts.
    - ssh(1), ssh-keygen(1): when signing a challenge using a FIDO token,
      perform hashing of the message to be signed in the middleware layer
      rather than in OpenSSH code.  This permits the use of security key
      middlewares that perform the hashing implicitly, such as Windows
      Hello.
    - ssh(1): fix incorrect error message for "too many known hosts files."
    - ssh(1): make failures when establishing "Tunnel" forwarding terminate
      the connection when ExitOnForwardFailure is enabled.
    - ssh-keygen(1): fix printing of fingerprints on private keys and add a
      regression test for same.
    - sshd(8): document order of checking AuthorizedKeysFile (first) and
      AuthorizedKeysCommand (subsequently, if the file doesn't match).
    - sshd(8): document that /etc/hosts.equiv and /etc/shosts.equiv are not
      considered for HostbasedAuthentication when the target user is root.
    - ssh(1), ssh-keygen(1): fix NULL dereference in private certificate key
      parsing.
    - ssh(1), sshd(8): more consistency between sets of %TOKENS are accepted
      in various configuration options.
    - ssh(1), ssh-keygen(1): improve error messages for some common PKCS#11
      C_Login failure cases.
    - ssh(1), sshd(8): make error messages for problems during SSH banner
      exchange consistent with other SSH transport-layer error messages and
      ensure they include the relevant IP addresses.
    - ssh-keygen(1), ssh-add(1): when downloading FIDO2 resident keys from a
      token, don't prompt for a PIN until the token has told us that it
      needs one.  Avoids double-prompting on devices that implement
      on-device authentication (closes: #932071).
    - sshd(8), ssh-keygen(1): no-touch-required FIDO certificate option
      should be an extension, not a critical option.
    - ssh(1), ssh-keygen(1), ssh-add(1): offer a better error message when
      trying to use a FIDO key function and SecurityKeyProvider is empty.
    - ssh-add(1), ssh-agent(8): ensure that a key lifetime fits within the
      values allowed by the wire format (u32).  Prevents integer wraparound
      of the timeout values.
    - ssh(1): detect and prevent trivial configuration loops when using
      ProxyJump. bz#3057.
    - On platforms that do not support setting process-wide routing domains
      (all excepting OpenBSD at present), fail to accept a configuration
      attempts to set one at process start time rather than fatally erroring
      at run time.
    - Fix theoretical infinite loop in the glob(3) replacement
      implementation.
  * Update GSSAPI key exchange patch from
    https://github.com/openssh-gsskex/openssh-gsskex:
    - Fix connection through ProxyJump in combination with "GSSAPITrustDNS
      yes".
    - Enable SHA2-based GSSAPI key exchange methods by default as RFC 8732
      was published.
  * Fix or suppress various shellcheck errors under debian/.
  * Use AUTOPKGTEST_TMP rather than the deprecated ADTTMP.
  * Apply upstream patch to fix the handling of Port directives after
    Include (closes: #962035, LP: #1876320).

 -- Colin Watson <cjwatson@debian.org>  Sun, 07 Jun 2020 13:44:04 +0100

openssh (1:8.2p1-4) unstable; urgency=medium

  * Add /etc/ssh/ssh_config.d/ to openssh-client.
  * Add /etc/ssh/sshd_config.d/ to openssh-server (closes: #952427).
  * Install ssh-sk-helper even on non-Linux architectures, though it will
    need an external middleware library in those cases.

 -- Colin Watson <cjwatson@debian.org>  Wed, 26 Feb 2020 10:55:07 +0000

openssh (1:8.2p1-3) unstable; urgency=medium

  * Reupload with -sa to work around confusion with 1:8.2p1-1 being in NEW.

 -- Colin Watson <cjwatson@debian.org>  Sun, 23 Feb 2020 13:30:01 +0000

openssh (1:8.2p1-2) unstable; urgency=medium

  * Move ssh-sk-helper into openssh-client rather than shipping it in a
    separate package.  The extra library dependencies are pretty small, so
    it doesn't seem worth bloating the Packages file.  Suggested by Bastian
    Blank.

 -- Colin Watson <cjwatson@debian.org>  Sun, 23 Feb 2020 11:31:31 +0000

openssh (1:8.2p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-8.2, closes:
    #951582):
    - ssh(1), sshd(8), ssh-keygen(1): this release removes the "ssh-rsa"
      (RSA/SHA1) algorithm from those accepted for certificate signatures
      (i.e. the client and server CASignatureAlgorithms option) and will use
      the rsa-sha2-512 signature algorithm by default when the ssh-keygen(1)
      CA signs new certificates.
    - ssh(1), sshd(8): Remove diffie-hellman-group14-sha1 from the default
      key exchange proposal for both the client and server.
    - ssh-keygen(1): The command-line options related to the generation and
      screening of safe prime numbers used by the
      diffie-hellman-group-exchange-* key exchange algorithms have changed.
      Most options have been folded under the -O flag.
    - sshd(8): The sshd listener process title visible to ps(1) has changed
      to include information about the number of connections that are
      currently attempting authentication and the limits configured by
      MaxStartups.
    - Add support for FIDO/U2F hardware authenticators.
    - ssh-keygen(1): Add a "no-touch-required" option when generating
      FIDO-hosted keys, that disables their default behaviour of requiring a
      physical touch/tap on the token during authentication.  Note: not all
      tokens support disabling the touch requirement.
    - sshd(8): Add a sshd_config PubkeyAuthOptions directive that collects
      miscellaneous public key authentication-related options for sshd(8).
      At present it supports only a single option "no-touch-required".  This
      causes sshd to skip its default check for FIDO/U2F keys that the
      signature was authorised by a touch or press event on the token
      hardware.
    - ssh(1), sshd(8), ssh-keygen(1): Add a "no-touch-required" option for
      authorized_keys and a similar extension for certificates.  This option
      disables the default requirement that FIDO key signatures attest that
      the user touched their key to authorize them, mirroring the similar
      PubkeyAuthOptions sshd_config option.
    - ssh-keygen(1): Add support for the writing the FIDO attestation
      information that is returned when new keys are generated via the "-O
      write-attestation=/path" option.  FIDO attestation certificates may be
      used to verify that a FIDO key is hosted in trusted hardware.  OpenSSH
      does not currently make use of this information, beyond optionally
      writing it to disk.
    - Add support for FIDO2 resident keys.
    - sshd(8): Add an Include sshd_config keyword that allows including
      additional configuration files via glob(3) patterns (closes: #631189).
    - ssh(1)/sshd(8): Make the LE (low effort) DSCP code point available via
      the IPQoS directive.
    - ssh(1): When AddKeysToAgent=yes is set and the key contains no
      comment, add the key to the agent with the key's path as the comment.
    - ssh-keygen(1), ssh-agent(1): Expose PKCS#11 key labels and X.509
      subjects as key comments, rather than simply listing the PKCS#11
      provider library path.
    - ssh-keygen(1): Allow PEM export of DSA and ECDSA keys.
    - sshd(8): When clients get denied by MaxStartups, send a notification
      prior to the SSH2 protocol banner according to RFC4253 section 4.2
      (closes: #275458).
    - ssh(1), ssh-agent(1): When invoking the $SSH_ASKPASS prompt program,
      pass a hint to the program to describe the type of desired prompt.
      The possible values are "confirm" (indicating that a yes/no
      confirmation dialog with no text entry should be shown), "none" (to
      indicate an informational message only), or blank for the original
      ssh-askpass behaviour of requesting a password/phrase.
    - ssh(1): Allow forwarding a different agent socket to the path
      specified by $SSH_AUTH_SOCK, by extending the existing ForwardAgent
      option to accepting an explicit path or the name of an environment
      variable in addition to yes/no.
    - ssh-keygen(1): Add a new signature operations "find-principals" to
      look up the principal associated with a signature from an
      allowed-signers file.
    - sshd(8): Expose the number of currently-authenticating connections
      along with the MaxStartups limit in the process title visible to "ps".
    - sshd(8): Make ClientAliveCountMax=0 have sensible semantics: it will
      now disable connection killing entirely rather than the current
      behaviour of instantly killing the connection after the first liveness
      test regardless of success.
    - sshd(8): Clarify order of AllowUsers / DenyUsers vs AllowGroups /
      DenyGroups in the sshd(8) manual page.
    - sshd(8): Better describe HashKnownHosts in the manual page.
    - sshd(8): Clarify that that permitopen=/PermitOpen do no name or
      address translation in the manual page.
    - sshd(8): Allow the UpdateHostKeys feature to function when multiple
      known_hosts files are in use.  When updating host keys, ssh will now
      search subsequent known_hosts files, but will add updated host keys to
      the first specified file only.
    - All: Replace all calls to signal(2) with a wrapper around
      sigaction(2).  This wrapper blocks all other signals during the
      handler preventing races between handlers, and sets SA_RESTART which
      should reduce the potential for short read/write operations.
    - sftp(1): Fix a race condition in the SIGCHILD handler that could turn
      in to a kill(-1).
    - sshd(8): Fix a case where valid (but extremely large) SSH channel IDs
      were being incorrectly rejected.
    - ssh(1): When checking host key fingerprints as answers to new hostkey
      prompts, ignore whitespace surrounding the fingerprint itself.
    - All: Wait for file descriptors to be readable or writeable during
      non-blocking connect, not just readable.  Prevents a timeout when the
      server doesn't immediately send a banner (e.g. multiplexers like
      sslh).
    - sshd_config(5): Document the sntrup4591761x25519-sha512@tinyssh.org
      key exchange algorithm.
  * Add more historical md5sums of /etc/ssh/sshd_config between 1:7.4p1-1
    and 1:7.8p1-1 inclusive (closes: #951220).
  * ssh(1): Explain that -Y is equivalent to -X in the default configuration
    (closes: #951640).
  * Include /etc/ssh/ssh_config.d/*.conf from /etc/ssh/ssh_config and
    /etc/ssh/sshd_config.d/*.conf from /etc/ssh/sshd_config (closes:
    #845315).

 -- Colin Watson <cjwatson@debian.org>  Fri, 21 Feb 2020 16:36:37 +0000

openssh (1:8.1p1-5) unstable; urgency=medium

  * Apply upstream patches to allow clock_nanosleep() and variants in the
    seccomp sandbox, fixing failures with glibc 2.31.
  * Apply upstream patch to deny (non-fatally) ipc in the seccomp sandbox,
    fixing failures with OpenSSL 1.1.1d and Linux < 3.19 on some
    architectures (closes: #946242).

 -- Colin Watson <cjwatson@debian.org>  Sat, 11 Jan 2020 23:55:03 +0000

openssh (1:8.1p1-4) unstable; urgency=medium

  * Apply upstream patch to stop using 2020 as a future date in regress
    tests.

 -- Colin Watson <cjwatson@debian.org>  Thu, 09 Jan 2020 11:42:10 +0000

openssh (1:8.1p1-3) unstable; urgency=medium

  [ Colin Watson ]
  * Drop suggestion of rssh, since it's been removed (see
    https://bugs.debian.org/923691).

  [ Steve Langasek ]
  * Don't build openssh-tests on Ubuntu i386 (closes: #948466).

 -- Colin Watson <cjwatson@debian.org>  Thu, 09 Jan 2020 00:29:58 +0000

openssh (1:8.1p1-2) unstable; urgency=medium

  * Drop "Allow flock and ipc syscall for s390 architecture" patch for now;
    upstream has security concerns with it and it doesn't currently seem to
    be needed.
  * Mark openssh-sftp-server, openssh-tests, ssh, and ssh-askpass-gnome as
    Multi-Arch: foreign; none of them provide any architecture-dependent
    interfaces.

 -- Colin Watson <cjwatson@debian.org>  Wed, 11 Dec 2019 23:53:49 +0000

openssh (1:8.1p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-8.1):
    - ssh(1), sshd(8), ssh-agent(1): Add protection for private keys at rest
      in RAM against speculation and memory side-channel attacks like
      Spectre, Meltdown and Rambleed.  This release encrypts private keys
      when they are not in use with a symmetric key that is derived from a
      relatively large "prekey" consisting of random data (currently 16KB).
    - ssh(1): Allow %n to be expanded in ProxyCommand strings.
    - ssh(1), sshd(8): Allow prepending a list of algorithms to the default
      set by starting the list with the '^' character, e.g.
      "HostKeyAlgorithms ^ssh-ed25519".
    - ssh-keygen(1): Add an experimental lightweight signature and
      verification ability.  Signatures may be made using regular ssh keys
      held on disk or stored in a ssh-agent and verified against an
      authorized_keys-like list of allowed keys.  Signatures embed a
      namespace that prevents confusion and attacks between different usage
      domains (e.g. files vs email).
    - ssh-keygen(1): Print key comment when extracting public key from a
      private key.
    - ssh-keygen(1): Accept the verbose flag when searching for host keys in
      known hosts (i.e. "ssh-keygen -vF host") to print the matching host's
      random-art signature too.
    - All: Support PKCS8 as an optional format for storage of private keys
      to disk.  The OpenSSH native key format remains the default, but PKCS8
      is a superior format to PEM if interoperability with non-OpenSSH
      software is required, as it may use a less insecure key derivation
      function than PEM's.
    - ssh(1): If a PKCS#11 token returns no keys then try to login and
      refetch them.
    - ssh(1): Produce a useful error message if the user's shell is set
      incorrectly during "match exec" processing.
    - sftp(1): Allow the maximum uint32 value for the argument passed to -b
      which allows better error messages from later validation.
    - ssh-keyscan(1): Include SHA2-variant RSA key algorithms in KEX
      proposal; allows ssh-keyscan to harvest keys from servers that disable
      old SHA1 ssh-rsa.
    - sftp(1): Print explicit "not modified" message if a file was requested
      for resumed download but was considered already complete.
    - sftp(1): Fix a typo and make <esc><right> move right to the closest
      end of a word just like <esc><left> moves left to the closest
      beginning of a word.
    - sshd(8): Cap the number of permitopen/permitlisten directives allowed
      to appear on a single authorized_keys line.
    - All: Fix a number of memory leaks (one-off or on exit paths).
    - ssh(1), sshd(8): Check for convtime() refusing to accept times that
      resolve to LONG_MAX.
    - ssh(1): Slightly more instructive error message when the user
      specifies multiple -J options on the command-line (closes: #929669).
    - ssh-agent(1): Process agent requests for RSA certificate private keys
      using correct signature algorithm when requested.
    - sftp(1): Check for user@host when parsing sftp target.  This allows
      user@[1.2.3.4] to work without a path.
    - sshd(8): Enlarge format buffer size for certificate serial number so
      the log message can record any 64-bit integer without truncation.
    - sshd(8): For PermitOpen violations add the remote host and port to be
      able to more easily ascertain the source of the request.  Add the same
      logging for PermitListen violations which were not previously logged
      at all.
    - scp(1), sftp(1): Use the correct POSIX format style for left
      justification for the transfer progress meter.
    - sshd(8): When examining a configuration using sshd -T, assume any
      attribute not provided by -C does not match, which allows it to work
      when sshd_config contains a Match directive with or without -C.
    - ssh(1), ssh-keygen(1): Downgrade PKCS#11 "provider returned no slots"
      warning from log level error to debug.  This is common when attempting
      to enumerate keys on smartcard readers with no cards plugged in.
    - ssh(1), ssh-keygen(1): Do not unconditionally log in to PKCS#11
      tokens.  Avoids spurious PIN prompts for keys not selected for
      authentication in ssh(1) and when listing public keys available in a
      token using ssh-keygen(1).
    - ssh(1), sshd(8): Fix typo that prevented detection of Linux VRF.
    - sshd(8): In the Linux seccomp-bpf sandbox, allow mprotect(2) with
      PROT_(READ|WRITE|NONE) only.  This syscall is used by some hardened
      heap allocators.
    - sshd(8): In the Linux seccomp-bpf sandbox, allow the s390-specific
      ioctl for ECC hardware support.
  * Re-enable hardening on hppa, since the corresponding GCC bug is
    apparently fixed.

 -- Colin Watson <cjwatson@debian.org>  Thu, 10 Oct 2019 10:23:19 +0100

openssh (1:8.0p1-7) unstable; urgency=medium

  [ Daniel Kahn Gillmor ]
  * runit: Correct typo in comment.

  [ Colin Watson ]
  * Apply upstream patch to deny (non-fatally) shmget/shmat/shmdt in preauth
    privsep child, coping with changes in OpenSSL 1.1.1d that broke OpenSSH
    on Linux kernels before 3.19 (closes: #941663).

 -- Colin Watson <cjwatson@debian.org>  Sat, 05 Oct 2019 22:41:11 +0100

openssh (1:8.0p1-6) unstable; urgency=medium

  * Only run dh_runit on openssh-server (closes: #935936).

 -- Colin Watson <cjwatson@debian.org>  Wed, 28 Aug 2019 10:53:18 +0100

openssh (1:8.0p1-5) unstable; urgency=medium

  [ Lorenzo Puliti ]
  * Add a runscript for runit (closes: #933999).

 -- Colin Watson <cjwatson@debian.org>  Tue, 27 Aug 2019 15:18:54 +0100

openssh (1:8.0p1-4) unstable; urgency=medium

  * Use debhelper-compat instead of debian/compat.
  * debian/*.apport:
    - Remove #! lines.
    - Avoid star imports.
    - Fix flake8 errors.
  * Run regression tests against the Python 3 version of Twisted Conch.

 -- Colin Watson <cjwatson@debian.org>  Sat, 03 Aug 2019 13:33:24 +0100

openssh (1:8.0p1-3) unstable; urgency=medium

  * Upload to unstable.

 -- Colin Watson <cjwatson@debian.org>  Mon, 08 Jul 2019 17:19:37 +0100

openssh (1:8.0p1-2) experimental; urgency=medium

  * Fix interop tests for recent regress changes.

 -- Colin Watson <cjwatson@debian.org>  Fri, 14 Jun 2019 14:32:12 +0100

openssh (1:8.0p1-1) experimental; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-8.0, closes:
    #927792):
    - ssh(1), ssh-agent(1), ssh-add(1): Add support for ECDSA keys in
      PKCS#11 tokens (LP: #1665695).
    - ssh(1), sshd(8): Add experimental quantum-computing resistant key
      exchange method, based on a combination of Streamlined NTRU Prime
      4591^761 and X25519.
    - ssh-keygen(1): Increase the default RSA key size to 3072 bits,
      following NIST Special Publication 800-57's guidance for a 128-bit
      equivalent symmetric security level (LP: #1445625).
    - ssh(1): Allow "PKCS11Provider=none" to override later instances of the
      PKCS11Provider directive in ssh_config.
    - sshd(8): Add a log message for situations where a connection is
      dropped for attempting to run a command but a sshd_config
      ForceCommand=internal-sftp restriction is in effect.
    - ssh(1): When prompting whether to record a new host key, accept the
      key fingerprint as a synonym for "yes".  This allows the user to paste
      a fingerprint obtained out of band at the prompt and have the client
      do the comparison for you.
    - ssh-keygen(1): When signing multiple certificates on a single
      command-line invocation, allow automatically incrementing the
      certificate serial number.
    - scp(1), sftp(1): Accept -J option as an alias to ProxyJump on the scp
      and sftp command-lines.
    - ssh-agent(1), ssh-pkcs11-helper(8), ssh-add(1): Accept "-v"
      command-line flags to increase the verbosity of output; pass verbose
      flags though to subprocesses, such as ssh-pkcs11-helper started from
      ssh-agent.
    - ssh-add(1): Add a "-T" option to allowing testing whether keys in an
      agent are usable by performing a signature and a verification.
    - sftp-server(8): Add a "lsetstat@openssh.com" protocol extension that
      replicates the functionality of the existing SSH2_FXP_SETSTAT
      operation but does not follow symlinks.
    - sftp(1): Add "-h" flag to chown/chgrp/chmod commands to request they
      do not follow symlinks.
    - sshd(8): Expose $SSH_CONNECTION in the PAM environment.  This makes
      the connection 4-tuple available to PAM modules that wish to use it in
      decision-making.
    - sshd(8): Add a ssh_config "Match final" predicate.  Matches in same
      pass as "Match canonical" but doesn't require hostname
      canonicalisation be enabled.
    - sftp(1): Support a prefix of '@' to suppress echo of sftp batch
      commands.
    - ssh-keygen(1): When printing certificate contents using "ssh-keygen
      -Lf /path/certificate", include the algorithm that the CA used to sign
      the cert.
    - sshd(8): Fix authentication failures when sshd_config contains
      "AuthenticationMethods any" inside a Match block that overrides a more
      restrictive default.
    - sshd(8): Avoid sending duplicate keepalives when ClientAliveCount is
      enabled.
    - sshd(8): Fix two race conditions related to SIGHUP daemon restart.
      Remnant file descriptors in recently-forked child processes could
      block the parent sshd's attempt to listen(2) to the configured
      addresses.  Also, the restarting parent sshd could exit before any
      child processes that were awaiting their re-execution state had
      completed reading it, leaving them in a fallback path.
    - ssh(1): Fix stdout potentially being redirected to /dev/null when
      ProxyCommand=- was in use.
    - sshd(8): Avoid sending SIGPIPE to child processes if they attempt to
      write to stderr after their parent processes have exited.
    - ssh(1): Fix bad interaction between the ssh_config ConnectTimeout and
      ConnectionAttempts directives - connection attempts after the first
      were ignoring the requested timeout (LP: #1798049).
    - ssh-keyscan(1): Return a non-zero exit status if no keys were found
      (closes: #374980, LP: #1661745).
    - scp(1): Sanitize scp filenames to allow UTF-8 characters without
      terminal control sequences.
    - sshd(8): Fix confusion between ClientAliveInterval and time-based
      RekeyLimit that could cause connections to be incorrectly closed.
    - ssh(1), ssh-add(1): Correct some bugs in PKCS#11 token PIN handling at
      initial token login.  The attempt to read the PIN could be skipped in
      some cases, particularly on devices with integrated PIN readers.  This
      would lead to an inability to retrieve keys from these tokens.
    - ssh(1), ssh-add(1): Support keys on PKCS#11 tokens that set the
      CKA_ALWAYS_AUTHENTICATE flag by requring a fresh login after the
      C_SignInit operation.
    - ssh(1): Improve documentation for ProxyJump/-J, clarifying that local
      configuration does not apply to jump hosts.
    - ssh-keygen(1): Clarify manual - ssh-keygen -e only writes public keys,
      not private.
    - ssh(1), sshd(8): be more strict in processing protocol banners,
      allowing \r characters only immediately before \n.
    - Various: fix a number of memory leaks.
    - scp(1), sftp(1): fix calculation of initial bandwidth limits.  Account
      for bytes written before the timer starts and adjust the schedule on
      which recalculations are performed.  Avoids an initial burst of
      traffic and yields more accurate bandwidth limits.
    - sshd(8): Only consider the ext-info-c extension during the initial key
      eschange.  It shouldn't be sent in subsequent ones, but if it is
      present we should ignore it.  This prevents sshd from sending a
      SSH_MSG_EXT_INFO for REKEX for these buggy clients.
    - ssh-keygen(1): Clarify manual that ssh-keygen -F (find host in
      authorized_keys) and -R (remove host from authorized_keys) options may
      accept either a bare hostname or a [hostname]:port combo.
    - ssh(1): Don't attempt to connect to empty SSH_AUTH_SOCK.
    - sshd(8): Silence error messages when sshd fails to load some of the
      default host keys.  Failure to load an explicitly-configured hostkey
      is still an error, and failure to load any host key is still fatal.
    - ssh(1): Redirect stderr of ProxyCommands to /dev/null when ssh is
      started with ControlPersist; prevents random ProxyCommand output from
      interfering with session output.
    - ssh(1): The ssh client was keeping a redundant ssh-agent socket
      (leftover from authentication) around for the life of the connection.
    - sshd(8): Fix bug in HostbasedAcceptedKeyTypes and
      PubkeyAcceptedKeyTypes options.  If only RSA-SHA2 signature types were
      specified, then authentication would always fail for RSA keys as the
      monitor checks only the base key (not the signature algorithm) type
      against *AcceptedKeyTypes.
    - ssh(1): Request correct signature types from ssh-agent when
      certificate keys and RSA-SHA2 signatures are in use.
    - sshd(8): Don't set $MAIL if UsePAM=yes as PAM typically specifies the
      user environment if it's enabled (closes: #189920, #532754).
  * Mostly resynced GSSAPI key exchange patch with Fedora.  Major changes:
    - Support selection of GSSAPI key exchange algorithms.
    - Support GSSAPI key exchange methods with DH and SHA2.
    - Support GSSAPI key exchange using ECDH and SHA2.
    - Make sure the Kerberos tickets are cleaned up with the user context.
    - Enable gssapi-keyex authentication without gssapi-with-mic.
    - Allow querying for GSSAPI key exchange algorithms from ssh (-Q
      kex-gss).
  * Apply upstream patch to fix the utimensat regression tests when not
    using the compatibility implementation.

 -- Colin Watson <cjwatson@debian.org>  Sun, 09 Jun 2019 22:47:27 +0100

openssh (1:7.9p1-10) unstable; urgency=medium

  * Temporarily revert IPQoS defaults to pre-7.8 values until issues with
    "iptables -m tos" and VMware have been fixed (closes: #923879, #926229;
    LP: #1822370).

 -- Colin Watson <cjwatson@debian.org>  Mon, 08 Apr 2019 11:13:04 +0100

openssh (1:7.9p1-9) unstable; urgency=medium

  * Apply upstream patch to make scp handle shell-style brace expansions
    when checking that filenames sent by the server match what the client
    requested (closes: #923486).

 -- Colin Watson <cjwatson@debian.org>  Fri, 01 Mar 2019 12:23:36 +0000

openssh (1:7.9p1-8) unstable; urgency=medium

  [ Colin Watson ]
  * Apply upstream patch to fix bug in HostbasedAcceptedKeyTypes and
    PubkeyAcceptedKeyTypes options in the case where only RSA-SHA2 signature
    types were specified.
  * Apply upstream patch to request RSA-SHA2 signatures for
    rsa-sha2-{256|512}-cert-v01@openssh.com cert algorithms (closes:
    #923419).
  * Move moduli(5) manual page to openssh-server to go with /etc/ssh/moduli;
    forgotten in 1:7.9p1-5.

  [ Dominik George ]
  * Correctly handle conffile move to openssh-server (closes: #919344).

 -- Colin Watson <cjwatson@debian.org>  Thu, 28 Feb 2019 19:31:49 +0000

openssh (1:7.9p1-7) unstable; urgency=medium

  * Recommend "default-logind | logind | libpam-systemd" rather than just
    libpam-systemd (closes: #923199).  (I've retained libpam-systemd as an
    alternative for a while to avoid backporting accidents, although it can
    be removed later.)
  * Pass "--exec /usr/sbin/sshd" to start-stop-daemon on stop as well as
    start and pass "--chuid 0:0" on start, to avoid problems with non-root
    groups leaking into the ownership of /run/sshd.pid (closes: #922365).

 -- Colin Watson <cjwatson@debian.org>  Tue, 26 Feb 2019 15:13:23 +0000

openssh (1:7.9p1-6) unstable; urgency=medium

  * CVE-2019-6109: Apply upstream patches to sanitize scp filenames via
    snmprintf (closes: #793412).
  * CVE-2019-6111: Apply upstream patch to check in scp client that
    filenames sent during remote->local directory copies satisfy the
    wildcard specified by the user.

 -- Colin Watson <cjwatson@debian.org>  Fri, 08 Feb 2019 16:26:35 +0000

openssh (1:7.9p1-5) unstable; urgency=high

  * Move /etc/ssh/moduli to openssh-server, since it's reasonably large and
    only used by sshd (closes: #858050).
  * Drop obsolete alternate build-dependency on libssl1.0-dev (closes:
    #917342).
  * CVE-2018-20685: Apply upstream scp patch to disallow empty incoming
    filename or ones that refer to the current directory (closes: #919101).

 -- Colin Watson <cjwatson@debian.org>  Sun, 13 Jan 2019 11:22:45 +0000

openssh (1:7.9p1-4) unstable; urgency=medium

  * Fix Ubuntu detection in debian/rules, since the documentation comment
    for dpkg_vendor_derives_from is wrong (thanks, Jeremy Bicha; see
    #913816).

 -- Colin Watson <cjwatson@debian.org>  Fri, 16 Nov 2018 11:27:28 +0000

openssh (1:7.9p1-3) unstable; urgency=medium

  * Be more specific about what files to install in openssh-tests, to avoid
    installing a symlink into the build tree.
  * Re-export debian/upstream/signing-key.asc without extra signatures.
  * Restore direct test dependencies on openssl, putty-tools, and
    python-twisted-conch; these are really only indirect dependencies via
    openssh-tests, but including them means that this package will be
    retested when they change.

 -- Colin Watson <cjwatson@debian.org>  Thu, 15 Nov 2018 01:30:56 +0000

openssh (1:7.9p1-2) unstable; urgency=medium

  * Add GitLab CI configuration.
  * Make the autopkgtest create /run/sshd if it doesn't already exist.
  * Drop "set -x" verbosity from the autopkgtest; I think we can do without
    this in most cases nowadays.
  * Add an openssh-tests binary package containing enough files to run the
    upstream regression tests.  This allows autopkgtest to run more
    efficiently, as it doesn't have to build part of the source tree again.

 -- Colin Watson <cjwatson@debian.org>  Wed, 14 Nov 2018 15:55:48 +0000

openssh (1:7.9p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-7.9):
    - ssh(1), sshd(8): allow most port numbers to be specified using service
      names from getservbyname(3) (typically /etc/services; closes:
      #177406).
    - ssh(1): allow the IdentityAgent configuration directive to accept
      environment variable names.  This supports the use of multiple agent
      sockets without needing to use fixed paths.
    - sshd(8): support signalling sessions via the SSH protocol.  A limited
      subset of signals is supported and only for login or command sessions
      (i.e. not subsystems) that were not subject to a forced command via
      authorized_keys or sshd_config.
    - ssh(1): support "ssh -Q sig" to list supported signature options.
      Also "ssh -Q help" to show the full set of supported queries.
    - ssh(1), sshd(8): add a CASignatureAlgorithms option for the client and
      server configs to allow control over which signature formats are
      allowed for CAs to sign certificates.  For example, this allows
      banning CAs that sign certificates using the RSA-SHA1 signature
      algorithm.
    - sshd(8), ssh-keygen(1): allow key revocation lists (KRLs) to revoke
      keys specified by SHA256 hash.
    - ssh-keygen(1): allow creation of key revocation lists directly from
      base64-encoded SHA256 fingerprints.  This supports revoking keys using
      only the information contained in sshd(8) authentication log messages.
    - ssh(1), ssh-keygen(1): avoid spurious "invalid format" errors when
      attempting to load PEM private keys while using an incorrect
      passphrase.
    - sshd(8): when a channel closed message is received from a client,
      close the stderr file descriptor at the same time stdout is closed.
      This avoids stuck processes if they were waiting for stderr to close
      and were insensitive to stdin/out closing (closes: #844494).
    - ssh(1): allow ForwardX11Timeout=0 to disable the untrusted X11
      forwarding timeout and support X11 forwarding indefinitely.
      Previously the behaviour of ForwardX11Timeout=0 was undefined.
    - sshd(8): when compiled with GSSAPI support, cache supported method
      OIDs regardless of whether GSSAPI authentication is enabled in the
      main section of sshd_config.  This avoids sandbox violations if GSSAPI
      authentication was later enabled in a Match block.
    - sshd(8): do not fail closed when configured with a text key revocation
      list that contains a too-short key.
    - ssh(1): treat connections with ProxyJump specified the same as ones
      with a ProxyCommand set with regards to hostname canonicalisation
      (i.e. don't try to canonicalise the hostname unless
      CanonicalizeHostname is set to 'always').
    - ssh(1): fix regression in OpenSSH 7.8 that could prevent public-key
      authentication using certificates hosted in a ssh-agent(1) or against
      sshd(8) from OpenSSH <7.8 (LP: #1790963).
    - All: support building against the openssl-1.1 API (releases 1.1.0g and
      later).  The openssl-1.0 API will remain supported at least until
      OpenSSL terminates security patch support for that API version
      (closes: #828475).
    - sshd(8): allow the futex(2) syscall in the Linux seccomp sandbox;
      apparently required by some glibc/OpenSSL combinations.
  * Remove dh_builddeb override to use xz compression; this has been the
    default since dpkg 1.17.0.
  * Simplify debian/rules using /usr/share/dpkg/default.mk.
  * Remove /etc/network/if-up.d/openssh-server, as it causes more problems
    than it solves (thanks, Christian Ehrhardt, Andreas Hasenack, and David
    Britton; closes: #789532, LP: #1037738, #1674330, #1718227).  Add an
    "if-up hook removed" section to README.Debian documenting the corner
    case that may need configuration adjustments.

 -- Colin Watson <cjwatson@debian.org>  Sun, 21 Oct 2018 10:39:24 +0100

openssh (1:7.8p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-7.8, closes:
    #907534):
    - ssh-keygen(1): Write OpenSSH format private keys by default instead of
      using OpenSSL's PEM format (closes: #905407).  The OpenSSH format,
      supported in OpenSSH releases since 2014 and described in the
      PROTOCOL.key file in the source distribution, offers substantially
      better protection against offline password guessing and supports key
      comments in private keys.  If necessary, it is possible to write old
      PEM-style keys by adding "-m PEM" to ssh-keygen's arguments when
      generating or updating a key.
    - sshd(8): Remove internal support for S/Key multiple factor
      authentication.  S/Key may still be used via PAM or BSD auth.
    - ssh(1): Remove vestigial support for running ssh(1) as setuid.  This
      used to be required for hostbased authentication and the (long gone)
      rhosts-style authentication, but has not been necessary for a long
      time.  Attempting to execute ssh as a setuid binary, or with uid !=
      effective uid will now yield a fatal error at runtime.
    - sshd(8): The semantics of PubkeyAcceptedKeyTypes and the similar
      HostbasedAcceptedKeyTypes options have changed.  These now specify
      signature algorithms that are accepted for their respective
      authentication mechanism, where previously they specified accepted key
      types.  This distinction matters when using the RSA/SHA2 signature
      algorithms "rsa-sha2-256", "rsa-sha2-512" and their certificate
      counterparts.  Configurations that override these options but omit
      these algorithm names may cause unexpected authentication failures (no
      action is required for configurations that accept the default for
      these options).
    - sshd(8): The precedence of session environment variables has changed.
      ~/.ssh/environment and environment="..." options in authorized_keys
      files can no longer override SSH_* variables set implicitly by sshd.
    - ssh(1)/sshd(8): The default IPQoS used by ssh/sshd has changed.  They
      will now use DSCP AF21 for interactive traffic and CS1 for bulk.  For
      a detailed rationale, please see the commit message:
      https://cvsweb.openbsd.org/src/usr.bin/ssh/readconf.c#rev1.284
    - ssh(1)/sshd(8): Add new signature algorithms "rsa-sha2-256-cert-
      v01@openssh.com" and "rsa-sha2-512-cert-v01@openssh.com" to explicitly
      force use of RSA/SHA2 signatures in authentication.
    - sshd(8): Extend the PermitUserEnvironment option to accept a whitelist
      of environment variable names in addition to global "yes" or "no"
      settings.
    - sshd(8): Add a PermitListen directive to sshd_config(5) and a
      corresponding permitlisten= authorized_keys option that control which
      listen addresses and port numbers may be used by remote forwarding
      (ssh -R ...).
    - sshd(8): Add some countermeasures against timing attacks used for
      account validation/enumeration.  sshd will enforce a minimum time or
      each failed authentication attempt consisting of a global 5ms minimum
      plus an additional per-user 0-4ms delay derived from a host secret.
    - sshd(8): Add a SetEnv directive to allow an administrator to
      explicitly specify environment variables in sshd_config.  Variables
      set by SetEnv override the default and client-specified environment.
    - ssh(1): Add a SetEnv directive to request that the server sets an
      environment variable in the session.  Similar to the existing SendEnv
      option, these variables are set subject to server configuration.
    - ssh(1): Allow "SendEnv -PATTERN" to clear environment variables
      previously marked for sending to the server (closes: #573316).
    - ssh(1)/sshd(8): Make UID available as a %-expansion everywhere that
      the username is available currently.
    - ssh(1): Allow setting ProxyJump=none to disable ProxyJump
      functionality.
    - sshd(8): Avoid observable differences in request parsing that could be
      used to determine whether a target user is valid.
    - ssh(1)/sshd(8): Fix some memory leaks.
    - ssh(1): Fix a pwent clobber (introduced in openssh-7.7) that could
      occur during key loading, manifesting as crash on some platforms.
    - sshd_config(5): Clarify documentation for AuthenticationMethods
      option.
    - ssh(1): Ensure that the public key algorithm sent in a public key
      SSH_MSG_USERAUTH_REQUEST matches the content of the signature blob.
      Previously, these could be inconsistent when a legacy or non-OpenSSH
      ssh-agent returned a RSA/SHA1 signature when asked to make a RSA/SHA2
      signature.
    - sshd(8): Fix failures to read authorized_keys caused by faulty
      supplemental group caching.
    - scp(1): Apply umask to directories, fixing potential mkdir/chmod race
      when copying directory trees.
    - ssh-keygen(1): Return correct exit code when searching for and hashing
      known_hosts entries in a single operation.
    - ssh(1): Prefer the ssh binary pointed to via argv[0] to $PATH when
      re-executing ssh for ProxyJump.
    - sshd(8): Do not ban PTY allocation when a sshd session is restricted
      because the user password is expired as it breaks password change
      dialog.
    - ssh(1)/sshd(8): Fix error reporting from select() failures.
    - ssh(1): Improve documentation for -w (tunnel) flag, emphasising that
      -w implicitly sets Tunnel=point-to-point.
    - ssh-agent(1): Implement EMFILE mitigation for ssh-agent.  ssh-agent
      will no longer spin when its file descriptor limit is exceeded.
    - ssh(1)/sshd(8): Disable SSH2_MSG_DEBUG messages for Twisted Conch
      clients.  Twisted Conch versions that lack a version number in their
      identification strings will mishandle these messages when running on
      Python 2.x (https://twistedmatrix.com/trac/ticket/9422).
    - sftp(1): Notify user immediately when underlying ssh process dies
      expectedly.
    - ssh(1)/sshd(8): Fix tunnel forwarding; regression in 7.7 release.
    - ssh-agent(1): Don't kill ssh-agent's listening socket entirely if it
      fails to accept(2) a connection.
    - ssh(1): Add some missing options in the configuration dump output (ssh
      -G).
    - sshd(8): Expose details of completed authentication to PAM auth
      modules via SSH_AUTH_INFO_0 in the PAM environment.
  * Switch debian/watch to HTTPS.
  * Temporarily work around https://twistedmatrix.com/trac/ticket/9515 in
    regression tests.

 -- Colin Watson <cjwatson@debian.org>  Thu, 30 Aug 2018 15:35:27 +0100

openssh (1:7.7p1-4) unstable; urgency=high

  * CVE-2018-15473: Apply upstream patch to delay bailout for invalid
    authenticating user until after the packet containing the request has
    been fully parsed (closes: #906236).

 -- Colin Watson <cjwatson@debian.org>  Fri, 17 Aug 2018 14:09:32 +0100

openssh (1:7.7p1-3) unstable; urgency=medium

  [ Colin Watson ]
  * Adjust git-dpm tagging configuration.
  * Remove no-longer-used Lintian overrides from openssh-server and ssh.
  * Add Documentation keys to ssh-agent.service, ssh.service, and
    ssh@.service.

  [ Juri Grabowski ]
  * Add rescue.target with ssh support.

  [ Christian Ehrhardt ]
  * Fix unintentional restriction of authorized keys environment options
    to be alphanumeric (closes: #903474, LP: #1771011).

 -- Colin Watson <cjwatson@debian.org>  Tue, 10 Jul 2018 16:07:16 +0100

openssh (1:7.7p1-2) unstable; urgency=medium

  * Fix parsing of DebianBanner option (closes: #894730).

 -- Colin Watson <cjwatson@debian.org>  Wed, 04 Apr 2018 00:47:29 +0100

openssh (1:7.7p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-7.7):
    - ssh(1)/sshd(8): Drop compatibility support for some very old SSH
      implementations, including ssh.com <=2.* and OpenSSH <= 3.*.  These
      versions were all released in or before 2001 and predate the final SSH
      RFCs.  The support in question isn't necessary for RFC-compliant SSH
      implementations.
    - Add experimental support for PQC XMSS keys (Extended Hash-Based
      Signatures).
    - sshd(8): Add an "rdomain" criterion for the sshd_config Match keyword
      to allow conditional configuration that depends on which routing
      domain a connection was received on.
    - sshd_config(5): Add an optional rdomain qualifier to the ListenAddress
      directive to allow listening on different routing domains.
    - sshd(8): Add "expiry-time" option for authorized_keys files to allow
      for expiring keys.
    - ssh(1): Add a BindInterface option to allow binding the outgoing
      connection to an interface's address (basically a more usable
      BindAddress; closes: #289592).
    - ssh(1): Expose device allocated for tun/tap forwarding via a new %T
      expansion for LocalCommand.  This allows LocalCommand to be used to
      prepare the interface.
    - sshd(8): Expose the device allocated for tun/tap forwarding via a new
      SSH_TUNNEL environment variable.  This allows automatic setup of the
      interface and surrounding network configuration automatically on the
      server.
    - ssh(1)/scp(1)/sftp(1): Add URI support to ssh, sftp and scp, e.g.
      ssh://user@host or sftp://user@host/path.  Additional connection
      parameters described in draft-ietf-secsh-scp-sftp-ssh-uri-04 are not
      implemented since the ssh fingerprint format in the draft uses the
      deprecated MD5 hash with no way to specify any other algorithm.
    - ssh-keygen(1): Allow certificate validity intervals that specify only
      a start or stop time (instead of both or neither).
    - sftp(1): Allow "cd" and "lcd" commands with no explicit path argument.
      lcd will change to the local user's home directory as usual.  cd will
      change to the starting directory for session (because the protocol
      offers no way to obtain the remote user's home directory).
    - sshd(8): When doing a config test with sshd -T, only require the
      attributes that are actually used in Match criteria rather than (an
      incomplete list of) all criteria.
    - ssh(1)/sshd(8): More strictly check signature types during key
      exchange against what was negotiated.  Prevents downgrade of RSA
      signatures made with SHA-256/512 to SHA-1.
    - sshd(8): Fix support for client that advertise a protocol version of
      "1.99" (indicating that they are prepared to accept both SSHv1 and
      SSHv2).  This was broken in OpenSSH 7.6 during the removal of SSHv1
      support.
    - ssh(1): Warn when the agent returns a ssh-rsa (SHA1) signature when a
      rsa-sha2-256/512 signature was requested.  This condition is possible
      when an old or non-OpenSSH agent is in use.
    - ssh-agent(1): Fix regression introduced in 7.6 that caused ssh-agent
      to fatally exit if presented an invalid signature request message.
    - sshd_config(5): Accept yes/no flag options case-insensitively, as has
      been the case in ssh_config(5) for a long time (LP: #1656557).
    - ssh(1): Improve error reporting for failures during connection.  Under
      some circumstances misleading errors were being shown.
    - ssh-keyscan(1): Add -D option to allow printing of results directly in
      SSHFP format.
    - ssh(1): Compatibility fix for some servers that erroneously drop the
      connection when the IUTF8 (RFC8160) option is sent.
    - scp(1): Disable RemoteCommand and RequestTTY in the ssh session
      started by scp (sftp was already doing this).
    - ssh-keygen(1): Refuse to create a certificate with an unusable number
      of principals.
    - ssh-keygen(1): Fatally exit if ssh-keygen is unable to write all the
      public key during key generation.  Previously it would silently ignore
      errors writing the comment and terminating newline.
    - ssh(1): Do not modify hostname arguments that are addresses by
      automatically forcing them to lower-case.  Instead canonicalise them
      jo resolve ambiguities (e.g. ::0001 => ::1) before they are matched
      against known_hosts.
    - ssh(1): Don't accept junk after "yes" or "no" responses to hostkey
      prompts.
    - sftp(1): Have sftp print a warning about shell cleanliness when
      decoding the first packet fails, which is usually caused by shells
      polluting stdout of non-interactive startups.
    - ssh(1)/sshd(8): Switch timers in packet code from using wall-clock
      time to monotonic time, allowing the packet layer to better function
      over a clock step and avoiding possible integer overflows during
      steps.
    - sshd(8): Correctly detect MIPS ABI in use at configure time.  Fixes
      sandbox violations on some environments.
    - Build and link with "retpoline" flags when available to mitigate the
      "branch target injection" style (variant 2) of the Spectre
      branch-prediction vulnerability.

 -- Colin Watson <cjwatson@debian.org>  Tue, 03 Apr 2018 12:40:24 +0100

openssh (1:7.6p1-5) unstable; urgency=medium

  * Explicitly build-depend on pkg-config, rather than implicitly
    build-depending on it via libgtk-3-dev (thanks, Aurelien Jarno; closes:
    #894558).

 -- Colin Watson <cjwatson@debian.org>  Sun, 01 Apr 2018 21:37:19 +0100

openssh (1:7.6p1-4) unstable; urgency=medium

  * Move VCS to salsa.debian.org.
  * Add a preseeding-only openssh-server/password-authentication debconf
    template that can be used to disable password authentication (closes:
    #878945).

 -- Colin Watson <cjwatson@debian.org>  Sat, 10 Feb 2018 02:31:46 +0000

openssh (1:7.6p1-3) unstable; urgency=medium

  [ Colin Watson ]
  * Remove the decade-old ssh-krb5 transitional package; upgrades of
    openssh-server will preserve existing configuration, and new
    installations should just enable GSSAPIAuthentication and
    GSSAPIKeyExchange in sshd_config (closes: #878626).
  * Support the "noudeb" build profile.
  * Fix putty-transfer regression test.

  [ Anders Kaseorg ]
  * debian/systemd/ssh-agent.service: Add missing dbus dependency.

  [ Jason Duerstock ]
  * Add a "pkg.openssh.nognome" build profile, which disables building the
    ssh-askpass-gnome binary package and avoids the build-dependency on
    libgtk-3-dev (closes: #883819).

 -- Colin Watson <cjwatson@debian.org>  Tue, 16 Jan 2018 17:41:08 +0000

openssh (1:7.6p1-2) unstable; urgency=medium

  * Apply upstream patch to fix PermitOpen argument handling.

 -- Colin Watson <cjwatson@debian.org>  Sat, 07 Oct 2017 13:44:13 +0100

openssh (1:7.6p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-7.6):
    - CVE-2017-15906: sftp-server(8): In read-only mode, sftp-server was
      incorrectly permitting creation of zero-length files. Reported by
      Michal Zalewski.
    - ssh(1): Delete SSH protocol version 1 support, associated
      configuration options and documentation (LP: #1584321).
    - ssh(1)/sshd(8): Remove support for the hmac-ripemd160 MAC.
    - ssh(1)/sshd(8): Remove support for the arcfour, blowfish and CAST
      ciphers.
    - Refuse RSA keys <1024 bits in length and improve reporting for keys
      that do not meet this requirement.
    - ssh(1): Do not offer CBC ciphers by default.
    - ssh(1): Add RemoteCommand option to specify a command in the ssh
      config file instead of giving it on the client's command line.  This
      allows the configuration file to specify the command that will be
      executed on the remote host.
    - sshd(8): Add ExposeAuthInfo option that enables writing details of the
      authentication methods used (including public keys where applicable)
      to a file that is exposed via a $SSH_USER_AUTH environment variable in
      the subsequent session.
    - ssh(1): Add support for reverse dynamic forwarding.  In this mode, ssh
      will act as a SOCKS4/5 proxy and forward connections to destinations
      requested by the remote SOCKS client.  This mode is requested using
      extended syntax for the -R and RemoteForward options and, because it
      is implemented solely at the client, does not require the server be
      updated to be supported.
    - sshd(8): Allow LogLevel directive in sshd_config Match blocks.
    - ssh-keygen(1): Allow inclusion of arbitrary string or flag certificate
      extensions and critical options.
    - ssh-keygen(1): Allow ssh-keygen to use a key held in ssh-agent as a CA
      when signing certificates.
    - ssh(1)/sshd(8): Allow IPQoS=none in ssh/sshd to not set an explicit
      ToS/DSCP value and just use the operating system default.
    - ssh-add(1): Add -q option to make ssh-add quiet on success.
    - ssh(1): Expand the StrictHostKeyChecking option with two new settings.
      The first "accept-new" will automatically accept hitherto-unseen keys
      but will refuse connections for changed or invalid hostkeys.  This is
      a safer subset of the current behaviour of StrictHostKeyChecking=no.
      The second setting "off", is a synonym for the current behaviour of
      StrictHostKeyChecking=no: accept new host keys, and continue
      connection for hosts with incorrect hostkeys.  A future release will
      change the meaning of StrictHostKeyChecking=no to the behaviour of
      "accept-new".
    - ssh(1): Add SyslogFacility option to ssh(1) matching the equivalent
      option in sshd(8).
    - ssh(1): Use HostKeyAlias if specified instead of hostname for matching
      host certificate principal names.
    - sftp(1): Implement sorting for globbed ls.
    - ssh(1): Add a user@host prefix to client's "Permission denied"
      messages, useful in particular when using "stacked" connections (e.g.
      ssh -J) where it's not clear which host is denying.
    - ssh(1): Accept unknown EXT_INFO extension values that contain \0
      characters.  These are legal, but would previously cause fatal
      connection errors if received.
    - sftp(1): Print '?' instead of incorrect link count (that the protocol
      doesn't provide) for remote listings.
    - ssh(1): Return failure rather than fatal() for more cases during
      session multiplexing negotiations.  Causes the session to fall back to
      a non-mux connection if they occur.
    - ssh(1): Mention that the server may send debug messages to explain
      public key authentication problems under some circumstances.
    - Translate OpenSSL error codes to better report incorrect passphrase
      errors when loading private keys.
    - sshd(8): Adjust compatibility patterns for WinSCP to correctly
      identify versions that implement only the legacy DH group exchange
      scheme (closes: #877800).
    - ssh(1): Print the "Killed by signal 1" message only at LogLevel
      verbose so that it is not shown at the default level; prevents it from
      appearing during ssh -J and equivalent ProxyCommand configs.
    - ssh-keygen(1): When generating all hostkeys (ssh-keygen -A), clobber
      existing keys if they exist but are zero length.  Zero-length keys
      could previously be made if ssh-keygen failed or was interrupted part
      way through generating them.
    - ssh-keyscan(1): Avoid double-close() on file descriptors.
    - sshd(8): Avoid reliance on shared use of pointers shared between
      monitor and child sshd processes.
    - sshd_config(8): Document available AuthenticationMethods.
    - ssh(1): Avoid truncation in some login prompts.
    - ssh(1): Make "--" before the hostname terminate argument processing
      after the hostname too (closes: #873201).
    - ssh-keygen(1): Switch from aes256-cbc to aes256-ctr for encrypting
      new-style private keys.
    - ssh(1): Warn and do not attempt to use keys when the public and
      private halves do not match.
    - sftp(1): Don't print verbose error message when ssh disconnects from
      under sftp.
    - sshd(8): Fix keepalive scheduling problem: prevent activity on a
      forwarded port from preventing the keepalive from being sent.
    - sshd(8): When started without root privileges, don't require the
      privilege separation user or path to exist.
    - ssh(1)/sshd(8): Correctness fix for channels implementation: accept
      channel IDs greater than 0x7FFFFFFF.
    - sshd(8): Expose list of completed authentication methods to PAM via
      the SSH_AUTH_INFO_0 PAM environment variable.
    - ssh(1)/sshd(8): Fix several problems in the tun/tap forwarding code,
      mostly to do with host/network byte order confusion.
    - sshd(8): Avoid Linux seccomp violations on ppc64le over the socketcall
      syscall.
  * Build-depend on debhelper (>= 9.20160709~) rather than dh-systemd.
  * Change priorities of ssh and ssh-krb5 binary packages to optional, since
    "Priority: extra" is now deprecated.
  * Use HTTPS form of copyright-format URL.
  * Adjust "Running sshd from inittab" instructions in README.Debian to
    recommend using service(8) rather than calling the init script directly.
  * Policy version 4.1.0.
  * Adjust "Per-connection sshd instances with systemd" instructions in
    README.Debian to recommend using a drop-in file rather than copying and
    modifying the ssh.socket unit file.

 -- Colin Watson <cjwatson@debian.org>  Fri, 06 Oct 2017 12:36:48 +0100

openssh (1:7.5p1-10) unstable; urgency=medium

  * Tell haveged to create the pid file we expect.
  * Give up and use systemctl to start haveged if running under systemd;
    this shouldn't be necessary, but I can't seem to get things working in
    the Ubuntu autopkgtest environment otherwise.

 -- Colin Watson <cjwatson@debian.org>  Fri, 01 Sep 2017 11:17:19 +0100

openssh (1:7.5p1-9) unstable; urgency=medium

  * Run debian/tests/regress with "set -x".
  * Run haveged without "-w 1024", as setting the low water mark doesn't
    seem possible in all autopkgtest virtualisation environments.

 -- Colin Watson <cjwatson@debian.org>  Thu, 31 Aug 2017 13:23:04 +0100

openssh (1:7.5p1-8) unstable; urgency=medium

  * Drop openssh-client-ssh1, now built by a separate source package.
  * Run haveged during autopkgtests to ensure that they have enough entropy
    for key generation (LP: #1712921).
  * Apply patches from https://bugzilla.mindrot.org/show_bug.cgi?id=2752 to
    allow some extra syscalls for crypto cards on s390x (LP: #1686618).

 -- Colin Watson <cjwatson@debian.org>  Mon, 28 Aug 2017 12:16:35 +0100

openssh (1:7.5p1-7) unstable; urgency=medium

  * Fix spelling of RuntimeDirectoryMode (closes: #872976).
  * Add RuntimeDirectory and RuntimeDirectoryMode to ssh@.service as well as
    ssh.service (closes: #872978).

 -- Colin Watson <cjwatson@debian.org>  Wed, 23 Aug 2017 12:12:59 +0100

openssh (1:7.5p1-6) unstable; urgency=medium

  [ Colin Watson ]
  * Test configuration before starting or reloading sshd under systemd
    (closes: #865770).
  * Create /run/sshd under systemd using RuntimeDirectory rather than
    tmpfiles.d (thanks, Dmitry Smirnov; closes: #864190).

  [ Dimitri John Ledkov ]
  * Drop upstart system and user jobs (closes: #872851).

  [ Chris Lamb ]
  * Quote IP address in suggested "ssh-keygen -f" calls (closes: #872643).

 -- Colin Watson <cjwatson@debian.org>  Wed, 23 Aug 2017 01:41:06 +0100

openssh (1:7.5p1-5) unstable; urgency=medium

  * Upload to unstable.
  * Fix syntax error in debian/copyright.

 -- Colin Watson <cjwatson@debian.org>  Sun, 18 Jun 2017 12:08:42 +0100

openssh (1:7.5p1-4) experimental; urgency=medium

  * Drop README.Debian section on privilege separation, as it's no longer
    optional.
  * Only call "initctl set-env" from agent-launch if $UPSTART_SESSION is set
    (LP: #1689299).
  * Fix incoming compression statistics (thanks, Russell Coker; closes:
    #797964).
  * Relicense debian/* under a two-clause BSD licence for bidirectional
    compatibility with upstream, with permission from Matthew Vernon and
    others.

 -- Colin Watson <cjwatson@debian.org>  Tue, 06 Jun 2017 15:17:58 +0100

openssh (1:7.5p1-3) experimental; urgency=medium

  * Fix debian/adjust-openssl-dependencies to account for preferring
    libssl1.0-dev.
  * Adjust OpenSSL dependencies for openssh-client-ssh1 too.
  * Fix purge failure when /etc/ssh has already somehow been removed
    (LP: #1682817).
  * Ensure that /etc/ssh exists before trying to create /etc/ssh/sshd_config
    (LP: #1685022).

 -- Colin Watson <cjwatson@debian.org>  Tue, 02 May 2017 13:51:27 +0100

openssh (1:7.5p1-2) experimental; urgency=medium

  * Add missing header on Linux/s390.
  * Fix syntax error on Linux/X32.

 -- Colin Watson <cjwatson@debian.org>  Sun, 02 Apr 2017 13:20:11 +0100

openssh (1:7.5p1-1) experimental; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-7.5):
    - SECURITY: ssh(1), sshd(8): Fix weakness in CBC padding oracle
      countermeasures that allowed a variant of the attack fixed in OpenSSH
      7.3 to proceed.  Note that the OpenSSH client disables CBC ciphers by
      default, sshd offers them as lowest-preference options and will remove
      them by default entirely in the next release.
    - This release deprecates the sshd_config UsePrivilegeSeparation option,
      thereby making privilege separation mandatory (closes: #407754).
    - The format of several log messages emitted by the packet code has
      changed to include additional information about the user and their
      authentication state.  Software that monitors ssh/sshd logs may need
      to account for these changes.
    - ssh(1), sshd(8): Support "=-" syntax to easily remove methods from
      algorithm lists, e.g. Ciphers=-*cbc.
    - sshd(1): Fix NULL dereference crash when key exchange start messages
      are sent out of sequence.
    - ssh(1), sshd(8): Allow form-feed characters to appear in configuration
      files.
    - sshd(8): Fix regression in OpenSSH 7.4 support for the server-sig-algs
      extension, where SHA2 RSA signature methods were not being correctly
      advertised.
    - ssh(1), ssh-keygen(1): Fix a number of case-sensitivity bugs in
      known_hosts processing.
    - ssh(1): Allow ssh to use certificates accompanied by a private key
      file but no corresponding plain *.pub public key.
    - ssh(1): When updating hostkeys using the UpdateHostKeys option, accept
      RSA keys if HostkeyAlgorithms contains any RSA keytype.  Previously,
      ssh could ignore RSA keys when only the ssh-rsa-sha2-* methods were
      enabled in HostkeyAlgorithms and not the old ssh-rsa method.
    - ssh(1): Detect and report excessively long configuration file lines.
    - Merge a number of fixes found by Coverity and reported via Redhat and
      FreeBSD.  Includes fixes for some memory and file descriptor leaks in
      error paths.
    - ssh(1), sshd(8): When logging long messages to stderr, don't truncate
      "\r\n" if the length of the message exceeds the buffer.
    - ssh(1): Fully quote [host]:port in generated ProxyJump/-J command-
      line; avoid confusion over IPv6 addresses and shells that treat square
      bracket characters specially.
    - Fix various fallout and sharp edges caused by removing SSH protocol 1
      support from the server, including the server banner string being
      incorrectly terminated with only \n (instead of \r\n), confusing error
      messages from ssh-keyscan, and a segfault in sshd if protocol v.1 was
      enabled for the client and sshd_config contained references to legacy
      keys.
    - ssh(1), sshd(8): Free fd_set on connection timeout.
    - sftp(1): Fix division by zero crash in "df" output when server returns
      zero total filesystem blocks/inodes.
    - ssh(1), ssh-add(1), ssh-keygen(1), sshd(8): Translate OpenSSL errors
      encountered during key loading to more meaningful error codes.
    - ssh-keygen(1): Sanitise escape sequences in key comments sent to
      printf but preserve valid UTF-8 when the locale supports it.
    - ssh(1), sshd(8): Return reason for port forwarding failures where
      feasible rather than always "administratively prohibited".
    - sshd(8): Fix deadlock when AuthorizedKeysCommand or
      AuthorizedPrincipalsCommand produces a lot of output and a key is
      matched early.
    - ssh(1): Fix typo in ~C error message for bad port forward
      cancellation.
    - ssh(1): Show a useful error message when included config files can't
      be opened.
    - sshd_config(5): Repair accidentally-deleted mention of %k token in
      AuthorizedKeysCommand.
    - sshd(8): Remove vestiges of previously removed LOGIN_PROGRAM.
    - ssh-agent(1): Relax PKCS#11 whitelist to include libexec and common
      32-bit compatibility library directories.
    - sftp-client(1): Fix non-exploitable integer overflow in SSH2_FXP_NAME
      response handling.
    - ssh-agent(1): Fix regression in 7.4 of deleting PKCS#11-hosted keys.
      It was not possible to delete them except by specifying their full
      physical path.
    - sshd(8): Avoid sandbox errors for Linux S390 systems using an ICA
      crypto coprocessor.
    - sshd(8): Fix non-exploitable weakness in seccomp-bpf sandbox arg
      inspection.
    - ssh-keygen(1), ssh(1), sftp(1): Fix output truncation for various that
      contain non-printable characters where the codeset in use is ASCII.

 -- Colin Watson <cjwatson@debian.org>  Sun, 02 Apr 2017 02:58:01 +0100

openssh (1:7.4p1-11) unstable; urgency=medium

  * Fix incoming compression statistics (thanks, Russell Coker; closes:
    #797964).

 -- Colin Watson <cjwatson@debian.org>  Tue, 06 Jun 2017 15:03:48 +0100

openssh (1:7.4p1-10) unstable; urgency=medium

  * Move privilege separation directory and PID file from /var/run/ to /run/
    (closes: #760422, #856825).
  * Unbreak Unix domain socket forwarding for root (closes: #858252).

 -- Colin Watson <cjwatson@debian.org>  Thu, 30 Mar 2017 11:19:04 +0100

openssh (1:7.4p1-9) unstable; urgency=medium

  * Fix null pointer dereference in ssh-keygen; this fixes an autopkgtest
    regression introduced in 1:7.4p1-8.

 -- Colin Watson <cjwatson@debian.org>  Thu, 16 Mar 2017 13:43:15 +0000

openssh (1:7.4p1-8) unstable; urgency=medium

  * Fix ssh-keygen -H accidentally corrupting known_hosts that contained
    already-hashed entries (closes: #851734, LP: #1668093).
  * Fix ssh-keyscan to correctly hash hosts with a port number (closes:
    #857736, LP: #1670745).

 -- Colin Watson <cjwatson@debian.org>  Tue, 14 Mar 2017 13:49:14 +0000

openssh (1:7.4p1-7) unstable; urgency=medium

  * Don't set "PermitRootLogin yes" on fresh installations (regression
    introduced in 1:7.4p1-1; closes: #852781).
  * Restore reading authorized_keys2 by default.  Upstream seems to intend
    to gradually phase this out, so don't assume that this will remain the
    default forever.  However, we were late in adopting the upstream
    sshd_config changes, so it makes sense to extend the grace period
    (closes: #852320).

 -- Colin Watson <cjwatson@debian.org>  Sun, 05 Mar 2017 02:12:42 +0000

openssh (1:7.4p1-6) unstable; urgency=medium

  * Remove temporary file on exit from postinst (closes: #850275).
  * Remove LOGIN_PROGRAM and LOGIN_NO_ENDOPT definitions, since UseLogin is
    gone.
  * Document sshd_config changes that may be needed following the removal of
    protocol 1 support from sshd (closes: #851573).
  * Remove ssh_host_dsa_key from HostKey default (closes: #850614).
  * Fix rekeying failure with GSSAPI key exchange (thanks, Harald Barth;
    closes: #819361, LP: #1608965).

 -- Colin Watson <cjwatson@debian.org>  Mon, 16 Jan 2017 15:11:10 +0000

openssh (1:7.4p1-5) unstable; urgency=medium

  * Create mux socket for regression tests in a temporary directory.
  * Work around clock_gettime kernel bug on Linux x32 (closes: #849923).

 -- Colin Watson <cjwatson@debian.org>  Tue, 03 Jan 2017 14:43:28 +0000

openssh (1:7.4p1-4) unstable; urgency=medium

  * Run regression tests inside annotate-output to try to diagnose timeout
    issues.
  * Make integrity tests more robust against timeouts in the case where the
    first test in a series for a given MAC happens to modify the low bytes
    of a packet length.
  * Fix race conditions in forwarding tests.

 -- Colin Watson <cjwatson@debian.org>  Mon, 02 Jan 2017 19:37:23 +0000

openssh (1:7.4p1-3) unstable; urgency=medium

  * Revert attempted hack around regress/forwarding.sh test failure, since
    it doesn't seem to help.
  * Run regression tests using 'sh -x' to try to get more information about
    failures.
  * Dump some useful log files if regression tests fail.
  * Tweak regression test setup to cope with the case where some of the
    source directory is unreadable by the openssh-tests user.

 -- Colin Watson <cjwatson@debian.org>  Sat, 31 Dec 2016 02:48:17 +0000

openssh (1:7.4p1-2) unstable; urgency=medium

  * Attempt to hack around regress/forwarding.sh test failure in some
    environments.
  * Avoid calling into Kerberos libraries from ssh_gssapi_server_mechanisms
    in the privsep monitor.

 -- Colin Watson <cjwatson@debian.org>  Thu, 29 Dec 2016 12:02:12 +0000

openssh (1:7.4p1-1) unstable; urgency=medium

  * New upstream release (http://www.openssh.com/txt/release-7.4):
    - ssh(1): Remove 3des-cbc from the client's default proposal.  64-bit
      block ciphers are not safe in 2016 and we don't want to wait until
      attacks like SWEET32 are extended to SSH.  As 3des-cbc was the only
      mandatory cipher in the SSH RFCs, this may cause problems connecting
      to older devices using the default configuration, but it's highly
      likely that such devices already need explicit configuration for key
      exchange and hostkey algorithms already anyway.
    - sshd(8): When a forced-command appears in both a certificate and an
      authorized keys/principals command= restriction, sshd will now refuse
      to accept the certificate unless they are identical.  The previous
      (documented) behaviour of having the certificate forced-command
      override the other could be a bit confusing and error-prone.
    - sshd(8): Remove the UseLogin configuration directive and support for
      having /bin/login manage login sessions.
    - CVE-2016-10009: ssh-agent(1): Will now refuse to load PKCS#11 modules
      from paths outside a trusted whitelist (run-time configurable).
      Requests to load modules could be passed via agent forwarding and an
      attacker could attempt to load a hostile PKCS#11 module across the
      forwarded agent channel: PKCS#11 modules are shared libraries, so this
      would result in code execution on the system running the ssh-agent if
      the attacker has control of the forwarded agent-socket (on the host
      running the sshd server) and the ability to write to the filesystem of
      the host running ssh-agent (usually the host running the ssh client)
      (closes: #848714).
    - CVE-2016-10010: sshd(8): When privilege separation is disabled,
      forwarded Unix-domain sockets would be created by sshd(8) with the
      privileges of 'root' instead of the authenticated user.  This release
      refuses Unix-domain socket forwarding when privilege separation is
      disabled (Privilege separation has been enabled by default for 14
      years) (closes: #848715).
    - CVE-2016-10011: sshd(8): Avoid theoretical leak of host private key
      material to privilege-separated child processes via realloc() when
      reading keys.  No such leak was observed in practice for normal-sized
      keys, nor does a leak to the child processes directly expose key
      material to unprivileged users (closes: #848716).
    - CVE-2016-10012: sshd(8): The shared memory manager used by
      pre-authentication compression support had a bounds checks that could
      be elided by some optimising compilers.  Additionally, this memory
      manager was incorrectly accessible when pre-authentication compression
      was disabled.  This could potentially allow attacks against the
      privileged monitor process from the sandboxed privilege-separation
      process (a compromise of the latter would be required first).  This
      release removes support for pre-authentication compression from
      sshd(8) (closes: #848717).
    - SECURITY: sshd(8): Validate address ranges for AllowUser and DenyUsers
      directives at configuration load time and refuse to accept invalid
      ones.  It was previously possible to specify invalid CIDR address
      ranges (e.g. user@127.1.2.3/55) and these would always match, possibly
      resulting in granting access where it was not intended.
    - ssh(1): Add a proxy multiplexing mode to ssh(1) inspired by the
      version in PuTTY by Simon Tatham.  This allows a multiplexing client
      to communicate with the master process using a subset of the SSH
      packet and channels protocol over a Unix-domain socket, with the main
      process acting as a proxy that translates channel IDs, etc.  This
      allows multiplexing mode to run on systems that lack file-descriptor
      passing (used by current multiplexing code) and potentially, in
      conjunction with Unix-domain socket forwarding, with the client and
      multiplexing master process on different machines.  Multiplexing proxy
      mode may be invoked using "ssh -O proxy ...".
    - sshd(8): Add a sshd_config DisableForwarding option that disables X11,
      agent, TCP, tunnel and Unix domain socket forwarding, as well as
      anything else we might implement in the future.  Like the 'restrict'
      authorized_keys flag, this is intended to be a simple and future-proof
      way of restricting an account.
    - sshd(8), ssh(1): Support the "curve25519-sha256" key exchange method.
      This is identical to the currently-supported method named
      "curve25519-sha256@libssh.org".
    - sshd(8): Improve handling of SIGHUP by checking to see if sshd is
      already daemonised at startup and skipping the call to daemon(3) if it
      is.  This ensures that a SIGHUP restart of sshd(8) will retain the
      same process-ID as the initial execution.  sshd(8) will also now
      unlink the PidFile prior to SIGHUP restart and re-create it after a
      successful restart, rather than leaving a stale file in the case of a
      configuration error.
    - sshd(8): Allow ClientAliveInterval and ClientAliveCountMax directives
      to appear in sshd_config Match blocks.
    - sshd(8): Add %-escapes to AuthorizedPrincipalsCommand to match those
      supported by AuthorizedKeysCommand (key, key type, fingerprint, etc.)
      and a few more to provide access to the contents of the certificate
      being offered.
    - ssh(1): Allow IdentityFile to successfully load and use certificates
      that have no corresponding bare public key.
    - ssh(1): Fix public key authentication when multiple authentication is
      in use and publickey is not just the first method attempted.
    - ssh(1): Improve reporting when attempting to load keys from PKCS#11
      tokens with fewer useless log messages and more detail in debug
      messages.
    - ssh(1): When tearing down ControlMaster connections, don't pollute
      stderr when LogLevel=quiet.
    - sftp(1): On ^Z wait for underlying ssh(1) to suspend before suspending
      sftp(1) to ensure that ssh(1) restores the terminal mode correctly if
      suspended during a password prompt.
    - ssh(1): Avoid busy-wait when ssh(1) is suspended during a password
      prompt (LP: #1646813).
    - ssh(1), sshd(8): Correctly report errors during sending of ext-info
      messages.
    - sshd(8): Fix NULL-deref crash if sshd(8) received an out-of-sequence
      NEWKEYS message.
    - sshd(8): Correct list of supported signature algorithms sent in the
      server-sig-algs extension.
    - sshd(8): Fix sending ext_info message if privsep is disabled.
    - sshd(8): More strictly enforce the expected ordering of privilege
      separation monitor calls used for authentication and allow them only
      when their respective authentication methods are enabled in the
      configuration.
    - sshd_config(5): Use 2001:db8::/32, the official IPv6 subnet for
      configuration examples.
    - On environments configured with Turkish locales, fall back to the
      C/POSIX locale to avoid errors in configuration parsing caused by that
      locale's unique handling of the letters 'i' and 'I' (LP: #1638338).
    - contrib: Add a gnome-ssh-askpass3 with GTK+3 support.
    - sshd(8): Improve PRNG reseeding across privilege separation and force
      libcrypto to obtain a high-quality seed before chroot or sandboxing.
  * Apply "wrap-and-sort -at -f debian/control -f debian/tests/control".
  * Remove entries related to protocol 1 from the default sshd_config
    generated on new installations.
  * Remove some advice related to protocol 1 from README.Debian.
  * Start handling /etc/ssh/sshd_config using ucf.  The immediate motivation
    for this is to deal with deprecations of options related to protocol 1,
    but something like this has been needed for a long time (closes:
    #419574, #848089):
    - sshd_config is now a slightly-patched version of upstream's, and only
      contains non-default settings (closes: #147201).
    - I've included as many historical md5sums of default versions of
      sshd_config as I could reconstruct from version control, but I'm sure
      I've missed some.
    - Explicitly synchronise the debconf database with the current
      configuration file state in openssh-server.config, to ensure that the
      PermitRootLogin setting is properly preserved.
    - UsePrivilegeSeparation now defaults to the stronger "sandbox" rather
      than "yes", per upstream.
  * Remove redundant "GSSAPIDelegateCredentials no" from ssh_config (already
    the upstream default), and document that setting ServerAliveInterval to
    300 by default if BatchMode is set is Debian-specific (closes: #765630).
  * Build gnome-ssh-askpass with GTK+ 3 (LP: #801187).
  * When running regression tests under autopkgtest, use a non-root user
    with passwordless sudo.

 -- Colin Watson <cjwatson@debian.org>  Tue, 27 Dec 2016 18:01:46 +0000

openssh (1:7.3p1-5) unstable; urgency=medium

  * debian/tests/control: Add dependency on openssl, required by the PuTTY
    interoperability tests.

 -- Colin Watson <cjwatson@debian.org>  Sat, 03 Dec 2016 03:43:21 +0000

openssh (1:7.3p1-4) unstable; urgency=medium

  * Adjust Build-Depends further to avoid considering libssl-dev >= 1.1.0~
    as sufficient.
  * Move build directories under debian/.
  * Remove the non-upstream .gitignore file and add the relevant entries to
    debian/.gitignore, in order to make the source tree more
    dgit-compatible.
  * Build all upstream regression test binaries using the new
    "regress-binaries" target.
  * Fix and enable PuTTY interoperability tests under autopkgtest.

 -- Colin Watson <cjwatson@debian.org>  Fri, 02 Dec 2016 20:49:30 +0000

openssh (1:7.3p1-3) unstable; urgency=medium

  * Avoid building with OpenSSL 1.1 for now (see #828475).
  * Add a missing License line to debian/copyright.
  * Policy version 3.9.8: no changes required.

 -- Colin Watson <cjwatson@debian.org>  Sat, 05 Nov 2016 15:37:15 +0000

openssh (1:7.3p1-2) unstable; urgency=high

  * Rewrite debian/copyright using copyright-format 1.0.
  * CVE-2016-8858: Unregister the KEXINIT handler after message has been
    received (closes: #841884).

 -- Colin Watson <cjwatson@debian.org>  Mon, 24 Oct 2016 11:18:00 +0100

openssh (1:7.3p1-1) unstable; urgency=medium

  * New upstream release (http://www.openssh.com/txt/release-7.3):
    - SECURITY: sshd(8): Mitigate a potential denial-of-service attack
      against the system's crypt(3) function via sshd(8).  An attacker could
      send very long passwords that would cause excessive CPU use in
      crypt(3).  sshd(8) now refuses to accept password authentication
      requests of length greater than 1024 characters.
    - SECURITY: ssh(1), sshd(8): Fix observable timing weakness in the CBC
      padding oracle countermeasures.  Note that CBC ciphers are disabled by
      default and only included for legacy compatibility.
    - SECURITY: ssh(1), sshd(8): Improve operation ordering of MAC
      verification for Encrypt-then-MAC (EtM) mode transport MAC algorithms
      to verify the MAC before decrypting any ciphertext.  This removes the
      possibility of timing differences leaking facts about the plaintext,
      though no such leakage has been observed.
    - ssh(1): Add a ProxyJump option and corresponding -J command-line flag
      to allow simplified indirection through a one or more SSH bastions or
      "jump hosts".
    - ssh(1): Add an IdentityAgent option to allow specifying specific agent
      sockets instead of accepting one from the environment.
    - ssh(1): Allow ExitOnForwardFailure and ClearAllForwardings to be
      optionally overridden when using ssh -W.
    - ssh(1), sshd(8): Implement support for the IUTF8 terminal mode as per
      draft-sgtatham-secsh-iutf8-00 (closes: #337041, LP: #394570).
    - ssh(1), sshd(8): Add support for additional fixed Diffie-Hellman 2K,
      4K and 8K groups from draft-ietf-curdle-ssh-kex-sha2-03.
    - ssh-keygen(1), ssh(1), sshd(8): Support SHA256 and SHA512 RSA
      signatures in certificates.
    - ssh(1): Add an Include directive for ssh_config(5) files (closes:
      #536031).
    - ssh(1): Permit UTF-8 characters in pre-authentication banners sent
      from the server.
    - ssh(1), sshd(8): Reduce the syslog level of some relatively common
      protocol events from LOG_CRIT.
    - sshd(8): Refuse AuthenticationMethods="" in configurations and accept
      AuthenticationMethods=any for the default behaviour of not requiring
      multiple authentication.
    - sshd(8): Remove obsolete and misleading "POSSIBLE BREAK-IN ATTEMPT!"
      message when forward and reverse DNS don't match.
    - ssh(1): Deduplicate LocalForward and RemoteForward entries to fix
      failures when both ExitOnForwardFailure and hostname canonicalisation
      are enabled.
    - sshd(8): Remove fallback from moduli to obsolete "primes" file that
      was deprecated in 2001 (LP: #1528251).
    - sshd_config(5): Correct description of UseDNS: it affects ssh hostname
      processing for authorized_keys, not known_hosts.
    - sshd(8): Send ClientAliveInterval pings when a time-based RekeyLimit
      is set; previously keepalive packets were not being sent.
    - sshd(8): Whitelist more architectures to enable the seccomp-bpf
      sandbox.
    - scp(1): Respect the local user's LC_CTYPE locale (closes: #396295).
    - Take character display widths into account for the progressmeter
      (closes: #407088).

 -- Colin Watson <cjwatson@debian.org>  Sun, 07 Aug 2016 22:45:26 +0100

openssh (1:7.2p2-8) unstable; urgency=medium

  [ Colin Watson ]
  * Stop enabling ssh-session-cleanup.service by default; instead, ship it
    as an example and add a section to README.Debian.  libpam-systemd >= 230
    and "UsePAM yes" should take care of the original problem for most
    systemd users (thanks, Michael Biebl; closes: #832155).

  [ Martin Pitt ]
  * Add debian/agent-launch: Helper script for conditionally starting the SSH
    agent in the user session. Use it in ssh-agent.user-session.upstart.
  * Add systemd user unit for graphical sessions that use systemd. Override
    the corresponding upstart job in that case (closes: #832445).
  * debian/openssh-server.if-up: Don't block on a finished reload of
    openssh.service, to avoid deadlocking with restarting networking.
    (closes: #832557, LP: #1584393)

 -- Colin Watson <cjwatson@debian.org>  Fri, 29 Jul 2016 02:51:32 +0100

openssh (1:7.2p2-7) unstable; urgency=medium

  * Don't stop the ssh-session-cleanup service on upgrade (closes: #832155).
    This may cause SSH sessions to be killed on upgrade to *this* version if
    you had previously installed 1:7.2p2-6.  Sorry!  If your session is
    killed, you can recover using "dpkg --unpack" on this openssh-server
    .deb, followed by "dpkg --configure -a".
  * Recommend libpam-systemd from openssh-server.  It's a much better
    solution than the above for systemd users, but I'm wary of depending on
    it in case I cause an assortment of exciting dependency problems on
    upgrade for non-systemd users.

 -- Colin Watson <cjwatson@debian.org>  Sat, 23 Jul 2016 11:46:33 +0100

openssh (1:7.2p2-6) unstable; urgency=medium

  * debian/watch: Switch to HTTP (thanks, Nicholas Luedtke; closes:
    #822997).
  * Copy summary of supported SFTP protocol versions from upstream's
    PROTOCOL file into the openssh-sftp-server package description (closes:
    #766887).
  * Set SSH_PROGRAM=/usr/bin/ssh1 when building openssh-client-ssh1 so that
    scp1 works (reported by Olivier MATZ).
  * Retroactively add a NEWS.Debian entry for the UseDNS change in 6.9 (see
    LP #1588457).
  * CVE-2016-6210: Mitigate user enumeration via covert timing channel
    (closes: #831902).
  * Backport upstream patch to close ControlPersist background process
    stderr when not in debug mode or when logging to a file or syslog
    (closes: #714526).
  * Add a session cleanup script and a systemd unit file to trigger it,
    which serves to terminate SSH sessions cleanly if systemd doesn't do
    that itself, often because libpam-systemd is not installed (thanks,
    Vivek Das Mohapatra, Tom Hutter, and others; closes: #751636).
  * Stop generating DSA host keys by default (thanks, Santiago Vila; closes:
    #823827).

 -- Colin Watson <cjwatson@debian.org>  Fri, 22 Jul 2016 17:06:19 +0100

openssh (1:7.2p2-5) unstable; urgency=medium

  * Backport upstream patch to unbreak authentication using lone certificate
    keys in ssh-agent: when attempting pubkey auth with a certificate, if no
    separate private key is found among the keys then try with the
    certificate key itself (thanks, Paul Querna; LP: #1575961).

 -- Colin Watson <cjwatson@debian.org>  Thu, 28 Apr 2016 01:52:01 +0100

openssh (1:7.2p2-4) unstable; urgency=medium

  * Drop dependency on libnss-files-udeb (closes: #819686).
  * Policy version 3.9.7: no changes required.

 -- Colin Watson <cjwatson@debian.org>  Fri, 15 Apr 2016 16:40:07 +0100

openssh (1:7.2p2-3) unstable; urgency=high

  * Change all openssh.org references to openssh.com (closes: #819213).
  * CVE-2015-8325: Ignore PAM environment vars when UseLogin=yes.

 -- Colin Watson <cjwatson@debian.org>  Wed, 13 Apr 2016 16:42:28 +0100

openssh (1:7.2p2-2) unstable; urgency=medium

  * Fix kexgss_server to cope with DH_GRP_MIN/DH_GRP_MAX being stricter on
    the server end than the client (thanks, Damien Miller; closes: #817870,
    LP: #1558576).

 -- Colin Watson <cjwatson@debian.org>  Mon, 21 Mar 2016 12:08:55 +0000

openssh (1:7.2p2-1) unstable; urgency=high

  * New upstream release (http://www.openssh.com/txt/release-7.2p2):
    - CVE-2016-3115: sshd(8): Sanitise X11 authentication credentials to
      avoid xauth command injection when X11Forwarding is enabled
      (http://www.openssh.com/txt/x11fwd.adv).

 -- Colin Watson <cjwatson@debian.org>  Thu, 10 Mar 2016 13:04:29 +0000

openssh (1:7.2p1-1) unstable; urgency=medium

  * New upstream release (http://www.openssh.com/txt/release-7.2):
    - This release disables a number of legacy cryptographic algorithms by
      default in ssh:
      + Several ciphers blowfish-cbc, cast128-cbc, all arcfour variants and
        the rijndael-cbc aliases for AES.
      + MD5-based and truncated HMAC algorithms.
      These algorithms are already disabled by default in sshd.
    - ssh(1), sshd(8): Remove unfinished and unused roaming code (was
      already forcibly disabled in OpenSSH 7.1p2).
    - ssh(1): Eliminate fallback from untrusted X11 forwarding to trusted
      forwarding when the X server disables the SECURITY extension.
    - ssh(1), sshd(8): Increase the minimum modulus size supported for
      diffie-hellman-group-exchange to 2048 bits.
    - sshd(8): Pre-auth sandboxing is now enabled by default (previous
      releases enabled it for new installations via sshd_config).
    - all: Add support for RSA signatures using SHA-256/512 hash algorithms
      based on draft-rsa-dsa-sha2-256-03.txt and draft-ssh-ext-info-04.txt.
    - ssh(1): Add an AddKeysToAgent client option which can be set to 'yes',
      'no', 'ask', or 'confirm', and defaults to 'no'.  When enabled, a
      private key that is used during authentication will be added to
      ssh-agent if it is running (with confirmation enabled if set to
      'confirm').
    - sshd(8): Add a new authorized_keys option "restrict" that includes all
      current and future key restrictions (no-*-forwarding, etc.).  Also add
      permissive versions of the existing restrictions, e.g.  "no-pty" ->
      "pty".  This simplifies the task of setting up restricted keys and
      ensures they are maximally-restricted, regardless of any permissions
      we might implement in the future.
    - ssh(1): Add ssh_config CertificateFile option to explicitly list
      certificates.
    - ssh-keygen(1): Allow ssh-keygen to change the key comment for all
      supported formats (closes: #811125).
    - ssh-keygen(1): Allow fingerprinting from standard input, e.g.
      "ssh-keygen -lf -" (closes: #509058).
    - ssh-keygen(1): Allow fingerprinting multiple public keys in a file,
      e.g. "ssh-keygen -lf ~/.ssh/authorized_keys".
    - sshd(8): Support "none" as an argument for sshd_config Foreground and
      ChrootDirectory.  Useful inside Match blocks to override a global
      default.
    - ssh-keygen(1): Support multiple certificates (one per line) and
      reading from standard input (using "-f -") for "ssh-keygen -L"
    - ssh-keyscan(1): Add "ssh-keyscan -c ..." flag to allow fetching
      certificates instead of plain keys.
    - ssh(1): Better handle anchored FQDNs (e.g. 'cvs.openbsd.org.') in
      hostname canonicalisation - treat them as already canonical and remove
      the trailing '.' before matching ssh_config.
    - sftp(1): Existing destination directories should not terminate
      recursive uploads (regression in OpenSSH 6.8; LP: #1553378).
  * Use HTTPS for Vcs-* URLs, and link to cgit rather than gitweb.
  * Restore slogin symlinks for compatibility, although they were removed
    upstream.

 -- Colin Watson <cjwatson@debian.org>  Tue, 08 Mar 2016 11:47:20 +0000

openssh (1:7.1p2-2) unstable; urgency=medium

  * Remove protocol 1 host key generation from openssh-server.postinst
    (closes: #811265).

 -- Colin Watson <cjwatson@debian.org>  Sun, 17 Jan 2016 14:10:19 +0000

openssh (1:7.1p2-1) unstable; urgency=high

  * New upstream release (http://www.openssh.com/txt/release-7.1p2):
    - CVE-2016-0777, CVE-2016-0778: Disable experimental client-side support
      for roaming, which could be tricked by a malicious server into leaking
      client memory to the server, including private client user keys; this
      information leak is restricted to connections to malicious or
      compromised servers (closes: #810984).
    - SECURITY: Fix an out of-bound read access in the packet handling code.
      Reported by Ben Hawkes.
    - Further use of explicit_bzero has been added in various buffer
      handling code paths to guard against compilers aggressively doing
      dead-store removal.

 -- Colin Watson <cjwatson@debian.org>  Thu, 14 Jan 2016 15:28:03 +0000

openssh (1:7.1p1-6) unstable; urgency=medium

  [ Colin Watson ]
  * Remove explicit "XS-Testsuite: autopkgtest" from debian/control;
    dpkg-source now figures that out automatically based on the existence of
    debian/tests/control.
  * Allow authenticating as root using gssapi-keyex even with
    "PermitRootLogin prohibit-password" (closes: #809695).
  * Shuffle PROPOSAL_KEX_ALGS mangling for GSSAPI key exchange a little
    later in ssh_kex2 so that it's actually effective (closes: #809696).

  [ Michael Biebl ]
  * Don't call sd_notify when sshd is re-execed (closes: #809035).

 -- Colin Watson <cjwatson@debian.org>  Mon, 04 Jan 2016 15:09:10 +0000

openssh (1:7.1p1-5) unstable; urgency=medium

  [ Michael Biebl ]
  * Add systemd readiness notification support (closes: #778913).

 -- Colin Watson <cjwatson@debian.org>  Mon, 21 Dec 2015 22:10:07 +0000

openssh (1:7.1p1-4) unstable; urgency=medium

  * Backport upstream patch to unbreak connections with peers that set
    first_kex_follows (LP: #1526357).

 -- Colin Watson <cjwatson@debian.org>  Tue, 15 Dec 2015 15:40:18 +0000

openssh (1:7.1p1-3) unstable; urgency=medium

  * Drop priority of openssh-client-ssh1 to extra (closes: #807518).
  * Redirect regression test input from /dev/zero, since otherwise conch
    will immediately send EOF.

 -- Colin Watson <cjwatson@debian.org>  Thu, 10 Dec 2015 15:12:10 +0000

openssh (1:7.1p1-2) unstable; urgency=medium

  * Really enable conch interoperability tests under autopkgtest.
  * Drop SSH1 keepalive patch.  Now that SSH1 is disabled at compile-time,
    it's been rejected upstream and there isn't much point carrying it any
    more.
  * Add NEWS.Debian documenting cryptographic changes in OpenSSH 7.0
    (closes: #806962).
  * Add an openssh-client-ssh1 binary package for people who need to connect
    to outdated SSH1-only servers (closes: #807107).
  * Update "Subsystem sftp" path in example sshd_config (closes: #691004,
    LP: #1437005).

 -- Colin Watson <cjwatson@debian.org>  Tue, 08 Dec 2015 15:33:08 +0000

openssh (1:7.1p1-1) unstable; urgency=medium

  * New upstream release (http://www.openssh.com/txt/release-7.0, closes:
    #785190):
    - Support for the legacy SSH version 1 protocol is disabled by default
      at compile time.
    - Support for the 1024-bit diffie-hellman-group1-sha1 key exchange is
      disabled by default at run-time.  It may be re-enabled using the
      instructions at http://www.openssh.com/legacy.html
    - Support for ssh-dss, ssh-dss-cert-* host and user keys is disabled by
      default at run-time.  These may be re-enabled using the instructions
      at http://www.openssh.com/legacy.html
    - Support for the legacy v00 cert format has been removed.
    - The default for the sshd_config(5) PermitRootLogin option has changed
      from "yes" to "prohibit-password".
    - PermitRootLogin=without-password/prohibit-password now bans all
      interactive authentication methods, allowing only public-key,
      hostbased and GSSAPI authentication (previously it permitted
      keyboard-interactive and password-less authentication if those were
      enabled).
    - ssh_config(5): Add PubkeyAcceptedKeyTypes option to control which
      public key types are available for user authentication.
    - sshd_config(5): Add HostKeyAlgorithms option to control which public
      key types are offered for host authentications.
    - ssh(1), sshd(8): Extend Ciphers, MACs, KexAlgorithms,
      HostKeyAlgorithms, PubkeyAcceptedKeyTypes and HostbasedKeyTypes
      options to allow appending to the default set of algorithms instead of
      replacing it.  Options may now be prefixed with a '+' to append to the
      default, e.g. "HostKeyAlgorithms=+ssh-dss".
    - sshd_config(5): PermitRootLogin now accepts an argument of
      'prohibit-password' as a less-ambiguous synonym of 'without-
      password'.
    - ssh(1), sshd(8): Add compatability workarounds for Cisco and more
      PuTTY versions.
    - Fix some omissions and errors in the PROTOCOL and PROTOCOL.mux
      documentation relating to Unix domain socket forwarding.
    - ssh(1): Improve the ssh(1) manual page to include a better description
      of Unix domain socket forwarding (closes: #779068).
    - ssh(1), ssh-agent(1): Skip uninitialised PKCS#11 slots, fixing
      failures to load keys when they are present.
    - ssh(1), ssh-agent(1): Do not ignore PKCS#11 hosted keys that wth empty
      CKA_ID.
    - sshd(8): Clarify documentation for UseDNS option.
    - Check realpath(3) behaviour matches what sftp-server requires and use
      a replacement if necessary.
  * New upstream release (http://www.openssh.com/txt/release-7.1):
    - sshd(8): OpenSSH 7.0 contained a logic error in PermitRootLogin=
      prohibit-password/without-password that could, depending on
      compile-time configuration, permit password authentication to root
      while preventing other forms of authentication.  This problem was
      reported by Mantas Mikulenas.
    - ssh(1), sshd(8): Add compatibility workarounds for FuTTY.
    - ssh(1), sshd(8): Refine compatibility workarounds for WinSCP.
    - Fix a number of memory faults (double-free, free of uninitialised
      memory, etc) in ssh(1) and ssh-keygen(1).  Reported by Mateusz
      Kocielski.
  * Change "PermitRootLogin without-password" to the new preferred spelling
    of "PermitRootLogin prohibit-password" in sshd_config, and update
    documentation to reflect the new upstream default.
  * Enable conch interoperability tests under autopkgtest.

 -- Colin Watson <cjwatson@debian.org>  Wed, 02 Dec 2015 20:18:35 +0000

openssh (1:6.9p1-3) unstable; urgency=medium

  * ssh_config(5): Fix markup errors in description of GSSAPITrustDns
    (closes: #799271).
  * Fix dh_install and dh_fixperms overrides to work properly with an
    architecture-independent-only build (closes: #806090).
  * Do much less work in architecture-independent-only builds.
  * Drop ConsoleKit session registration patch; it was only ever enabled for
    Ubuntu, which no longer needs it (LP: #1334916, #1502045).

 -- Colin Watson <cjwatson@debian.org>  Tue, 24 Nov 2015 22:48:53 +0000

openssh (1:6.9p1-2) unstable; urgency=medium

  [ Colin Watson ]
  * mention-ssh-keygen-on-keychange.patch: Move example ssh-keygen
    invocation onto a separate line to make it easier to copy and paste
    (LP: #1491532).

  [ Tyler Hicks ]
  * Build with audit support on Linux (closes: #797727, LP: #1478087).

 -- Colin Watson <cjwatson@debian.org>  Thu, 10 Sep 2015 12:26:11 +0100

openssh (1:6.9p1-1) unstable; urgency=medium

  * New upstream release (http://www.openssh.com/txt/release-6.8):
    - sshd(8): UseDNS now defaults to 'no'.  Configurations that match
      against the client host name (via sshd_config or authorized_keys) may
      need to re-enable it or convert to matching against addresses.
    - Add FingerprintHash option to ssh(1) and sshd(8), and equivalent
      command-line flags to the other tools to control algorithm used for
      key fingerprints.  The default changes from MD5 to SHA256 and format
      from hex to base64.
      Fingerprints now have the hash algorithm prepended.  An example of the
      new format: SHA256:mVPwvezndPv/ARoIadVY98vAC0g+P/5633yTC4d/wXE
      Please note that visual host keys will also be different.
    - ssh(1), sshd(8): Experimental host key rotation support.  Add a
      protocol extension for a server to inform a client of all its
      available host keys after authentication has completed.  The client
      may record the keys in known_hosts, allowing it to upgrade to better
      host key algorithms and a server to gracefully rotate its keys.
      The client side of this is controlled by a UpdateHostkeys config
      option (default off).
    - ssh(1): Add a ssh_config HostbasedKeyType option to control which host
      public key types are tried during host-based authentication.
    - ssh(1), sshd(8): Fix connection-killing host key mismatch errors when
      sshd offers multiple ECDSA keys of different lengths.
    - ssh(1): When host name canonicalisation is enabled, try to parse host
      names as addresses before looking them up for canonicalisation.  Fixes
      bz#2074 and avoids needless DNS lookups in some cases.
    - ssh(1), ssh-keysign(8): Make ed25519 keys work for host based
      authentication.
    - sshd(8): SSH protocol v.1 workaround for the Meyer, et al,
      Bleichenbacher Side Channel Attack.  Fake up a bignum key before RSA
      decryption.
    - sshd(8): Remember which public keys have been used for authentication
      and refuse to accept previously-used keys.  This allows
      AuthenticationMethods=publickey,publickey to require that users
      authenticate using two _different_ public keys.
    - sshd(8): add sshd_config HostbasedAcceptedKeyTypes and
      PubkeyAcceptedKeyTypes options to allow sshd to control what public
      key types will be accepted (closes: #481133).  Currently defaults to
      all.
    - sshd(8): Don't count partial authentication success as a failure
      against MaxAuthTries.
    - ssh(1): Add RevokedHostKeys option for the client to allow text-file
      or KRL-based revocation of host keys.
    - ssh-keygen(1), sshd(8): Permit KRLs that revoke certificates by serial
      number or key ID without scoping to a particular CA.
    - ssh(1): Add a "Match canonical" criteria that allows ssh_config Match
      blocks to trigger only in the second config pass.
    - ssh(1): Add a -G option to ssh that causes it to parse its
      configuration and dump the result to stdout, similar to "sshd -T".
    - ssh(1): Allow Match criteria to be negated. E.g. "Match !host".
    - ssh-keyscan(1): ssh-keyscan has been made much more robust against
      servers that hang or violate the SSH protocol (closes: #241119).
    - ssh(1), ssh-keygen(1): Fix regression bz#2306: Key path names were
      being lost as comment fields (closes: #787776).
    - ssh(1): Allow ssh_config Port options set in the second config parse
      phase to be applied (they were being ignored; closes: #774369).
    - ssh(1): Tweak config re-parsing with host canonicalisation - make the
      second pass through the config files always run when host name
      canonicalisation is enabled (and not whenever the host name changes)
    - ssh(1): Fix passing of wildcard forward bind addresses when connection
      multiplexing is in use.
    - ssh-keygen(1): Fix broken private key conversion from non-OpenSSH
      formats.
    - ssh-keygen(1): Fix KRL generation bug when multiple CAs are in use.
  * New upstream release (http://www.openssh.com/txt/release-6.9):
    - CVE-2015-5352: ssh(1): When forwarding X11 connections with
      ForwardX11Trusted=no, connections made after ForwardX11Timeout expired
      could be permitted and no longer subject to XSECURITY restrictions
      because of an ineffective timeout check in ssh(1) coupled with "fail
      open" behaviour in the X11 server when clients attempted connections
      with expired credentials (closes: #790798).  This problem was reported
      by Jann Horn.
    - SECURITY: ssh-agent(1): Fix weakness of agent locking (ssh-add -x) to
      password guessing by implementing an increasing failure delay, storing
      a salted hash of the password rather than the password itself and
      using a timing-safe comparison function for verifying unlock attempts.
      This problem was reported by Ryan Castellucci.
    - sshd(8): Support admin-specified arguments to AuthorizedKeysCommand
      (closes: #740494).
    - sshd(8): Add AuthorizedPrincipalsCommand that allows retrieving
      authorized principals information from a subprocess rather than a
      file.
    - ssh(1), ssh-add(1): Support PKCS#11 devices with external PIN entry
      devices.
    - ssh-keygen(1): Support "ssh-keygen -lF hostname" to search known_hosts
      and print key hashes rather than full keys.
    - ssh-agent(1): Add -D flag to leave ssh-agent in foreground without
      enabling debug mode.
    - ssh(1), sshd(8): Deprecate legacy SSH2_MSG_KEX_DH_GEX_REQUEST_OLD
      message and do not try to use it against some 3rd-party SSH
      implementations that use it (older PuTTY, WinSCP).
    - ssh(1), sshd(8): Cap DH-GEX group size at 4Kbits for Cisco
      implementations as some would fail when attempting to use group sizes
      >4K (closes: #740307, LP: #1287222).
    - ssh(1): Fix out-of-bound read in EscapeChar configuration option
      parsing.
    - sshd(8): Fix application of PermitTunnel, LoginGraceTime,
      AuthenticationMethods and StreamLocalBindMask options in Match blocks.
    - ssh(1), sshd(8): Improve disconnection message on TCP reset.
    - ssh(1): Remove failed remote forwards established by multiplexing from
      the list of active forwards.
    - sshd(8): Make parsing of authorized_keys "environment=" options
      independent of PermitUserEnv being enabled.
    - sshd(8): Fix post-auth crash with permitopen=none (closes: #778807).
    - ssh(1), ssh-add(1), ssh-keygen(1): Allow new-format private keys to be
      encrypted with AEAD ciphers.
    - ssh(1): Allow ListenAddress, Port and AddressFamily configuration
      options to appear in any order.
    - sshd(8): Check for and reject missing arguments for VersionAddendum
      and ForceCommand.
    - ssh(1), sshd(8): Don't treat unknown certificate extensions as fatal.
    - ssh-keygen(1): Make stdout and stderr output consistent.
    - ssh(1): Mention missing DISPLAY environment in debug log when X11
      forwarding requested.
    - sshd(8): Correctly record login when UseLogin is set.
    - sshd(8): Add some missing options to sshd -T output and fix output of
      VersionAddendum and HostCertificate.
    - Document and improve consistency of options that accept a "none"
      argument: TrustedUserCAKeys, RevokedKeys, AuthorizedPrincipalsFile.
    - ssh(1): Include remote username in debug output.
    - sshd(8): Avoid compatibility problem with some versions of Tera Term,
      which would crash when they received the hostkeys notification message
      (hostkeys-00@openssh.com).
    - sshd(8): Mention ssh-keygen -E as useful when comparing legacy MD5
      host key fingerprints.
    - ssh(1): Clarify pseudo-terminal request behaviour and make manual
      language consistent.
    - ssh(1): Document that the TERM environment variable is not subject to
      SendEnv and AcceptEnv; bz#2386
    - sshd(8): Format UsePAM setting when using sshd -T (closes: #767648).
    - moduli(5): Update DH-GEX moduli (closes: #787037).
  * There are some things I want to fix before upgrading to 7.0p1, though I
    intend to do that soon.  In the meantime, backport some patches, mainly
    to fix security issues:
    - SECURITY: sshd(8): OpenSSH 6.8 and 6.9 incorrectly set TTYs to be
      world-writable.  Local attackers may be able to write arbitrary
      messages to logged-in users, including terminal escape sequences.
      Reported by Nikolay Edigaryev.
    - SECURITY: sshd(8): Fixed a privilege separation weakness related to
      PAM support.  Attackers who could successfully compromise the
      pre-authentication process for remote code execution and who had valid
      credentials on the host could impersonate other users.  Reported by
      Moritz Jodeit.
    - SECURITY: sshd(8): Fixed a use-after-free bug related to PAM support
      that was reachable by attackers who could compromise the
      pre-authentication process for remote code execution (closes:
      #795711).  Also reported by Moritz Jodeit.
    - CVE-2015-5600: sshd(8): Fix circumvention of MaxAuthTries using
      keyboard-interactive authentication (closes: #793616).  By specifying
      a long, repeating keyboard-interactive "devices" string, an attacker
      could request the same authentication method be tried thousands of
      times in a single pass.  The LoginGraceTime timeout in sshd(8) and any
      authentication failure delays implemented by the authentication
      mechanism itself were still applied.  Found by Kingcope.
    - Let principals-command.sh work for noexec /var/run.
  * Thanks to Jakub Jelen of Red Hat for Fedora's rebased version of the
    GSSAPI key exchange patch.
  * Document the Debian-specific change to the default value of
    ForwardX11Trusted in ssh(1) (closes: #781469).

 -- Colin Watson <cjwatson@debian.org>  Thu, 20 Aug 2015 10:38:58 +0100

openssh (1:6.7p1-6) unstable; urgency=medium

  [ Martin Pitt ]
  * openssh-server.postinst: Quiesce "Unable to connect to Upstart" error
    message from initctl if upstart is installed, but not the current init
    system. (LP: #1440070)
  * openssh-server.postinst: Fix version comparisons of upgrade adjustments
    to not apply to fresh installs.

 -- Colin Watson <cjwatson@debian.org>  Sun, 19 Apr 2015 14:32:43 +0100

openssh (1:6.7p1-5) unstable; urgency=medium

  * Revert change from previous upload, which causes far more trouble than
    it is worth (closes: #780797):
    - Send/accept only specific known LC_* variables, rather than using a
      wildcard.
  * Add a NEWS.Debian entry documenting this reversion, as it is too
    difficult to undo the sshd_config change automatically without
    compounding the problem of (arguably) overwriting user configuration.

 -- Colin Watson <cjwatson@debian.org>  Sun, 22 Mar 2015 23:20:56 +0000

openssh (1:6.7p1-4) unstable; urgency=medium

  * Send/accept only specific known LC_* variables, rather than using a
    wildcard (closes: #765633).
  * Document interactions between ListenAddress/Port and ssh.socket in
    README.Debian (closes: #764842).
  * Debconf translations:
    - Brazilian Portuguese (thanks, José de Figueiredo; closes: #771859).

 -- Colin Watson <cjwatson@debian.org>  Wed, 18 Mar 2015 15:34:13 +0000

openssh (1:6.7p1-3) unstable; urgency=medium

  * Debconf translations:
    - Dutch (thanks, Frans Spiesschaert; closes: #765851).
  * Assume that dpkg-statoverride exists and drop the test for an obsolete
    compatibility path.

 -- Colin Watson <cjwatson@debian.org>  Mon, 03 Nov 2014 20:29:52 +0000

openssh (1:6.7p1-2) unstable; urgency=medium

  * debian/tests/control: Drop isolation-container, since the tests run on a
    high port.  They're still not guaranteed to run correctly in an schroot,
    but may manage to work, so this lets the tests at least try to run on
    ci.debian.net.

 -- Colin Watson <cjwatson@debian.org>  Fri, 10 Oct 2014 10:47:19 +0100

openssh (1:6.7p1-1) unstable; urgency=medium

  * New upstream release (http://www.openssh.com/txt/release-6.7):
    - sshd(8): The default set of ciphers and MACs has been altered to
      remove unsafe algorithms.  In particular, CBC ciphers and arcfour* are
      disabled by default.  The full set of algorithms remains available if
      configured explicitly via the Ciphers and MACs sshd_config options.
    - ssh(1), sshd(8): Add support for Unix domain socket forwarding.  A
      remote TCP port may be forwarded to a local Unix domain socket and
      vice versa or both ends may be a Unix domain socket (closes: #236718).
    - ssh(1), ssh-keygen(1): Add support for SSHFP DNS records for ED25519
      key types.
    - sftp(1): Allow resumption of interrupted uploads.
    - ssh(1): When rekeying, skip file/DNS lookups of the hostkey if it is
      the same as the one sent during initial key exchange.
    - sshd(8): Allow explicit ::1 and 127.0.0.1 forwarding bind addresses
      when GatewayPorts=no; allows client to choose address family.
    - sshd(8): Add a sshd_config PermitUserRC option to control whether
      ~/.ssh/rc is executed, mirroring the no-user-rc authorized_keys
      option.
    - ssh(1): Add a %C escape sequence for LocalCommand and ControlPath that
      expands to a unique identifier based on a hash of the tuple of (local
      host, remote user, hostname, port).  Helps avoid exceeding miserly
      pathname limits for Unix domain sockets in multiplexing control paths.
    - sshd(8): Make the "Too many authentication failures" message include
      the user, source address, port and protocol in a format similar to the
      authentication success / failure messages.
    - Use CLOCK_BOOTTIME in preference to CLOCK_MONOTONIC when it is
      available. It considers time spent suspended, thereby ensuring
      timeouts (e.g. for expiring agent keys) fire correctly (closes:
      #734553).
    - Use prctl() to prevent sftp-server from accessing
      /proc/self/{mem,maps}.
  * Restore TCP wrappers support, removed upstream in 6.7.  It is true that
    dropping this reduces preauth attack surface in sshd.  On the other
    hand, this support seems to be quite widely used, and abruptly dropping
    it (from the perspective of users who don't read openssh-unix-dev) could
    easily cause more serious problems in practice.  It's not entirely clear
    what the right long-term answer for Debian is, but it at least probably
    doesn't involve dropping this feature shortly before a freeze.
  * Replace patch to disable OpenSSL version check with an updated version
    of Kurt Roeckx's patch from #732940 to just avoid checking the status
    field.
  * Build-depend on a new enough dpkg-dev for dpkg-buildflags, rather than
    simply a new enough dpkg.
  * Simplify debian/rules using /usr/share/dpkg/buildflags.mk.
  * Use Package-Type rather than XC-Package-Type, now that it is an official
    field.
  * Run a subset of the upstream regression test suite at package build
    time, and the rest of it under autopkgtest.

 -- Colin Watson <cjwatson@debian.org>  Thu, 09 Oct 2014 14:05:56 +0100

openssh (1:6.6p1-8) unstable; urgency=medium

  * Make the if-up hook use "reload" rather than "restart" if the system was
    booted using systemd (closes: #756547).
  * Show fingerprints of new keys after creating them in the postinst
    (closes: #762128).
  * Policy version 3.9.6: no changes required.
  * Don't link /usr/share/doc/ssh to openssh-client, as this is not safe
    between Architecture: all and Architecture: any binary packages (closes:
    #763375).

 -- Colin Watson <cjwatson@debian.org>  Fri, 03 Oct 2014 12:23:57 +0100

openssh (1:6.6p1-7) unstable; urgency=medium

  * Make sure that DEB_HOST_ARCH is set, even when invoking debian/rules
    directly.
  * Use dh-exec to simplify override_dh_install target.
  * Remove several unnecessary entries in debian/*.dirs.
  * Pass noupdate to the second call to pam_motd, not the first (thanks, Ken
    T Takusagawa; closes: #757059).
  * Debconf translations:
    - Turkish (thanks, Mert Dirik; closes: #756757).

 -- Colin Watson <cjwatson@debian.org>  Tue, 05 Aug 2014 09:10:04 +0100

openssh (1:6.6p1-6) unstable; urgency=medium

  * Upgrade to debhelper v9.
  * Only use pam_keyinit on Linux architectures (closes: #747245).
  * Make get_config_option more robust against trailing whitespace (thanks,
    LaMont Jones).
  * Debconf translations:
    - Czech (thanks, Michal Šimůnek; closes: #751419).

 -- Colin Watson <cjwatson@debian.org>  Sat, 28 Jun 2014 14:50:04 +0100

openssh (1:6.6p1-5) unstable; urgency=medium

  * Force ssh-agent Upstart job to use sh syntax regardless of the user's
    shell (thanks, Steffen Stempel; LP: #1312928).

 -- Colin Watson <cjwatson@debian.org>  Thu, 01 May 2014 16:27:53 +0100

openssh (1:6.6p1-4) unstable; urgency=medium

  * Debconf translations:
    - Spanish (thanks, Matías Bellone; closes: #744867).
  * Apply upstream-recommended patch to fix bignum encoding for
    curve25519-sha256@libssh.org, fixing occasional key exchange failures.

 -- Colin Watson <cjwatson@debian.org>  Mon, 21 Apr 2014 21:29:53 +0100

openssh (1:6.6p1-3) unstable; urgency=medium

  * Debconf translations:
    - French (thanks, Étienne Gilli; closes: #743242).
  * Never signal the service supervisor with SIGSTOP more than once, to
    prevent a hang on re-exec (thanks, Robie Basak; LP: #1306877).

 -- Colin Watson <cjwatson@debian.org>  Mon, 14 Apr 2014 12:11:50 +0100

openssh (1:6.6p1-2) unstable; urgency=medium

  * If no root password is set, then switch to "PermitRootLogin
    without-password" without asking (LP: #1300127).

 -- Colin Watson <cjwatson@debian.org>  Mon, 31 Mar 2014 12:20:46 +0100

openssh (1:6.6p1-1) unstable; urgency=medium

  [ Colin Watson ]
  * Apply various warning-suppression and regression-test fixes to
    gssapi.patch from Damien Miller.
  * New upstream release (http://www.openssh.com/txt/release-6.6,
    LP: #1298280):
    - CVE-2014-2532: sshd(8): when using environment passing with an
      sshd_config(5) AcceptEnv pattern with a wildcard, OpenSSH prior to 6.6
      could be tricked into accepting any environment variable that contains
      the characters before the wildcard character.
  * Re-enable btmp logging, as its permissions were fixed a long time ago in
    response to #370050 (closes: #341883).
  * Change to "PermitRootLogin without-password" for new installations, and
    ask a debconf question when upgrading systems with "PermitRootLogin yes"
    from previous versions (closes: #298138).
  * Debconf translations:
    - Danish (thanks, Joe Hansen).
    - Portuguese (thanks, Américo Monteiro).
    - Russian (thanks, Yuri Kozlov; closes: #742308).
    - Swedish (thanks, Andreas Rönnquist).
    - Japanese (thanks, victory).
    - German (thanks, Stephan Beck; closes: #742541).
    - Italian (thanks, Beatrice Torracca).
  * Don't start ssh-agent from the Upstart user session job if something
    like Xsession has already done so (based on work by Bruno Vasselle;
    LP: #1244736).

  [ Matthew Vernon ]
  * CVE-2014-2653: Fix failure to check SSHFP records if server presents a
    certificate (bug reported by me, patch by upstream's Damien Miller;
    thanks also to Mark Wooding for his help in fixing this) (Closes:
    #742513)

 -- Colin Watson <cjwatson@debian.org>  Fri, 28 Mar 2014 18:04:41 +0000

openssh (1:6.5p1-6) unstable; urgency=medium

  * Fix Breaks/Replaces versions of openssh-sftp-server on openssh-server
    (thanks, Axel Beckert).

 -- Colin Watson <cjwatson@debian.org>  Thu, 06 Mar 2014 16:18:44 +0000

openssh (1:6.5p1-5) unstable; urgency=medium

  [ Colin Watson ]
  * Add Alias=sshd.service to systemd ssh.service file, to match "Provides:
    sshd" in the sysvinit script (thanks, Michael Biebl).
  * Add Before=ssh.service to systemd ssh.socket file, since otherwise
    nothing guarantees that ssh.service has stopped before ssh.socket starts
    (thanks, Uoti Urpala).

  [ Axel Beckert ]
  * Split sftp-server into its own package to allow it to also be used by
    other SSH server implementations like dropbear (closes: #504290).

 -- Colin Watson <cjwatson@debian.org>  Wed, 05 Mar 2014 13:53:08 +0000

openssh (1:6.5p1-4) unstable; urgency=medium

  * Configure --without-hardening on hppa, to work around
    http://gcc.gnu.org/bugzilla/show_bug.cgi?id=60155 (closes: #738798).
  * Amend "Running sshd from inittab" instructions in README.Debian to
    recommend 'update-rc.d ssh disable', rather than manual removal of rc*.d
    symlinks that won't work with dependency-based sysv-rc.
  * Remove code related to non-dependency-based sysv-rc ordering, since that
    is no longer supported.
  * Apply patch from https://bugzilla.mindrot.org/show_bug.cgi?id=2200 to
    fix getsockname errors when using "ssh -W" (closes: #738693).

 -- Colin Watson <cjwatson@debian.org>  Sat, 15 Feb 2014 02:19:36 +0000

openssh (1:6.5p1-3) unstable; urgency=medium

  * Clarify socket activation mode in README.Debian, as suggested by Uoti
    Urpala.
  * Stop claiming that "Protocol 2" is a Debian-specific default; this has
    been upstream's default since 5.4p1.
  * Avoid stdout noise from which(1) on purge of openssh-client.
  * Fix sysvinit->systemd transition code to cope with still-running
    sysvinit jobs being considered active by systemd (thanks, Uoti Urpala
    and Michael Biebl).
  * Bump guard version for sysvinit->systemd transition to 1:6.5p1-3; we may
    have got it wrong before, and it's fairly harmless to repeat it.
  * Remove tests for whether /dev/null is a character device from the
    Upstart job and the systemd service files; it's there to avoid a
    confusing failure mode in daemon(), but with modern init systems we use
    the -D option to suppress daemonisation anyway.
  * Refer to /usr/share/common-licenses/GPL-2 in debian/copyright (for the
    Debian patch) rather than plain GPL.
  * Drop some very old Conflicts and Replaces (ssh (<< 1:3.8.1p1-9),
    rsh-client (<< 0.16.1-1), ssh-krb5 (<< 1:4.3p2-7), ssh-nonfree (<< 2),
    and openssh-client (<< 1:3.8.1p1-11)).  These all relate to pre-etch
    versions, for which we no longer have maintainer script code, and per
    policy they would have to become Breaks nowadays anyway.
  * Policy version 3.9.5.
  * Drop unnecessary -1 in zlib1g Build-Depends version.
  * Tweak dh_systemd_enable invocations to avoid lots of error noise.

 -- Colin Watson <cjwatson@debian.org>  Wed, 12 Feb 2014 13:10:08 +0000

openssh (1:6.5p1-2) unstable; urgency=medium

  * Only enable ssh.service for systemd, not both ssh.service and
    ssh.socket.  Thanks to Michael Biebl for spotting this.
  * Backport upstream patch to unbreak case-sensitive matching of ssh_config
    (closes: #738619).

 -- Colin Watson <cjwatson@debian.org>  Tue, 11 Feb 2014 11:28:35 +0000

openssh (1:6.5p1-1) unstable; urgency=medium

  * New upstream release (http://www.openssh.com/txt/release-6.5,
    LP: #1275068):
    - ssh(1): Add support for client-side hostname canonicalisation using a
      set of DNS suffixes and rules in ssh_config(5).  This allows
      unqualified names to be canonicalised to fully-qualified domain names
      to eliminate ambiguity when looking up keys in known_hosts or checking
      host certificate names (closes: #115286).
  * Switch to git; adjust Vcs-* fields.
  * Convert to git-dpm, and drop source package documentation associated
    with the old bzr/quilt patch handling workflow.
  * Drop ssh-vulnkey and the associated ssh/ssh-add/sshd integration code,
    leaving only basic configuration file compatibility, since it has been
    nearly six years since the original vulnerability and this code is not
    likely to be of much value any more (closes: #481853, #570651).  See
    https://lists.debian.org/debian-devel/2013/09/msg00240.html for my full
    reasoning.
  * Add OpenPGP signature checking configuration to watch file (thanks,
    Daniel Kahn Gillmor; closes: #732441).
  * Add the pam_keyinit session module, to create a new session keyring on
    login (closes: #734816).
  * Incorporate default path changes from shadow 1:4.0.18.1-8, removing
    /usr/bin/X11 (closes: #644521).
  * Generate ED25519 host keys on fresh installations.  Upgraders who wish
    to add such host keys should manually add 'HostKey
    /etc/ssh/ssh_host_ed25519_key' to /etc/ssh/sshd_config and run
    'ssh-keygen -q -f /etc/ssh/ssh_host_ed25519_key -N "" -t ed25519'.
  * Drop long-obsolete "SSH now uses protocol 2 by default" section from
    README.Debian.
  * Add systemd support (thanks, Sven Joachim; closes: #676830).

 -- Colin Watson <cjwatson@debian.org>  Mon, 10 Feb 2014 14:58:26 +0000

openssh (1:6.4p1-2) unstable; urgency=high

  * Increase ServerKeyBits value in package-generated sshd_config to 1024
    (closes: #727622, LP: #1244272).
  * Restore patch to disable OpenSSL version check (closes: #732940).

 -- Colin Watson <cjwatson@debian.org>  Mon, 23 Dec 2013 10:44:04 +0000

openssh (1:6.4p1-1) unstable; urgency=high

  * New upstream release.  Important changes:
    - 6.3/6.3p1 (http://www.openssh.com/txt/release-6.3):
      + sftp(1): add support for resuming partial downloads using the
        "reget" command and on the sftp commandline or on the "get"
        commandline using the "-a" (append) option (closes: #158590).
      + ssh(1): add an "IgnoreUnknown" configuration option to selectively
        suppress errors arising from unknown configuration directives
        (closes: #436052).
      + sftp(1): update progressmeter when data is acknowledged, not when
        it's sent (partially addresses #708372).
      + ssh(1): do not fatally exit when attempting to cleanup multiplexing-
        created channels that are incompletely opened (closes: #651357).
    - 6.4/6.4p1 (http://www.openssh.com/txt/release-6.4):
      + CVE-2013-4548: sshd(8): fix a memory corruption problem triggered
        during rekeying when an AES-GCM cipher is selected (closes:
        #729029).  Full details of the vulnerability are available at:
        http://www.openssh.com/txt/gcmrekey.adv
  * When running under Upstart, only consider the daemon started once it is
    ready to accept connections (by raising SIGSTOP at that point and using
    "expect stop").

 -- Colin Watson <cjwatson@debian.org>  Sat, 09 Nov 2013 18:24:16 +0000

openssh (1:6.2p2-6) unstable; urgency=low

  * Update config.guess and config.sub automatically at build time.
    dh_autoreconf does not take care of that by default because openssh does
    not use automake.

 -- Colin Watson <cjwatson@debian.org>  Tue, 02 Jul 2013 22:54:49 +0100

openssh (1:6.2p2-5) unstable; urgency=low

  [ Colin Watson ]
  * Document consequences of ssh-agent being setgid in ssh-agent(1); see
    #711623.
  * Use 'set -e' rather than '#! /bin/sh -e' in maintainer scripts and
    ssh-argv0.

  [ Yolanda Robla ]
  * debian/rules: Include real distribution in SSH_EXTRAVERSION instead of
    hardcoding Debian (LP: #1195342).

 -- Colin Watson <cjwatson@debian.org>  Thu, 27 Jun 2013 15:24:14 +0100

openssh (1:6.2p2-4) unstable; urgency=low

  * Fix non-portable shell in ssh-copy-id (closes: #711162).
  * Rebuild against debhelper 9.20130604 with fixed dependencies for
    invoke-rc.d and Upstart jobs (closes: #711159, #711364).
  * Set SELinux context on private host keys as well as public host keys
    (closes: #687436).

 -- Colin Watson <cjwatson@debian.org>  Thu, 06 Jun 2013 17:06:31 +0100

openssh (1:6.2p2-3) unstable; urgency=low

  * If the running init daemon is Upstart, then, on the first upgrade to
    this version, check whether sysvinit is still managing sshd; if so,
    manually stop it so that it can be restarted under upstart.  We do this
    near the end of the postinst, so it shouldn't result in any appreciable
    extra window where sshd is not running during upgrade.

 -- Colin Watson <cjwatson@debian.org>  Wed, 22 May 2013 17:42:10 +0100

openssh (1:6.2p2-2) unstable; urgency=low

  * Change start condition of Upstart job to be just the standard "runlevel
    [2345]", rather than "filesystem or runlevel [2345]"; the latter makes
    it unreasonably difficult to ensure that urandom starts before ssh, and
    is not really necessary since one of static-network-up and failsafe-boot
    is guaranteed to happen and will trigger entry to the default runlevel,
    and we don't care about ssh starting before the network (LP: #1098299).
  * Drop conffile handling for direct upgrades from pre-split ssh package;
    this was originally added in 1:4.3p2-7 / 1:4.3p2-8, and contained a
    truly ghastly hack around a misbehaviour in sarge's dpkg.  Since this is
    now four Debian releases ago, we can afford to drop this and simplify
    the packaging.
  * Remove ssh/use_old_init_script, which was a workaround for a very old
    bug in /etc/init.d/ssh.  If anyone has ignored this for >10 years then
    they aren't going to be convinced now (closes: #214182).
  * Remove support for upgrading directly from ssh-nonfree.
  * Remove lots of maintainer script support for direct upgrades from
    pre-etch (three releases before current stable).
  * Add #DEBHELPER# tokens to openssh-client.postinst and
    openssh-server.postinst.
  * Replace old manual conffile handling code with dpkg-maintscript-helper,
    via dh_installdeb.
  * Switch to new unified layout for Upstart jobs as documented in
    https://wiki.ubuntu.com/UpstartCompatibleInitScripts: the init script
    checks for a running Upstart, and we now let dh_installinit handle most
    of the heavy lifting in maintainer scripts.  Ubuntu users should be
    essentially unaffected except that sshd may no longer start
    automatically in chroots if the running Upstart predates 0.9.0; but the
    main goal is simply not to break when openssh-server is installed in a
    chroot.
  * Remove the check for vulnerable host keys; this was first added five
    years ago, and everyone should have upgraded through a version that
    applied these checks by now.  The ssh-vulnkey tool and the blacklisting
    support in sshd are still here, at least for the moment.
  * This removes the last of our uses of debconf (closes: #221531).
  * Use the pam_loginuid session module (thanks, Laurent Bigonville; closes:
    #677440, LP: #1067779).
  * Bracket our session stack with calls to pam_selinux close/open (thanks,
    Laurent Bigonville; closes: #679458).
  * Fix dh_builddeb invocation so that we really use xz compression for
    binary packages, as intended since 1:6.1p1-2.

 -- Colin Watson <cjwatson@debian.org>  Wed, 22 May 2013 09:07:42 +0100

openssh (1:6.2p2-1) unstable; urgency=low

  * New upstream release (http://www.openssh.com/txt/release-6.2p2):
    - Only warn for missing identity files that were explicitly specified
      (closes: #708275).
    - Fix bug in contributed contrib/ssh-copy-id script that could result in
      "rm *" being called on mktemp failure (closes: #708419).

 -- Colin Watson <cjwatson@debian.org>  Thu, 16 May 2013 14:05:06 +0100

openssh (1:6.2p1-3) unstable; urgency=low

  * Renumber Debian-specific additions to enum monitor_reqtype so that they
    fit within a single byte (thanks, Jason Conti; LP: #1179202).

 -- Colin Watson <cjwatson@debian.org>  Mon, 13 May 2013 10:56:04 +0100

openssh (1:6.2p1-2) unstable; urgency=low

  * Fix build failure on Ubuntu:
    - Include openbsd-compat/sys-queue.h from consolekit.c.
    - Fix consolekit mismerges in monitor.c and monitor_wrap.c.

 -- Colin Watson <cjwatson@debian.org>  Thu, 09 May 2013 09:45:57 +0100

openssh (1:6.2p1-1) unstable; urgency=low

  * New upstream release (http://www.openssh.com/txt/release-6.2).
    - Add support for multiple required authentication in SSH protocol 2 via
      an AuthenticationMethods option (closes: #195716).
    - Fix Sophie Germain formula in moduli(5) (closes: #698612).
    - Update ssh-copy-id to Phil Hands' greatly revised version (closes:
      #99785, #322228, #620428; LP: #518883, #835901, #1074798).
  * Use dh-autoreconf.

 -- Colin Watson <cjwatson@debian.org>  Tue, 07 May 2013 11:48:16 +0100

openssh (1:6.1p1-4) experimental; urgency=low

  [ Gunnar Hjalmarsson ]
  * debian/openssh-server.sshd.pam: Explicitly state that ~/.pam_environment
    should be read, and move the pam_env calls from "auth" to "session" so
    that it's also read when $HOME is encrypted (LP: #952185).

  [ Stéphane Graber ]
  * Add ssh-agent upstart user job.  This implements something similar to
    the 90x11-common_ssh-agent Xsession script.  That is, start ssh-agent
    and set the appropriate environment variables (closes: #703906).

 -- Colin Watson <cjwatson@debian.org>  Mon, 25 Mar 2013 16:58:04 +0000

openssh (1:6.1p1-3) experimental; urgency=low

  * Give ssh and ssh-krb5 versioned dependencies on openssh-client and
    openssh-server, to try to reduce confusion when people run 'apt-get
    install ssh' or similar and expect that to upgrade everything relevant.
  * CVE-2010-5107: Improve DoS resistance by changing default of MaxStartups
    to 10:30:100 (closes: #700102).

 -- Colin Watson <cjwatson@debian.org>  Fri, 08 Feb 2013 21:07:31 +0000

openssh (1:6.1p1-2) experimental; urgency=low

  * Use xz compression for binary packages.
  * Merge from Ubuntu:
    - Add support for registering ConsoleKit sessions on login.  (This is
      currently enabled only when building for Ubuntu.)
    - Drop openssh-blacklist and openssh-blacklist-extra to Suggests.  It's
      been long enough since the relevant vulnerability that we shouldn't
      need these installed by default nowadays.
    - Add an Upstart job (not currently used by default in Debian).
    - Add mention of ssh-keygen in ssh connect warning (Scott Moser).
    - Install apport hooks.
  * Only build with -j if DEB_BUILD_OPTIONS=parallel=* is used (closes:
    #694282).

 -- Colin Watson <cjwatson@debian.org>  Mon, 26 Nov 2012 16:39:07 +0000

openssh (1:6.1p1-1) experimental; urgency=low

  * New upstream release (http://www.openssh.com/txt/release-6.1).
    - Enable pre-auth sandboxing by default for new installs.
    - Allow "PermitOpen none" to refuse all port-forwarding requests
      (closes: #543683).

 -- Colin Watson <cjwatson@debian.org>  Fri, 07 Sep 2012 00:22:44 +0100

openssh (1:6.0p1-3) unstable; urgency=low

  * debconf template translations:
    - Add Indonesian (thanks, Andika Triwidada; closes: #681670).
  * Call restorecon on copied ~/.ssh/authorized_keys if possible, since some
    SELinux policies require this (closes: #658675).
  * Add ncurses-term to openssh-server's Recommends, since it's often needed
    to support unusual terminal emulators on clients (closes: #675362).

 -- Colin Watson <cjwatson@debian.org>  Fri, 24 Aug 2012 06:55:36 +0100

openssh (1:6.0p1-2) unstable; urgency=low

  * Tighten libssl1.0.0 and libcrypto1.0.0-udeb dependencies to the current
    "fix" version at build time (closes: #678661).

 -- Colin Watson <cjwatson@debian.org>  Sun, 24 Jun 2012 12:16:06 +0100

openssh (1:6.0p1-1) unstable; urgency=low

  [ Roger Leigh ]
  * Display dynamic part of MOTD from /run/motd.dynamic, if it exists
    (closes: #669699).

  [ Colin Watson ]
  * Update OpenSSH FAQ to revision 1.113, fixing missing line break (closes:
    #669667).
  * New upstream release (closes: #671010,
    http://www.openssh.com/txt/release-6.0).
    - Fix IPQoS not being set on non-mapped v4-in-v6 addressed connections
      (closes: #643312, #650512, #671075).
    - Add a new privilege separation sandbox implementation for Linux's new
      seccomp sandbox, automatically enabled on platforms that support it.
      (Note: privilege separation sandboxing is still experimental.)
  * Fix a bashism in configure's seccomp_filter check.
  * Add a sandbox fallback mechanism, so that behaviour on Linux depends on
    whether the running system's kernel has seccomp_filter support, not the
    build system's kernel (forwarded upstream as
    https://bugzilla.mindrot.org/show_bug.cgi?id=2011).

 -- Colin Watson <cjwatson@debian.org>  Sat, 26 May 2012 13:48:14 +0100

openssh (1:5.9p1-5) unstable; urgency=low

  * Use dpkg-buildflags, including for hardening support; drop use of
    hardening-includes.
  * Fix cross-building:
    - Allow using a cross-architecture pkg-config.
    - Pass default LDFLAGS to contrib/Makefile.
    - Allow dh_strip to strip gnome-ssh-askpass, rather than calling
      'install -s'.

 -- Colin Watson <cjwatson@debian.org>  Mon, 02 Apr 2012 11:20:33 +0100

openssh (1:5.9p1-4) unstable; urgency=low

  * Disable OpenSSL version check again, as its SONAME is sufficient
    nowadays (closes: #664383).

 -- Colin Watson <cjwatson@debian.org>  Mon, 19 Mar 2012 11:06:30 +0000

openssh (1:5.9p1-3) unstable; urgency=low

  * debconf template translations:
    - Update Polish (thanks, Michał Kułach; closes: #659829).
  * Ignore errors writing to console in init script (closes: #546743).
  * Move ssh-krb5 to Section: oldlibs.

 -- Colin Watson <cjwatson@debian.org>  Fri, 24 Feb 2012 08:56:18 +0000

openssh (1:5.9p1-2) unstable; urgency=low

  * Mark openssh-client and openssh-server as Multi-Arch: foreign.

 -- Colin Watson <cjwatson@debian.org>  Wed, 09 Nov 2011 02:06:48 +0000

openssh (1:5.9p1-1) unstable; urgency=low

  * New upstream release (http://www.openssh.com/txt/release-5.9).
    - Introduce sandboxing of the pre-auth privsep child using an optional
      sshd_config(5) "UsePrivilegeSeparation=sandbox" mode that enables
      mandatory restrictions on the syscalls the privsep child can perform.
    - Add new SHA256-based HMAC transport integrity modes from
      http://www.ietf.org/id/draft-dbider-sha2-mac-for-ssh-02.txt.
    - The pre-authentication sshd(8) privilege separation slave process now
      logs via a socket shared with the master process, avoiding the need to
      maintain /dev/log inside the chroot (closes: #75043, #429243,
      #599240).
    - ssh(1) now warns when a server refuses X11 forwarding (closes:
      #504757).
    - sshd_config(5)'s AuthorizedKeysFile now accepts multiple paths,
      separated by whitespace (closes: #76312).  The authorized_keys2
      fallback is deprecated but documented (closes: #560156).
    - ssh(1) and sshd(8): set IPv6 traffic class from IPQoS, as well as IPv4
      ToS/DSCP (closes: #498297).
    - ssh-add(1) now accepts keys piped from standard input.  E.g. "ssh-add
      - < /path/to/key" (closes: #229124).
    - Clean up lost-passphrase text in ssh-keygen(1) (closes: #444691).
    - Say "required" rather than "recommended" in unprotected-private-key
      warning (LP: #663455).
  * Update OpenSSH FAQ to revision 1.112.

 -- Colin Watson <cjwatson@debian.org>  Wed, 07 Sep 2011 23:46:00 +0100

openssh (1:5.8p1-7) unstable; urgency=low

  * Only recommend ssh-import-id when built on Ubuntu (closes: #635887).
  * Use 'dpkg-vendor --derives-from Ubuntu' to detect Ubuntu systems rather
    than 'lsb_release -is' so that Ubuntu derivatives behave the same way as
    Ubuntu itself.

 -- Colin Watson <cjwatson@debian.org>  Fri, 29 Jul 2011 14:27:52 +0100

openssh (1:5.8p1-6) unstable; urgency=low

  * openssh-client and openssh-server Suggests: monkeysphere.
  * Quieten logs when multiple from= restrictions are used in different
    authorized_keys lines for the same key; it's still not ideal, but at
    least you'll only get one log entry per key (closes: #630606).
  * Merge from Ubuntu (Dustin Kirkland):
    - openssh-server Recommends: ssh-import-id (no-op in Debian since that
      package doesn't exist there, but this reduces the Ubuntu delta).

 -- Colin Watson <cjwatson@debian.org>  Thu, 28 Jul 2011 17:10:18 +0100

openssh (1:5.8p1-5) unstable; urgency=low

  * Drop openssh-server's dependency on openssh-blacklist to a
    recommendation (closes: #622604).
  * Update Vcs-* fields and README.source for Alioth changes.
  * Backport from upstream:
    - Make hostbased auth with ECDSA keys work correctly (closes: #633368).

 -- Colin Watson <cjwatson@debian.org>  Sun, 24 Jul 2011 11:06:47 +0100

openssh (1:5.8p1-4) unstable; urgency=low

  * Drop hardcoded dependencies on libssl0.9.8 and libcrypto0.9.8-udeb,
    since the required minimum versions are rather old now anyway and
    openssl has bumped its SONAME (thanks, Julien Cristau; closes: #620828).
  * Remove unreachable code from openssh-server.postinst.

 -- Colin Watson <cjwatson@debian.org>  Mon, 04 Apr 2011 15:56:18 +0100

openssh (1:5.8p1-3) unstable; urgency=low

  * Correct ssh-keygen instruction in the changelog for 1:5.7p1-1 (thanks,
    Joel Stanley).
  * Allow ssh-add to read from FIFOs (thanks, Daniel Kahn Gillmor; closes:
    #614897).

 -- Colin Watson <cjwatson@debian.org>  Fri, 18 Mar 2011 16:42:42 +0000

openssh (1:5.8p1-2) unstable; urgency=low

  * Upload to unstable.

 -- Colin Watson <cjwatson@debian.org>  Tue, 08 Feb 2011 10:59:17 +0000

openssh (1:5.8p1-1) experimental; urgency=low

  * New upstream release (http://www.openssh.com/txt/release-5.8):
    - Fix stack information leak in legacy certificate signing
      (http://www.openssh.com/txt/legacy-cert.adv).

 -- Colin Watson <cjwatson@debian.org>  Sat, 05 Feb 2011 11:13:11 +0000

openssh (1:5.7p1-2) experimental; urgency=low

  * Fix crash in ssh_selinux_setfscreatecon when SELinux is disabled
    (LP: #708571).

 -- Colin Watson <cjwatson@debian.org>  Thu, 27 Jan 2011 12:14:17 +0000

openssh (1:5.7p1-1) experimental; urgency=low

  * New upstream release (http://www.openssh.com/txt/release-5.7):
    - Implement Elliptic Curve Cryptography modes for key exchange (ECDH)
      and host/user keys (ECDSA) as specified by RFC5656.  ECDH and ECDSA
      offer better performance than plain DH and DSA at the same equivalent
      symmetric key length, as well as much shorter keys.
    - sftp(1)/sftp-server(8): add a protocol extension to support a hard
      link operation.  It is available through the "ln" command in the
      client.  The old "ln" behaviour of creating a symlink is available
      using its "-s" option or through the preexisting "symlink" command.
    - scp(1): Add a new -3 option to scp: Copies between two remote hosts
      are transferred through the local host (closes: #508613).
    - ssh(1): "atomically" create the listening mux socket by binding it on
      a temporary name and then linking it into position after listen() has
      succeeded.  This allows the mux clients to determine that the server
      socket is either ready or stale without races (closes: #454784).
      Stale server sockets are now automatically removed (closes: #523250).
    - ssh(1): install a SIGCHLD handler to reap expired child process
      (closes: #594687).
    - ssh(1)/ssh-agent(1): honour $TMPDIR for client xauth and ssh-agent
      temporary directories (closes: #357469, although only if you arrange
      for ssh-agent to actually see $TMPDIR since the setgid bit will cause
      it to be stripped off).
  * Update to current GSSAPI patch from
    http://www.sxw.org.uk/computing/patches/openssh-5.7p1-gsskex-all-20110125.patch:
    - Add GSSAPIServerIdentity option.
  * Generate ECDSA host keys on fresh installations.  Upgraders who wish to
    add such host keys should manually add 'HostKey
    /etc/ssh/ssh_host_ecdsa_key' to /etc/ssh/sshd_config and run 'ssh-keygen
    -q -f /etc/ssh/ssh_host_ecdsa_key -N "" -t ecdsa'.
  * Build-depend on libssl-dev (>= 0.9.8g) to ensure sufficient ECC support.
  * Backport SELinux build fix from CVS.
  * Rearrange selinux-role.patch so that it links properly given this
    SELinux build fix.

 -- Colin Watson <cjwatson@debian.org>  Wed, 26 Jan 2011 23:48:02 +0000

openssh (1:5.6p1-3) experimental; urgency=low

  * Drop override for desktop-file-but-no-dh_desktop-call, which Lintian no
    longer issues.
  * Merge 1:5.5p1-6.

 -- Colin Watson <cjwatson@debian.org>  Thu, 30 Dec 2010 11:48:00 +0000

openssh (1:5.6p1-2) experimental; urgency=low

  * Backport upstream patch to install a SIGCHLD handler to reap expired ssh
    child processes, preventing lots of zombies when using ControlPersist
    (closes: #594687).

 -- Colin Watson <cjwatson@debian.org>  Tue, 26 Oct 2010 14:46:40 +0100

openssh (1:5.6p1-1) experimental; urgency=low

  * New upstream release (http://www.openssh.com/txt/release-5.6):
    - Added a ControlPersist option to ssh_config(5) that automatically
      starts a background ssh(1) multiplex master when connecting.  This
      connection can stay alive indefinitely, or can be set to automatically
      close after a user-specified duration of inactivity (closes: #335697,
      #350898, #454787, #500573, #550262).
    - Support AuthorizedKeysFile, AuthorizedPrincipalsFile,
      HostbasedUsesNameFromPacketOnly, and PermitTunnel in sshd_config(5)
      Match blocks (closes: #549858).
    - sftp(1): fix ls in working directories that contain globbing
      characters in their pathnames (LP: #530714).

 -- Colin Watson <cjwatson@debian.org>  Tue, 24 Aug 2010 00:37:54 +0100

openssh (1:5.5p1-6) unstable; urgency=low

  * Touch /var/run/sshd/.placeholder in the preinst so that /var/run/sshd,
    which is intentionally no longer shipped in the openssh-server package
    due to /var/run often being a temporary directory, is not removed on
    upgrade (closes: #575582).

 -- Colin Watson <cjwatson@debian.org>  Sun, 26 Dec 2010 18:09:29 +0000

openssh (1:5.5p1-5) unstable; urgency=low

  * Use an architecture wildcard for libselinux1-dev (closes: #591740).
  * debconf template translations:
    - Update Danish (thanks, Joe Hansen; closes: #592800).

 -- Colin Watson <cjwatson@debian.org>  Mon, 23 Aug 2010 22:59:03 +0100

openssh (1:5.5p1-4) unstable; urgency=low

  [ Sebastian Andrzej Siewior ]
  * Add powerpcspe to architecture list for libselinux1-dev build-dependency
    (closes: #579843).

  [ Colin Watson ]
  * Allow ~/.ssh/authorized_keys and other secure files to be
    group-writable, provided that the group in question contains only the
    file's owner; this extends a patch previously applied to ~/.ssh/config
    (closes: #581919).
  * Check primary group memberships as well as supplementary group
    memberships, and only allow group-writability by groups with exactly one
    member, as zero-member groups are typically used by setgid binaries
    rather than being user-private groups (closes: #581697).

 -- Colin Watson <cjwatson@debian.org>  Sat, 22 May 2010 23:37:20 +0100

openssh (1:5.5p1-3) unstable; urgency=low

  * Discard error messages while checking whether rsh, rlogin, and rcp
    alternatives exist (closes: #579285).
  * Drop IDEA key check; I don't think it works properly any more due to
    textual changes in error output, it's only relevant for direct upgrades
    from truly ancient versions, and it breaks upgrades if
    /etc/ssh/ssh_host_key can't be loaded (closes: #579570).

 -- Colin Watson <cjwatson@debian.org>  Wed, 28 Apr 2010 22:12:47 +0100

openssh (1:5.5p1-2) unstable; urgency=low

  * Use dh_installinit -n, since our maintainer scripts already handle this
    more carefully (thanks, Julien Cristau).

 -- Colin Watson <cjwatson@debian.org>  Sat, 17 Apr 2010 12:55:56 +0100

openssh (1:5.5p1-1) unstable; urgency=low

  * New upstream release:
    - Unbreak sshd_config's AuthorizedKeysFile option for $HOME-relative
      paths.
    - Include a language tag when sending a protocol 2 disconnection
      message.
    - Make logging of certificates used for user authentication more clear
      and consistent between CAs specified using TrustedUserCAKeys and
      authorized_keys.

 -- Colin Watson <cjwatson@debian.org>  Fri, 16 Apr 2010 10:27:30 +0100

openssh (1:5.4p1-2) unstable; urgency=low

  * Borrow patch from Fedora to add DNSSEC support: if glibc 2.11 is
    installed, the host key is published in an SSHFP RR secured with DNSSEC,
    and VerifyHostKeyDNS=yes, then ssh will no longer prompt for host key
    verification (closes: #572049).
  * Convert to dh(1), and use dh_installdocs --link-doc.
  * Drop lpia support, since Ubuntu no longer supports this architecture.
  * Use dh_install more effectively.
  * Add a NEWS.Debian entry about changes in smartcard support relative to
    previous unofficial builds (closes: #231472).

 -- Colin Watson <cjwatson@debian.org>  Sat, 10 Apr 2010 01:08:59 +0100

openssh (1:5.4p1-1) unstable; urgency=low

  * New upstream release (LP: #535029).
    - After a transition period of about 10 years, this release disables SSH
      protocol 1 by default.  Clients and servers that need to use the
      legacy protocol must explicitly enable it in ssh_config / sshd_config
      or on the command-line.
    - Remove the libsectok/OpenSC-based smartcard code and add support for
      PKCS#11 tokens.  This support is enabled by default in the Debian
      packaging, since it now doesn't involve additional library
      dependencies (closes: #231472, LP: #16918).
    - Add support for certificate authentication of users and hosts using a
      new, minimal OpenSSH certificate format (closes: #482806).
    - Added a 'netcat mode' to ssh(1): "ssh -W host:port ...".
    - Add the ability to revoke keys in sshd(8) and ssh(1).  (For the Debian
      package, this overlaps with the key blacklisting facility added in
      openssh 1:4.7p1-9, but with different file formats and slightly
      different scopes; for the moment, I've roughly merged the two.)
    - Various multiplexing improvements, including support for requesting
      port-forwardings via the multiplex protocol (closes: #360151).
    - Allow setting an explicit umask on the sftp-server(8) commandline to
      override whatever default the user has (closes: #496843).
    - Many sftp client improvements, including tab-completion, more options,
      and recursive transfer support for get/put (LP: #33378).  The old
      mget/mput commands never worked properly and have been removed
      (closes: #270399, #428082).
    - Do not prompt for a passphrase if we fail to open a keyfile, and log
      the reason why the open failed to debug (closes: #431538).
    - Prevent sftp from crashing when given a "-" without a command.  Also,
      allow whitespace to follow a "-" (closes: #531561).

  * Fix 'debian/rules quilt-setup' to avoid writing .orig files if some
    patches apply with offsets.
  * Include debian/ssh-askpass-gnome.png in the Debian tarball now that
    we're using a source format that permits this, rather than messing
    around with uudecode.
  * Drop compatibility with the old gssapi mechanism used in ssh-krb5 <<
    3.8.1p1-1.  Simon Wilkinson refused this patch since the old gssapi
    mechanism was removed due to a serious security hole, and since these
    versions of ssh-krb5 are no longer security-supported by Debian I don't
    think there's any point keeping client compatibility for them.
  * Fix substitution of ETC_PAM_D_SSH, following the rename in 1:4.7p1-4.
  * Hardcode the location of xauth to /usr/bin/xauth rather than
    /usr/bin/X11/xauth (thanks, Aron Griffis; closes: #575725, LP: #8440).
    xauth no longer depends on x11-common, so we're no longer guaranteed to
    have the /usr/bin/X11 symlink available.  I was taking advantage of the
    /usr/bin/X11 symlink to smooth X's move to /usr/bin, but this is far
    enough in the past now that it's probably safe to just use /usr/bin.
  * Remove SSHD_OOM_ADJUST configuration.  sshd now unconditionally makes
    itself non-OOM-killable, and doesn't require configuration to avoid log
    spam in virtualisation containers (closes: #555625).
  * Drop Debian-specific removal of OpenSSL version check.  Upstream ignores
    the two patchlevel nybbles now, which is sufficient to address the
    original reason this change was introduced, and it appears that any
    change in the major/minor/fix nybbles would involve a new libssl package
    name.  (We'd still lose if the status nybble were ever changed, but that
    would mean somebody had packaged a development/beta version rather than
    a proper release, which doesn't appear to be normal practice.)
  * Drop most of our "LogLevel SILENT" (-qq) patch.  This was originally
    introduced to match the behaviour of non-free SSH, in which -q does not
    suppress fatal errors, but matching the behaviour of OpenSSH upstream is
    much more important nowadays.  We no longer document that -q does not
    suppress fatal errors (closes: #280609).  Migrate "LogLevel SILENT" to
    "LogLevel QUIET" in sshd_config on upgrade.
  * Policy version 3.8.4:
    - Add a Homepage field.

 -- Colin Watson <cjwatson@debian.org>  Tue, 06 Apr 2010 22:38:31 +0100

openssh (1:5.3p1-3) unstable; urgency=low

  * Convert to source format 3.0 (quilt).
  * Update README.source to match, and add a 'quilt-setup' target to
    debian/rules for the benefit of those checking out the package from
    revision control.
  * All patches are now maintained separately and tagged according to DEP-3.
  * Add GSSAPIStoreCredentialsOnRekey to 'sshd -T' configuration dump.
  * Remove documentation of building for Debian 3.0 in README.Debian.
    Support for this was removed in 1:4.7p1-2.
  * Remove obsolete header from README.Debian dating from when people
    expected non-free SSH.
  * Update copyright years for GSSAPI patch.

 -- Colin Watson <cjwatson@debian.org>  Sun, 28 Feb 2010 01:35:53 +0000

openssh (1:5.3p1-2) unstable; urgency=low

  * Link with -Wl,--as-needed (closes: #560155).
  * Install upstream sshd_config as an example (closes: #415008).
  * Use dh_lintian.
  * Honour DEB_BUILD_OPTIONS=nocheck.

 -- Colin Watson <cjwatson@debian.org>  Mon, 22 Feb 2010 12:43:24 +0000

openssh (1:5.3p1-1) unstable; urgency=low

  * New upstream release.
  * Update to GSSAPI patch from
    http://www.sxw.org.uk/computing/patches/openssh-5.3p1-gsskex-all-20100124.patch.
  * Backport from upstream:
    - Do not fall back to adding keys without constraints (ssh-add -c / -t
      ...) when the agent refuses the constrained add request. This was a
      useful migration measure back in 2002 when constraints were new, but
      just adds risk now (LP: #209447).
  * Drop change from 1:3.8p1-3 to avoid setresuid() and setresgid() system
    calls.  This only applied to Linux 2.2, which it's no longer feasible to
    run anyway (see 1:5.2p1-2 changelog).

 -- Colin Watson <cjwatson@debian.org>  Tue, 26 Jan 2010 11:55:29 +0000

openssh (1:5.2p1-2) unstable; urgency=low

  [ Colin Watson ]
  * Backport from upstream:
    - After sshd receives a SIGHUP, ignore subsequent HUPs while sshd
      re-execs itself.  Prevents two HUPs in quick succession from resulting
      in sshd dying (LP: #497781).
    - Output a debug if we can't open an existing keyfile (LP: #505301).
  * Use host compiler for ssh-askpass-gnome when cross-compiling.
  * Don't run tests when cross-compiling.
  * Drop change from 1:3.6.1p2-5 to disable cmsg_type check for file
    descriptor passing when running on Linux 2.0.  The previous stable
    release of Debian dropped support for Linux 2.4, let alone 2.0, so this
    very likely has no remaining users depending on it.

  [ Kees Cook ]
  * Implement DebianBanner server configuration flag that can be set to "no"
    to allow sshd to run without the Debian-specific extra version in the
    initial protocol handshake (closes: #562048).

 -- Colin Watson <cjwatson@debian.org>  Sat, 16 Jan 2010 01:28:58 +0000

openssh (1:5.2p1-1) unstable; urgency=low

  * New upstream release (closes: #536182). Yes, I know 5.3p1 has been out
    for a while, but there's no GSSAPI patch available for it yet.
    - Change the default cipher order to prefer the AES CTR modes and the
      revised "arcfour256" mode to CBC mode ciphers that are susceptible to
      CPNI-957037 "Plaintext Recovery Attack Against SSH".
    - Add countermeasures to mitigate CPNI-957037-style attacks against the
      SSH protocol's use of CBC-mode ciphers. Upon detection of an invalid
      packet length or Message Authentication Code, ssh/sshd will continue
      reading up to the maximum supported packet length rather than
      immediately terminating the connection. This eliminates most of the
      known differences in behaviour that leaked information about the
      plaintext of injected data which formed the basis of this attack
      (closes: #506115, LP: #379329).
    - ForceCommand directive now accepts commandline arguments for the
      internal-sftp server (closes: #524423, LP: #362511).
    - Add AllowAgentForwarding to available Match keywords list (closes:
      #540623).
    - Make ssh(1) send the correct channel number for
      SSH2_MSG_CHANNEL_SUCCESS and SSH2_MSG_CHANNEL_FAILURE messages to
      avoid triggering 'Non-public channel' error messages on sshd(8) in
      openssh-5.1.
    - Avoid printing 'Non-public channel' warnings in sshd(8), since the
      ssh(1) has sent incorrect channel numbers since ~2004 (this reverts a
      behaviour introduced in openssh-5.1; closes: #496017).
    - Disable nonfunctional ssh(1) ~C escape handler in multiplex slave
      connections (closes: #507541).
    - Fix "whitepsace" typo in ssh_config(5) (closes: #514313, LP: #303835).
  * Update to GSSAPI patch from
    http://www.sxw.org.uk/computing/patches/openssh-5.2p1-gsskex-all-20090726.patch,
    including cascading credentials support (LP: #416958).
  * Use x11.pc when compiling/linking gnome-ssh-askpass2 (closes: #555951).
  * Moved to bzr.debian.org; add Vcs-Bzr and Vcs-Browser control fields.
  * Add debian/README.source with instructions on bzr handling.
  * Make ChrootDirectory work with SELinux (thanks, Russell Coker; closes:
    #556644).
  * Initialise sc to NULL in ssh_selinux_getctxbyname (thanks, Václav Ovsík;
    closes: #498684).
  * Don't duplicate backslashes when displaying server banner (thanks,
    Michał Górny; closes: #505378, LP: #425346).
  * Use hardening-includes for hardening logic (thanks, Kees Cook; closes:
    #561887).
  * Update OpenSSH FAQ to revision 1.110.
  * Remove ssh/new_config, only needed for direct upgrades from potato which
    are no longer particularly feasible anyway (closes: #420682).
  * Cope with insserv reordering of init script links.
  * Remove init script stop link in rc1, as killprocs handles it already.
  * Adjust short descriptions to avoid relying on previous experience with
    rsh, based on suggestions from Reuben Thomas (closes: #512198).
  * Remove manual page references to login.conf, which aren't applicable on
    non-BSD systems (closes: #154434).
  * Remove/adjust manual page references to BSD-specific /etc/rc (closes:
    #513417).
  * Refer to sshd_config(5) rather than sshd(8) in postinst-written
    /etc/ssh/sshd_config, and add UsePAM commentary from upstream-shipped
    configuration file (closes: #415008, although unfortunately this will
    only be conveniently visible on new installations).
  * Include URL to OpenBSD's ssl(8) in ssh(1), since I don't see a better
    source for the same information among Debian's manual pages (closes:
    #530692, LP: #456660).

 -- Colin Watson <cjwatson@debian.org>  Mon, 04 Jan 2010 13:23:35 +0000

openssh (1:5.1p1-8) unstable; urgency=low

  * Build with just -fPIC on mips/mipsel, not -fPIE as well (thanks, LIU Qi;
    closes: #538313).
  * Build-depend on libselinux1-dev on sh4 too (thanks, Nobuhiro Iwamatsu;
    closes: #547103).
  * Fix grammar in if-up script (closes: #549128).
  * Pass $SSHD_OPTS when checking configuration too (thanks, "sobtwmxt";
    closes: #548662).

 -- Colin Watson <cjwatson@debian.org>  Mon, 05 Oct 2009 13:30:49 +0100

openssh (1:5.1p1-7) unstable; urgency=low

  * Update config.guess and config.sub from autotools-dev 20090611.1
    (closes: #538301).
  * Set umask to 022 in the init script as well as postinsts (closes:
    #539030).
  * Add ${misc:Depends} to keep Lintian happy.
  * Use 'which' rather than 'type' in maintainer scripts.
  * Upgrade to debhelper v7.

 -- Colin Watson <cjwatson@debian.org>  Fri, 31 Jul 2009 16:28:10 +0100

openssh (1:5.1p1-6) unstable; urgency=low

  * Open /proc/self/oom_adj with O_RDONLY or O_WRONLY as necessary, rather
    than O_RDWR.
  * Disable OOM adjustment for vserver/OpenVZ (thanks, Karl Chen; closes:
    #511771).
  * Add ufw integration (thanks, Didier Roche; see
    https://wiki.ubuntu.com/UbuntuFirewall#Integrating%20UFW%20with%20Packages;
    LP: #261884).
  * Add a comment above PermitRootLogin in sshd_config pointing to
    README.Debian.
  * Check if delgroup is present in openssh-client.postrm (closes: #530501).
  * Build with -fPIC on mips/mipsel (thanks, Luk Claes; closes: #531942).
  * Remove /var/run/sshd from openssh-server package; it will be created at
    run-time before starting the server.
  * Use invoke-rc.d in openssh-server's if-up script.

 -- Colin Watson <cjwatson@debian.org>  Fri, 05 Jun 2009 11:56:03 +0100

openssh (1:5.1p1-5) unstable; urgency=low

  * Backport from upstream CVS (Markus Friedl):
    - packet_disconnect() on padding error, too. Should reduce the success
      probability for the CPNI-957037 Plaintext Recovery Attack to 2^-18.
  * Check that /var/run/sshd.pid exists and that the process ID listed there
    corresponds to sshd before running '/etc/init.d/ssh reload' from if-up
    script; SIGHUP is racy if called at boot before sshd has a chance to
    install its signal handler, but fortunately the pid file is written
    after that which lets us avoid the race (closes: #502444).
  * While the above is a valuable sanity-check, it turns out that it doesn't
    really fix the bug (thanks to Kevin Price for testing), so for the
    meantime we'll just use '/etc/init.d/ssh restart', even though it is
    unfortunately heavyweight.

 -- Colin Watson <cjwatson@debian.org>  Wed, 14 Jan 2009 00:34:08 +0000

openssh (1:5.1p1-4) unstable; urgency=low

  * ssh-copy-id: Strip trailing colons from hostname (closes: #226172,
    LP: #249706; thanks to Karl Goetz for nudging this along; forwarded
    upstream as https://bugzilla.mindrot.org/show_bug.cgi?id=1530).
  * Backport from upstream CVS (Markus Friedl):
    - Only send eow and no-more-sessions requests to openssh 5 and newer;
      fixes interop problems with broken ssh v2 implementations (closes:
      #495917).
  * Fix double-free when failing to parse a forwarding specification given
    using ~C (closes: #505330; forwarded upstream as
    https://bugzilla.mindrot.org/show_bug.cgi?id=1539).

 -- Colin Watson <cjwatson@debian.org>  Sun, 23 Nov 2008 14:46:10 +0000

openssh (1:5.1p1-3) unstable; urgency=low

  * Remove unnecessary ssh-vulnkey output in non-verbose mode when no
    compromised or unknown keys were found (closes: #496495).
  * Configure with --disable-strip; dh_strip will deal with stripping
    binaries and will honour DEB_BUILD_OPTIONS (thanks, Bernhard R. Link;
    closes: #498681).
  * Fix handling of zero-length server banners (thanks, Tomas Mraz; closes:
    #497026).

 -- Colin Watson <cjwatson@debian.org>  Tue, 30 Sep 2008 23:09:58 +0100

openssh (1:5.1p1-2) unstable; urgency=low

  * Look for $SHELL on the path when executing ProxyCommands or
    LocalCommands (closes: #492728).

 -- Colin Watson <cjwatson@debian.org>  Tue, 29 Jul 2008 15:31:25 +0100

openssh (1:5.1p1-1) unstable; urgency=low

  * New upstream release (closes: #474301). Important changes not previously
    backported to 4.7p1:
    - 4.9/4.9p1 (http://www.openssh.com/txt/release-4.9):
      + Added chroot(2) support for sshd(8), controlled by a new option
        "ChrootDirectory" (closes: #139047, LP: #24777).
      + Linked sftp-server(8) into sshd(8). The internal sftp server is used
        when the command "internal-sftp" is specified in a Subsystem or
        ForceCommand declaration. When used with ChrootDirectory, the
        internal sftp server requires no special configuration of files
        inside the chroot environment.
      + Added a protocol extension method "posix-rename@openssh.com" for
        sftp-server(8) to perform POSIX atomic rename() operations; sftp(1)
        prefers this if available (closes: #308561).
      + Removed the fixed limit of 100 file handles in sftp-server(8).
      + ssh(8) will now skip generation of SSH protocol 1 ephemeral server
        keys when in inetd mode and protocol 2 connections are negotiated.
        This speeds up protocol 2 connections to inetd-mode servers that
        also allow Protocol 1.
      + Accept the PermitRootLogin directive in a sshd_config(5) Match
        block. Allows for, e.g. permitting root only from the local network.
      + Reworked sftp(1) argument splitting and escaping to be more
        internally consistent (i.e. between sftp commands) and more
        consistent with sh(1). Please note that this will change the
        interpretation of some quoted strings, especially those with
        embedded backslash escape sequences.
      + Support "Banner=none" in sshd_config(5) to disable sending of a
        pre-login banner (e.g. in a Match block).
      + ssh(1) ProxyCommands are now executed with $SHELL rather than
        /bin/sh.
      + ssh(1)'s ConnectTimeout option is now applied to both the TCP
        connection and the SSH banner exchange (previously it just covered
        the TCP connection). This allows callers of ssh(1) to better detect
        and deal with stuck servers that accept a TCP connection but don't
        progress the protocol, and also makes ConnectTimeout useful for
        connections via a ProxyCommand.
      + scp(1) incorrectly reported "stalled" on slow copies (closes:
        #140828).
      + scp(1) date underflow for timestamps before epoch.
      + ssh(1) used the obsolete SIG DNS RRtype for host keys in DNS,
        instead of the current standard RRSIG.
      + Correctly drain ACKs when a sftp(1) upload write fails midway,
        avoids a fatal() exit from what should be a recoverable condition.
      + Fixed ssh-keygen(1) selective host key hashing (i.e. "ssh-keygen -HF
        hostname") to not include any IP address in the data to be hashed.
      + Make ssh(1) skip listening on the IPv6 wildcard address when a
        binding address of 0.0.0.0 is used against an old SSH server that
        does not support the RFC4254 syntax for wildcard bind addresses.
      + Enable IPV6_V6ONLY socket option on sshd(8) listen socket, as is
        already done for X11/TCP forwarding sockets (closes: #439661).
      + Fix FD leak that could hang a ssh(1) connection multiplexing master.
      + Make ssh(1) -q option documentation consistent with reality.
      + Fixed sshd(8) PAM support not calling pam_session_close(), or
        failing to call it with root privileges (closes: #372680).
      + Fix activation of OpenSSL engine support when requested in configure
        (LP: #119295).
      + Cache SELinux status earlier so we know if it's enabled after a
        chroot (LP: #237557).
    - 5.1/5.1p1 (http://www.openssh.com/txt/release-5.1):
      + Introduce experimental SSH Fingerprint ASCII Visualisation to ssh(1)
        and ssh-keygen(1). Visual fingerprint display is controlled by a new
        ssh_config(5) option "VisualHostKey". The intent is to render SSH
        host keys in a visual form that is amenable to easy recall and
        rejection of changed host keys.
      + sshd_config(5) now supports CIDR address/masklen matching in "Match
        address" blocks, with a fallback to classic wildcard matching.
      + sshd(8) now supports CIDR matching in ~/.ssh/authorized_keys
        from="..." restrictions, also with a fallback to classic wildcard
        matching.
      + Added an extended test mode (-T) to sshd(8) to request that it write
        its effective configuration to stdout and exit. Extended test mode
        also supports the specification of connection parameters (username,
        source address and hostname) to test the application of
        sshd_config(5) Match rules.
      + ssh(1) now prints the number of bytes transferred and the overall
        connection throughput for SSH protocol 2 sessions when in verbose
        mode (previously these statistics were displayed for protocol 1
        connections only).
      + sftp-server(8) now supports extension methods statvfs@openssh.com
        and fstatvfs@openssh.com that implement statvfs(2)-like operations.
      + sftp(1) now has a "df" command to the sftp client that uses the
        statvfs@openssh.com to produce a df(1)-like display of filesystem
        space and inode utilisation (requires statvfs@openssh.com support on
        the server).
      + Added a MaxSessions option to sshd_config(5) to allow control of the
        number of multiplexed sessions supported over a single TCP
        connection. This allows increasing the number of allowed sessions
        above the previous default of 10, disabling connection multiplexing
        (MaxSessions=1) or disallowing login/shell/subsystem sessions
        entirely (MaxSessions=0).
      + Added a no-more-sessions@openssh.com global request extension that
        is sent from ssh(1) to sshd(8) when the client knows that it will
        never request another session (i.e. when session multiplexing is
        disabled). This allows a server to disallow further session requests
        and terminate the session in cases where the client has been
        hijacked.
      + ssh-keygen(1) now supports the use of the -l option in combination
        with -F to search for a host in ~/.ssh/known_hosts and display its
        fingerprint.
      + ssh-keyscan(1) now defaults to "rsa" (protocol 2) keys, instead of
        "rsa1" (LP: #129794).
      + Added an AllowAgentForwarding option to sshd_config(8) to control
        whether authentication agent forwarding is permitted. Note that this
        is a loose control, as a client may install their own unofficial
        forwarder.
      + ssh(1) and sshd(8): avoid unnecessary malloc/copy/free when
        receiving network data, resulting in a ~10% speedup.
      + ssh(1) and sshd(8) will now try additional addresses when connecting
        to a port forward destination whose DNS name resolves to more than
        one address. The previous behaviour was to try the only first
        address and give up if that failed.
      + ssh(1) and sshd(8) now support signalling that channels are
        half-closed for writing, through a channel protocol extension
        notification "eow@openssh.com". This allows propagation of closed
        file descriptors, so that commands such as "ssh -2 localhost od
        /bin/ls | true" do not send unnecessary data over the wire.
      + sshd(8): increased the default size of ssh protocol 1 ephemeral keys
        from 768 to 1024 bits.
      + When ssh(1) has been requested to fork after authentication ("ssh
        -f") with ExitOnForwardFailure enabled, delay the fork until after
        replies for any -R forwards have been seen. Allows for robust
        detection of -R forward failure when using -f.
      + "Match group" blocks in sshd_config(5) now support negation of
        groups. E.g. "Match group staff,!guests".
      + sftp(1) and sftp-server(8) now allow chmod-like operations to set
        set[ug]id/sticky bits.
      + The MaxAuthTries option is now permitted in sshd_config(5) match
        blocks.
      + Multiplexed ssh(1) sessions now support a subset of the ~ escapes
        that are available to a primary connection.
      + ssh(1) connection multiplexing will now fall back to creating a new
        connection in most error cases (closes: #352830).
      + Make ssh(1) deal more gracefully with channel requests that fail.
        Previously it would optimistically assume that requests would always
        succeed, which could cause hangs if they did not (e.g. when the
        server runs out of file descriptors).
      + ssh(1) now reports multiplexing errors via the multiplex slave's
        stderr where possible (subject to LogLevel in the mux master).
      + Fixed an UMAC alignment problem that manifested on Itanium
        platforms.
  * Remove our local version of moduli(5) now that there's one upstream.
  * Say "GTK+" rather than "GTK" in ssh-askpass-gnome's description.
  * Add lintian overrides for empty /usr/share/doc/openssh-client
    directories in openssh-server and ssh (necessary due to being symlink
    targets).
  * Merge from Ubuntu:
    - Add 'status' action to openssh-server init script, requiring lsb-base
      (>= 3.2-13) (thanks, Dustin Kirkland).
  * debconf template translations:
    - Update Korean (thanks, Sunjae Park; closes: #484821).

 -- Colin Watson <cjwatson@debian.org>  Fri, 25 Jul 2008 10:45:08 +0100

openssh (1:4.7p1-13) unstable; urgency=low

  * Add some helpful advice to the end of ssh-vulnkey's output if there are
    unknown or compromised keys (thanks, Dan Jacobson; closes: #483756).
  * Check compromised key blacklist in ssh or ssh-add, as well as in the
    server (LP: #232391). To override the blacklist check in ssh
    temporarily, use 'ssh -o UseBlacklistedKeys=yes'; there is no override
    for the blacklist check in ssh-add.
  * Add cross-references to ssh-vulnkey(1) to ssh(1), ssh-add(1),
    ssh-keygen(1), and sshd(8) (closes: #484451).
  * Change openssh-client-udeb's Installer-Menu-Item from 99900 to 99999
    (thanks, Frans Pop).
  * Drop openssh-client-udeb isinstallable hack, as main-menu (>= 1.26) now
    takes care of that (thanks, Frans Pop; closes: #484404).
  * Update DEB_BUILD_OPTIONS parsing code from policy 3.8.0.
  * Add documentation on removing openssh-blacklist locally (see #484269).
  * Clarify documentation of SSHD_OOM_ADJUST, and make setting it to the
    empty string actually skip adjustment as intended (closes: #487325).
  * Remove empty /usr/share/applications directory in ssh-askpass-gnome.
  * debconf template translations:
    - Update Romanian (thanks, Cătălin Feștilă; closes: #485415).

 -- Colin Watson <cjwatson@debian.org>  Mon, 21 Jul 2008 12:18:28 +0100

openssh (1:4.7p1-12) unstable; urgency=low

  * Fill in CVE identifier for ssh-vulnkey bug fixed in 1:4.7p1-10.
  * Refactor rejection of blacklisted user keys into a single
    reject_blacklisted_key function in auth.c (thanks, Dmitry V. Levin).
  * Fix memory leak of blacklisted host keys (thanks, Dmitry V. Levin).
  * debconf template translations:
    - Update Dutch (thanks, Bart Cornelis; closes: #483004).
    - Update Brazilian Portuguese (thanks, Eder L. Marques; closes:
      #483142).
    - Update Slovak (thanks, Ivan Masár; closes: #483517).

 -- Colin Watson <cjwatson@debian.org>  Thu, 29 May 2008 21:41:29 +0100

openssh (1:4.7p1-11) unstable; urgency=low

  * Make init script depend on $syslog, and fix some other dependency
    glitches (thanks, Petter Reinholdtsen; closes: #481018).
  * Remove 0 and 6 from Default-Stop in init script (thanks, Kel Modderman;
    closes: #481151).
  * Restore OOM killer adjustment for child processes (thanks, Vaclav Ovsik;
    closes: #480020).
  * Allow building with heimdal-dev (LP: #125805).

  * Check RSA1 keys without the need for a separate blacklist. Thanks to
    Simon Tatham for the idea.
  * Generate two keys with the PID forced to the same value and test that
    they differ, to defend against recurrences of the recent Debian OpenSSL
    vulnerability.
  * Recommend openssh-blacklist from openssh-client (closes: #481187).
  * Recommend openssh-blacklist-extra from openssh-client and
    openssh-server.
  * Make ssh-vulnkey report the file name and line number for each key
    (thanks, Heiko Schlittermann and Christopher Perry; closes: #481398).
  * Check for blacklists in /usr/share/ssh/ as well as /etc/ssh/ (see
    #481283).
  * Log IP addresses of hosts attempting to use blacklisted keys (closes:
    #481721).
  * Incorporate various ssh-vulnkey suggestions from Hugh Daniel:
    - Add -v (verbose) option, and don't print output for keys that have a
      blacklist file but that are not listed unless in verbose mode.
    - Move exit status documentation to a separate section.
    - Document key status descriptions.
    - Add key type to output.
    - Fix error output if ssh-vulnkey fails to read key files, with the
      exception of host keys unless -a was given.
    - In verbose mode, output the name of each file examined.
  * Handle leading IP addresses in ssh-vulnkey input (LP: #230497).
  * Fix various ssh-vulnkey problems pointed out by Solar Designer:
    - Fix some buffer handling inconsistencies.
    - Use xasprintf to build user key file names, avoiding truncation
      problems.
    - Drop to the user's UID when reading user keys with -a.
    - Use EUID rather than UID when run with no file names and without -a.
    - Reword "Unknown (no blacklist information)" to "Unknown (blacklist
      file not installed)".

  * Fix typo in ssh/vulnerable_host_keys message (thanks, Esko Arajärvi).
  * debconf template translations:
    - Update Finnish (thanks, Esko Arajärvi; closes: #481530).
    - Update French (thanks, Christian Perrier; closes: #481576).
    - Update Norwegian Bokmål (thanks, Bjørn Steensrud; closes: #481591).
    - Update Galician (thanks, Jacobo Tarrio; closes: #481596).
    - Update Japanese (thanks, Kenshi Muto; closes: #481621).
    - Update Czech (thanks, Miroslav Kure; closes: #481624).
    - Update German (thanks, Helge Kreutzmann; closes: #481676).
    - Update Portuguese (thanks, Ricardo Silva; closes: #481781).
    - Update Basque (thanks, Piarres Beobide; closes: #481836).
    - Update Bulgarian (thanks, Damyan Ivanov; closes: #481870).
    - Update Vietnamese (thanks, Clytie Siddall; closes: #481876).
    - Update Spanish (thanks, Javier Fernandez-Sanguino Peña; closes:
      #482341).
    - Update Turkish (thanks, Mert Dirik; closes: #482548).
    - Update Russian (thanks, Yuri Kozlov; closes: #482887).
    - Update Swedish (thanks, Martin Bagge; closes: #482464).
    - Update Italian (thanks, Luca Monducci; closes: #482808).

 -- Colin Watson <cjwatson@debian.org>  Mon, 26 May 2008 12:21:39 +0100

openssh (1:4.7p1-10) unstable; urgency=low

  * Add a FILES section to ssh-vulnkey(1) (thanks, Hugh Daniel).
  * CVE-2008-2285: ssh-vulnkey handles options in authorized_keys
    (LP: #230029), and treats # as introducing a comment even if it is
    preceded by whitespace.

 -- Colin Watson <cjwatson@debian.org>  Wed, 14 May 2008 12:35:05 +0100

openssh (1:4.7p1-9) unstable; urgency=critical

  * Fill in CVE identifier for security vulnerability fixed in 1:4.7p1-8.
  * Mitigate OpenSSL security vulnerability (CVE-2008-0166):
    - Add key blacklisting support. Keys listed in
      /etc/ssh/blacklist.TYPE-LENGTH will be rejected for authentication by
      sshd, unless "PermitBlacklistedKeys yes" is set in
      /etc/ssh/sshd_config.
    - Add a new program, ssh-vulnkey, which can be used to check keys
      against these blacklists.
    - Depend on openssh-blacklist.
    - Force dependencies on libssl0.9.8 / libcrypto0.9.8-udeb to at least
      0.9.8g-9.
    - Automatically regenerate known-compromised host keys, with a
      critical-priority debconf note. (I regret that there was no time to
      gather translations.)

 -- Colin Watson <cjwatson@debian.org>  Tue, 13 May 2008 12:33:38 +0100

openssh (1:4.7p1-8) unstable; urgency=high

  * Fill in CVE identifier for security vulnerability fixed in 1:4.7p1-5.
  * Rename KeepAlive to TCPKeepAlive in sshd_config, cleaning up from old
    configurations (LP: #211400).
  * Tweak scp's reporting of filenames in verbose mode to be a bit less
    confusing with spaces (thanks, Nicolas Valcárcel; LP: #89945).
  * Backport from 4.9p1:
    - CVE-2008-1657: Ignore ~/.ssh/rc if a sshd_config ForceCommand is
      specified.
    - Add no-user-rc authorized_keys option to disable execution of
      ~/.ssh/rc.
  * Backport from Simon Wilkinson's GSSAPI key exchange patch for 5.0p1:
    - Add code to actually implement GSSAPIStrictAcceptorCheck, which had
      somehow been omitted from a previous version of this patch (closes:
      #474246).

 -- Colin Watson <cjwatson@debian.org>  Sun, 06 Apr 2008 12:34:19 +0100

openssh (1:4.7p1-7) unstable; urgency=low

  * Ignore errors writing to oom_adj (closes: #473573).

 -- Colin Watson <cjwatson@debian.org>  Mon, 31 Mar 2008 16:24:44 +0100

openssh (1:4.7p1-6) unstable; urgency=low

  * Disable the Linux kernel's OOM-killer for the sshd parent; tweak
    SSHD_OOM_ADJUST in /etc/default/ssh to change this (closes: #341767).

 -- Colin Watson <cjwatson@debian.org>  Sun, 30 Mar 2008 21:14:12 +0100

openssh (1:4.7p1-5) unstable; urgency=low

  * Recommends: xauth rather than Suggests: xbase-clients.
  * Document in ssh(1) that '-S none' disables connection sharing
    (closes: #471437).
  * Patch from Red Hat / Fedora:
    - CVE-2008-1483: Don't use X11 forwarding port which can't be bound on
      all address families, preventing hijacking of X11 forwarding by
      unprivileged users when both IPv4 and IPv6 are configured (closes:
      #463011).
  * Use printf rather than echo -en (a bashism) in openssh-server.config and
    openssh-server.preinst.
  * debconf template translations:
    - Update Finnish (thanks, Esko Arajärvi; closes: #468563).

 -- Colin Watson <cjwatson@debian.org>  Sat, 22 Mar 2008 12:37:00 +0000

openssh (1:4.7p1-4) unstable; urgency=low

  [ Caleb Case ]
  * Fix configure detection of getseuserbyname and
    get_default_context_with_level (closes: #465614, LP: #188136).

  [ Colin Watson ]
  * Include the autogenerated debian/copyright in the source package.
  * Move /etc/pam.d/ssh to /etc/pam.d/sshd, allowing us to stop defining
    SSHD_PAM_SERVICE (closes: #255870).

 -- Colin Watson <cjwatson@debian.org>  Wed, 13 Feb 2008 18:18:52 +0000

openssh (1:4.7p1-3) unstable; urgency=low

  * Improve grammar of ssh-askpass-gnome description.
  * Backport from upstream:
    - Use the correct packet maximum sizes for remote port and agent
      forwarding. Prevents the server from killing the connection if too
      much data is queued and an excessively large packet gets sent
      (https://bugzilla.mindrot.org/show_bug.cgi?id=1360).
  * Allow passing temporary daemon parameters on the init script's command
    line, e.g. '/etc/init.d/ssh start "-o PermitRootLogin=yes"' (thanks,
    Marc Haber; closes: #458547).

 -- Colin Watson <cjwatson@debian.org>  Fri, 01 Feb 2008 21:59:59 +0000

openssh (1:4.7p1-2) unstable; urgency=low

  * Adjust many relative links in faq.html to point to
    http://www.openssh.com/ (thanks, Dan Jacobson; mentioned in #459807).
  * Pass --with-mantype=doc to configure rather than build-depending on
    groff (closes: #460121).
  * Add armel to architecture list for libselinux1-dev build-dependency
    (closes: #460136).
  * Drop source-compatibility with Debian 3.0:
    - Remove support for building with GNOME 1. This allows simplification
      of our GNOME build-dependencies (see #460136).
    - Remove hacks to support the old PAM configuration scheme.
    - Remove compatibility for building without po-debconf.
  * Build-depend on libgtk2.0-dev rather than libgnomeui-dev. As far as I
    can see, the GTK2 version of ssh-askpass-gnome has never required
    libgnomeui-dev.

 -- Colin Watson <cjwatson@debian.org>  Fri, 11 Jan 2008 00:14:10 +0000

openssh (1:4.7p1-1) unstable; urgency=low

  * New upstream release (closes: #453367).
    - CVE-2007-4752: Prevent ssh(1) from using a trusted X11 cookie if
      creation of an untrusted cookie fails; found and fixed by Jan Pechanec
      (closes: #444738).
    - sshd(8) in new installations defaults to SSH Protocol 2 only. Existing
      installations are unchanged.
    - The SSH channel window size has been increased, and both ssh(1)
      sshd(8) now send window updates more aggressively. These improves
      performance on high-BDP (Bandwidth Delay Product) networks.
    - ssh(1) and sshd(8) now preserve MAC contexts between packets, which
      saves 2 hash calls per packet and results in 12-16% speedup for
      arcfour256/hmac-md5.
    - A new MAC algorithm has been added, UMAC-64 (RFC4418) as
      "umac-64@openssh.com". UMAC-64 has been measured to be approximately
      20% faster than HMAC-MD5.
    - Failure to establish a ssh(1) TunnelForward is now treated as a fatal
      error when the ExitOnForwardFailure option is set.
    - ssh(1) returns a sensible exit status if the control master goes away
      without passing the full exit status.
    - When using a ProxyCommand in ssh(1), set the outgoing hostname with
      gethostname(2), allowing hostbased authentication to work.
    - Make scp(1) skip FIFOs rather than hanging (closes: #246774).
    - Encode non-printing characters in scp(1) filenames. These could cause
      copies to be aborted with a "protocol error".
    - Handle SIGINT in sshd(8) privilege separation child process to ensure
      that wtmp and lastlog records are correctly updated.
    - Report GSSAPI mechanism in errors, for libraries that support multiple
      mechanisms.
    - Improve documentation for ssh-add(1)'s -d option.
    - Rearrange and tidy GSSAPI code, removing server-only code being linked
      into the client.
    - Delay execution of ssh(1)'s LocalCommand until after all forwardings
      have been established.
    - In scp(1), do not truncate non-regular files.
    - Improve exit message from ControlMaster clients.
    - Prevent sftp-server(8) from reading until it runs out of buffer space,
      whereupon it would exit with a fatal error (closes: #365541).
    - pam_end() was not being called if authentication failed
      (closes: #405041).
    - Manual page datestamps updated (closes: #433181).
  * Install the OpenSSH FAQ in /usr/share/doc/openssh-client.
    - Includes documentation on copying files with colons using scp
      (closes: #303453).
  * Create /var/run/sshd on start even if /etc/ssh/sshd_not_to_be_run exists
    (closes: #453285).
  * Fix "overriden" typo in ssh(1) (thanks, A. Costa; closes: #390699).
  * Refactor debian/rules configure and make invocations to make development
    easier.
  * Remove the hideously old /etc/ssh/primes on upgrade (closes: #123013).
  * Update moduli(5) to revision 1.11 from OpenBSD CVS.
  * Document the non-default options we set as standard in ssh_config(5) and
    sshd_config(5) (closes: #327886, #345628).
  * Recode LICENCE to UTF-8 when concatenating it to debian/copyright.
  * Override desktop-file-but-no-dh_desktop-call lintian warning; the
    .desktop file is intentionally not installed (see 1:3.8.1p1-10).
  * Update copyright dates for Kerberos patch in debian/copyright.head.
  * Policy version 3.7.3: no changes required.

 -- Colin Watson <cjwatson@debian.org>  Mon, 24 Dec 2007 16:43:02 +0000

openssh (1:4.6p1-7) unstable; urgency=low

  * Don't build PIE executables on m68k (closes: #451192).
  * Use autotools-dev's recommended configure --build and --host options.
  * Adjust README.Debian to suggest mailing debian-ssh@lists.debian.org
    rather than Matthew.
  * Check whether deluser exists in postrm (closes: #454085).

 -- Colin Watson <cjwatson@debian.org>  Mon, 03 Dec 2007 11:11:02 +0000

openssh (1:4.6p1-6) unstable; urgency=low

  * Remove blank line between head comment and first template in
    debian/openssh-server.templates.master; apparently it confuses some
    versions of debconf.
  * Install authorized_keys(5) as a symlink to sshd(8) (thanks, Tomas
    Pospisek; closes: #441817).
  * Discard error output from dpkg-query in preinsts, in case the ssh
    metapackage is not installed.
  * Fix sshd/inittab advice in README.Debian to account for rc.d movement
    (closes: #450632).
  * Suppress error from debian/rules if lsb-release is not installed.
  * Don't ignore errors from 'make -C contrib clean'.
  * Adjust categories in ssh-askpass-gnome.desktop to comply with the
    Desktop Menu Specification.
  * debconf template translations:
    - Add Slovak (thanks, Ivan Masár; closes: #441690).
    - Update Brazilian Portuguese (thanks, Eder L. Marques;
      closes: #447145).

 -- Colin Watson <cjwatson@debian.org>  Mon, 12 Nov 2007 11:47:28 +0000

openssh (1:4.6p1-5) unstable; urgency=low

  * Identify ssh as a metapackage rather than a transitional package. It's
    still useful as a quick way to install both the client and the server.
  * ssh-copy-id now checks the exit status of ssh-add -L (thanks, Adeodato
    Simó; closes: #221675).
  * ssh-copy-id no longer prints the output of expr (thanks, Peter
    Eisentraut; closes: #291534).
  * ssh-copy-id defaults to ~/.ssh/id_rsa.pub rather than
    ~/.ssh/identity.pub, in line with ssh-keygen (thanks, Greg Norris;
    closes: #234627).
  * Build-depend on libselinux1-dev on lpia.
  * openssh-client Suggests: keychain.
  * debconf template translations:
    - Update Catalan (thanks, Jordà Polo; closes: #431970).

 -- Colin Watson <cjwatson@debian.org>  Mon, 30 Jul 2007 09:34:38 +0100

openssh (1:4.6p1-4) unstable; urgency=low

  * Don't build PIE executables on hppa, as they crash.

 -- Colin Watson <cjwatson@debian.org>  Thu, 05 Jul 2007 11:06:54 +0100

openssh (1:4.6p1-3) unstable; urgency=low

  * Only build PIE executables on Linux and NetBSD (closes: #430455).
  * Fix broken switch fallthrough when SELinux is running in permissive mode
    (closes: #430838).
  * Document that HashKnownHosts may break tab-completion (closes: #430154).

 -- Colin Watson <cjwatson@debian.org>  Fri, 29 Jun 2007 07:15:38 +0100

openssh (1:4.6p1-2) unstable; urgency=low

  * Fix ordering of SYSLOG_LEVEL_QUIET and SYSLOG_LEVEL_FATAL.
  * Clarify that 'ssh -q -q' still prints errors caused by bad arguments
    (i.e. before the logging system is initialised).
  * Suppress "Connection to <host> closed" and "Connection to master closed"
    messages at loglevel SILENT (thanks, Jaap Eldering; closes: #409788).
  * Suppress "Pseudo-terminal will not be allocated because stdin is not a
    terminal" message at loglevels QUIET and SILENT (closes: #366814).
  * Document the SILENT loglevel in sftp-server(8), ssh_config(5), and
    sshd_config(5).
  * Add try-restart action to init script.
  * Add /etc/network/if-up.d/openssh-server to restart sshd when new
    interfaces appear (LP: #103436).
  * Backport from upstream:
    - Move C/R -> kbdint special case to after the defaults have been
      loaded, which makes ChallengeResponse default to yes again. This was
      broken by the Match changes and not fixed properly subsequently
      (closes: #428968).
    - Silence spurious error messages from hang-on-exit fix
      (http://bugzilla.mindrot.org/show_bug.cgi?id=1306, closes: #429531).

 -- Colin Watson <cjwatson@debian.org>  Wed, 20 Jun 2007 11:52:44 +0100

openssh (1:4.6p1-1) unstable; urgency=low

  * New upstream release (closes: #395507, #397961, #420035). Important
    changes not previously backported to 4.3p2:
    - 4.4/4.4p1 (http://www.openssh.com/txt/release-4.4):
      + On portable OpenSSH, fix a GSSAPI authentication abort that could be
        used to determine the validity of usernames on some platforms.
      + Implemented conditional configuration in sshd_config(5) using the
        "Match" directive. This allows some configuration options to be
        selectively overridden if specific criteria (based on user, group,
        hostname and/or address) are met. So far a useful subset of
        post-authentication options are supported and more are expected to
        be added in future releases.
      + Add support for Diffie-Hellman group exchange key agreement with a
        final hash of SHA256.
      + Added a "ForceCommand" directive to sshd_config(5). Similar to the
        command="..." option accepted in ~/.ssh/authorized_keys, this forces
        the execution of the specified command regardless of what the user
        requested. This is very useful in conjunction with the new "Match"
        option.
      + Add a "PermitOpen" directive to sshd_config(5). This mirrors the
        permitopen="..." authorized_keys option, allowing fine-grained
        control over the port-forwardings that a user is allowed to
        establish.
      + Add optional logging of transactions to sftp-server(8).
      + ssh(1) will now record port numbers for hosts stored in
        ~/.ssh/known_hosts when a non-standard port has been requested
        (closes: #50612).
      + Add an "ExitOnForwardFailure" option to cause ssh(1) to exit (with a
